#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ListboxConstants.au3>
#include <File.au3>

Opt( "GUIOnEventMode", 1 )
Opt( "MustDeclareVars", 1 )

Global Const $iBorderWidth     =  4
Global Const $iTitleBarHeight  = 30
Global Const $iMenuBarHeight   = 20
Global Const $iStatusBarHeight = 28
Global Const $iStatusBarRows   =  1

Global $iWidth  = 490, $iHeight = 125

Global $iGuiWidth  = $iWidth
Global $iGuiHeight = $iHeight + $iMenuBarHeight + $iStatusBarRows * $iStatusBarHeight

; Menu system
Global $hMenu, $iMenuId, $hExamplesMenu, $hContextMenu, $hToolsMenu
Global Enum $idExamples11 = 1000, $idExamples21, $idExamples33, $idModels, $idUnused, $idTemplates
Global Enum $idConInfo = 1100, $idConSelect
Global Enum $idTools01 = 1200, $idTools02, $idTools03, $idTools04, $idTools05, $idTools06
Global Enum $idLinks = 1300

; Child window and controls to show example list and launch examples
Global $hExamples, $hExampleList, $idExampleList, $sExample, $iExample = 0, $aExList[1], $nExamples, $sExPath, $sLastTitle = ""
Global $idButNext, $idButPlay, $idButPrev, $idButClose, $idChkClose, $fCloseLast = True, $idExLaunch

; Child window and controls to show context info
Global $hConInfo, $idGroup1, $idGroup2, $idLabel1, $idLabel2, $idLabel3, $idLabel4, $idLabel5, $idLabel6, $idLabel7

; Child window and controls to select context
Global $hConSelect, $fConSelectErr = False, $aRadio[8], $iRadio, $idButTst, $idButOgl, $idButSav, $aContextInfo[3]

; Tools menu
Global $aTools[6] = [ _
	"List of functions.au3", _
	"OpenGL extensions.au3", _
	"WGL extensions - ARB.au3", _
	"WGL extensions - EXT.au3", _
	"", _
	"Model viewer.au3" ]

; Links menu
Global $idxLinks = 3

Global $hLastWin, $iLastMenu

; Statusbar
Global $idStatusBar1, $idStatusBar2

Global $hGui, $hOpenGL, $hDC, $hRC, $aAccelKeys[1][2], $bFocus = True

#include "Includes\Utilities.au3"
#include "Includes\Links\ShellFavoritesMenu.au3"

MainFunc()

While 1
	Sleep(10)
WEnd

Func MainFunc()
	If Not InitGUIwindow() Then GUI_EVENT_CLOSE()
EndFunc

Func InitGUIwindow()

	;$hGui = GUICreate( ScriptName(), $iGuiWidth, $iGuiHeight, 50, 200 ) ; _WinAPI_GetSystemMetrics( 1 ) = SM_CYSCREEN
	$hGui = GUICreate( ScriptName(), $iGuiWidth, $iGuiHeight, 50, _WinAPI_GetSystemMetrics( 1 ) - $iGuiHeight - 100 )

	GUICtrlSetOnEvent( $idFavMenuMsgUnHook, "FavMenuMsgUnHook" )

	GUISetOnEvent( $GUI_EVENT_CLOSE, "GUI_EVENT_CLOSE" )

	GUIRegisterMsg( $WM_ACTIVATE, "WM_ACTIVATE" )
	GUIRegisterMsg( $WM_COMMAND,  "WM_COMMAND" )

	; --- Menu system ---

	; Samples menu
	$hExamplesMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 0, "OpenGL 1.1", $idExamples11 )
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 1, "OpenGL 2.1", $idExamples21 )
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 2, "OpenGL 3.3", $idExamples33 )
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 3, "Models", $idModels )
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 4, "" )
	_GUICtrlMenu_InsertMenuItem( $hExamplesMenu, 5, "Templates", $idTemplates )

	; Context menu
	$hContextMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hContextMenu, 0, "Info", $idConInfo )
	_GUICtrlMenu_InsertMenuItem( $hContextMenu, 1, "Select", $idConSelect )

	; Tools menu
	$hToolsMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 0, "List of functions",    $idTools01 )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 1, "" )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 2, "OpenGL extensions",    $idTools02 )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 3, "WGL extensions - ARB", $idTools03 )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 4, "WGL extensions - EXT", $idTools04 )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 5, "" )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 6, "Image viewer",         $idTools05 )
	_GUICtrlMenu_InsertMenuItem( $hToolsMenu, 7, "Model viewer",         $idTools06 )
	_GUICtrlMenu_SetItemState( $hToolsMenu, $idTools05, $MFS_DISABLED, True, False )

	; Main menu
	$hMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hMenu, 0, "Samples", 0, $hExamplesMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 1, "Context", 0, $hContextMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 2, "Tools",   0, $hToolsMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 3, "Links", $idLinks )

	; Set window menu
	_GUICtrlMenu_SetMenu( $hGui, $hMenu )

	; Set menu item states
	_GUICtrlMenu_SetItemState( $hExamplesMenu, 0, $MFS_CHECKED )
	;_GUICtrlMenu_SetItemState( $hExamplesMenu, 1, $MFS_DISABLED )
	;_GUICtrlMenu_SetItemState( $hExamplesMenu, 2, $MFS_DISABLED )
	$iLastMenu = $idExamples11

	; --- Statusbar ---

	; Use label as statusbar
	$idStatusBar1 = GUICtrlCreateLabel( "", 0, $iHeight + 1, $iWidth + 2, $iStatusBarHeight, $SS_ETCHEDFRAME )
	$idStatusBar2 = GUICtrlCreateLabel( "No rendering context", 5, $iHeight + 1 + 6, $iWidth - 10, $iStatusBarHeight - 10 )

	; --- Child windows ---

	CreateExamplesListWindow()
	CreateContextInfoWindow()
	CreateContextSelectWindow()
	$hLastWin = $hExamples
	GUISwitch( $hGui )

	; Show GUI
	$sExPath = "Samples\OpenGL 1.1"
	GetExampleList( $sExPath )
	GUISetState()

	GetRenderingContext()

	Return 1

EndFunc

Func ExLauncherWindow()
	Local $aInf = GetMenuInfo( $iLastMenu )
	_GUICtrlMenu_SetItemState( $aInf[0], $aInf[1], $MFS_CHECKED, False )
	Switch $iMenuId
		Case $idExamples11
			If $iLastMenu <> $idExamples11 Then
				If $iLastMenu <> $idExamples21 And $iLastMenu <> $idExamples33 And $iLastMenu <> $idModels And $iLastMenu <> $idTemplates Then
					GUISetState( @SW_HIDE, $hLastWin )
					GUISetState( @SW_SHOW, $hExamples )
					$hLastWin = $hExamples
				EndIf
				GUICtrlSetData( $idExampleList, "" )
				$sExPath = "Samples\OpenGL 1.1"
				GetExampleList( $sExPath )
			EndIf
		Case $idExamples21
			If $iLastMenu <> $idExamples21 Then
				If $iLastMenu <> $idExamples11 And $iLastMenu <> $idExamples33 And $iLastMenu <> $idModels And $iLastMenu <> $idTemplates Then
					GUISetState( @SW_HIDE, $hLastWin )
					GUISetState( @SW_SHOW, $hExamples )
					$hLastWin = $hExamples
				EndIf
				GUICtrlSetData( $idExampleList, "" )
				$sExPath = "Samples\OpenGL 2.1"
				GetExampleList( $sExPath )
			EndIf
		Case $idExamples33
			If $iLastMenu <> $idExamples33 Then
				If $iLastMenu <> $idExamples11 And $iLastMenu <> $idExamples21 And $iLastMenu <> $idModels And $iLastMenu <> $idTemplates Then
					GUISetState( @SW_HIDE, $hLastWin )
					GUISetState( @SW_SHOW, $hExamples )
					$hLastWin = $hExamples
				EndIf
				GUICtrlSetData( $idExampleList, "" )
				$sExPath = "Samples\OpenGL 3.3"
				GetExampleList( $sExPath )
			EndIf
		Case $idModels
			If $iLastMenu <> $idModels Then
				If $iLastMenu <> $idExamples11 And $iLastMenu <> $idExamples21 And $iLastMenu <> $idExamples33 And $iLastMenu <> $idTemplates Then
					GUISetState( @SW_HIDE, $hLastWin )
					GUISetState( @SW_SHOW, $hExamples )
					$hLastWin = $hExamples
				EndIf
				GUICtrlSetData( $idExampleList, "" )
				$sExPath = "Samples\Models"
				GetExampleList( $sExPath )
			EndIf
		Case $idTemplates
			If $iLastMenu <> $idTemplates Then
				If $iLastMenu <> $idExamples11 And $iLastMenu <> $idExamples21 And $iLastMenu <> $idExamples33 And $iLastMenu <> $idModels Then
					GUISetState( @SW_HIDE, $hLastWin )
					GUISetState( @SW_SHOW, $hExamples )
					$hLastWin = $hExamples
				EndIf
				GUICtrlSetData( $idExampleList, "" )
				$sExPath = "Samples\Templates"
				GetExampleList( $sExPath )
			EndIf
		Case $idConInfo
			If $iLastMenu <> $idConInfo Then
				GUISetState( @SW_HIDE, $hLastWin )
				GUISetState( @SW_SHOW, $hConInfo )
				If Not $fConSelectErr Then _
					GetRenderingContext()
				$hLastWin = $hConInfo
			EndIf
		Case $idConSelect
			If $iLastMenu <> $idConSelect Then
				GUISetState( @SW_HIDE, $hLastWin )
				GUISetState( @SW_SHOW, $hConSelect )
				If $fConSelectErr Then
					GUICtrlSetState( $idButTst, $GUI_ENABLE )
				Else
					GUICtrlSetState( $idButTst, $GUI_DISABLE )
				EndIf
				GUICtrlSetState( $idButOgl, $GUI_DISABLE )
				GUICtrlSetState( $idButSav, $GUI_DISABLE )
				If Not $fConSelectErr Then _
					GetRenderingContext()
				$hLastWin = $hConSelect
			EndIf
	EndSwitch
	GUISwitch( $hGui )
	$iLastMenu = $iMenuId
	$aInf = GetMenuInfo( $iMenuId )
	_GUICtrlMenu_SetItemState( $aInf[0], $aInf[1], $MFS_CHECKED, True )
EndFunc

Func GetMenuInfo( $iMenuId )
	Local $hMenu, $iPos, $aInf[2]
	If $iMenuId <= $idTemplates Then
		$hMenu = $hExamplesMenu
		$iPos = $iMenuId - $idExamples11
	ElseIf $iMenuId <= $idConSelect Then
		$hMenu = $hContextMenu
		$iPos = $iMenuId - $idConInfo
	EndIf
	$aInf[0] = $hMenu
	$aInf[1] = $iPos
	Return $aInf
EndFunc

Func WM_ACTIVATE( $hWnd, $Msg, $wParam, $lParam )
	Switch $hWnd
		Case $hGui
			If $wParam Then
				If $hLastWin = $hExamples Then
					ControlFocus( $hExamples, "", $idExampleList )
					$bFocus = True
				EndIf
			Else
				$bFocus = False
			EndIf
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_COMMAND( $hWnd, $iMsg, $iwParam, $ilParam )
	If $hWnd = $hGui Then
		Switch _WinAPI_LoWord( $iwParam )
			Case $idExamples11, $idExamples21, $idExamples33, $idModels, $idTemplates, $idConInfo, $idConSelect
				$iMenuId = _WinAPI_LoWord( $iwParam )
				ExLauncherWindow()
			Case $idTools01, $idTools02, $idTools03, $idTools04, $idTools05, $idTools06
				ShellExecute( $aTools[_WinAPI_LoWord( $iwParam )-$idTools01], "", "Tools" )
			Case $idLinks
				Local $tRect, $aRet[2]
				$hFavMenu = _GUICtrlMenu_CreatePopup()
				$tRect = _GUICtrlMenu_GetItemRectEx( $hGui, $hMenu, $idxLinks )
				$aRet[0] = DllStructGetData( $tRect, "Left" )
				$aRet[1] = DllStructGetData( $tRect, "Bottom" )
				ShowFavoritesMenu( $hGui, $hFavMenu, $aRet[0], $aRet[1], @ScriptDir & "\zLinks" )
		EndSwitch
	ElseIf $hWnd = $hExamples Then
		Switch $ilParam
			Case $hExampleList
				Switch BitShift( $iwParam, 16 )
					Case $LBN_DBLCLK
						If $bFocus Then
							$iExample = GetExample()
							GUICtrlSendToDummy( $idExLaunch )
						EndIf
				EndSwitch
		EndSwitch
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc

Func GUI_EVENT_CLOSE()
	If $fCloseLast And $sLastTitle Then WinClose( $sLastTitle, "" )
	;GUIDelete( $hGui )
	CloseDlls( False )
	Exit
EndFunc

; --- OpenGL examples ---

Func CreateExamplesListWindow()
	$hExamples = GUICreate( "", 490, 125, 0, 0, $WS_CHILD, -1, $hGui )

	; Create list
	$idExampleList = GUICtrlCreateList( "", 10, 10, 470, 69, BitOR( $GUI_SS_DEFAULT_LIST, $LBS_NOINTEGRALHEIGHT ), $WS_EX_STATICEDGE )
	$hExampleList = ControlGetHandle( $hGui, "", $idExampleList )

	; Detect enter key
	Local $kbdEnter = GUICtrlCreateDummy()
	$aAccelKeys[0][0] = "{ENTER}"
	$aAccelKeys[0][1] = $kbdEnter
	GUICtrlSetOnEvent( $kbdEnter, "kbdEnter" )
	GUISetAccelerators( $aAccelKeys, $hGui )
	GUISwitch( $hExamples )

	; Dummy control to launch example
	$idExLaunch = GUICtrlCreateDummy( )
	GUICtrlSetOnEvent( $idExLaunch, "LaunchSample" )

	; Buttons and checkbox
	$idButNext = GUICtrlCreateButton( "Next",           10, 90, 91, 22 )
	$idButPlay = GUICtrlCreateButton( "Play",          111, 90, 91, 22 )
	$idButPrev = GUICtrlCreateButton( "Prev",          212, 90, 91, 22 )
	$idButClose = GUICtrlCreateButton( "Close",        313, 90, 91, 22 )
	$idChkClose = GUICtrlCreateCheckbox( "Close last", 415, 93, 70, 18 )
	GUICtrlSetOnEvent( $idButNext,  "NextSample"  )
	GUICtrlSetOnEvent( $idButPlay,  "PlaySample"  )
	GUICtrlSetOnEvent( $idButPrev,  "PrevSample"  )
	GUICtrlSetOnEvent( $idButClose, "CloseSample" )
	GUICtrlSetOnEvent( $idChkClose, "CloseLast"   )
	GUICtrlSetState( $idChkClose, $GUI_CHECKED )

	GUISetState( @SW_SHOW )
EndFunc

Func GetExampleList( $exPath )
	Local $aTmp = _FileListToArrayRec( $exPath, "*.au3|*-a.au3;*-b.au3;*-c.au3;*-d.au3;*-e.au3;*-f.au3|0;1;2;3;4;5;6;7;8;9;models;utilities", 0, 1, 2 )
	ReDim $aExList[$aTmp[0]]
	$nExamples = 0
	For $i = 1 To $aTmp[0]
		If StringRight( $aTmp[$i], 4 ) <> ".au3" Then ContinueLoop
		$aExList[$nExamples] = $aTmp[$i]
		$nExamples += 1
	Next
	ReDim $aExList[$nExamples]
	For $i = 0 To $nExamples - 1
		GUICtrlSetData( $idExampleList, $aExList[$i] )
	Next
	GUICtrlSetData( $idExampleList, $aExList[0] )
	$sExample = $aExList[0]
EndFunc

Func GetExample()
	$sExample = GUICtrlRead( $idExampleList )
	For $i = 0 To $nExamples - 1
		If $sExample = $aExList[$i] Then Return $i
	Next
EndFunc

Func kbdEnter()
	$iExample = GetExample()
	GUICtrlSendToDummy( $idExLaunch )
EndFunc

Func LaunchSample()
	LaunchExample()
EndFunc

Func LaunchExample( $path = "", $iContext = 0 )
	Local $file, $wd
	If $path = "" Then _
		GetRenderingContext()
	If Not $fConSelectErr Then
		$wd = @WorkingDir
		If $path = "" Then $path = $sExPath & "\" & $aExList[$iExample]
		$file = StringRight( $path, StringLen( $path ) - StringInStr( $path, "\", 0, -1 ) )
		$path = StringLeft( $path, StringInStr( $path, "\", 0, -1 ) - 1 )
		If $fCloseLast And $sLastTitle Then WinClose( $sLastTitle, "" )
		If $iContext Then
			ShellExecute( $file, $iContext, $path )
		Else
			ShellExecute( $file, "", $path )
		EndIf
		$sLastTitle = StringLeft( $file, StringInStr( $file, ".", 0, -1 ) - 1 )
		$sLastTitle = "[TITLE:" & $sLastTitle & "; CLASS:AutoIt v3 GUI]"
		ControlFocus( $hExamples, "", $idExampleList )
	EndIf
EndFunc

Func NextSample()
	$iExample = GetExample() + 1
	If $iExample = $nExamples Then $iExample = 0
	GUICtrlSetData( $idExampleList, $aExList[$iExample] )
	LaunchExample()
EndFunc

Func PlaySample()
	$iExample = GetExample()
	LaunchExample()
EndFunc

Func PrevSample()
	$iExample = GetExample() - 1
	If $iExample = -1 Then $iExample = $nExamples - 1
	GUICtrlSetData( $idExampleList, $aExList[$iExample] )
	LaunchExample()
EndFunc

Func CloseSample()
	If $sLastTitle Then WinClose( $sLastTitle, "" )
	ControlFocus( $hExamples, "", $idExampleList )
EndFunc

Func CloseLast()
	If GUICtrlRead( $idChkClose ) = $GUI_CHECKED Then
		$fCloseLast = True
	Else
		$fCloseLast = False
	EndIf
EndFunc

; --- Context info ---

Func CreateContextInfoWindow()
	$hConInfo = GUICreate( "", 490, 125, 0, 0, $WS_CHILD, -1, $hGui )

	GUICtrlCreateGroup( "Supported context",            10, 10, 230, 100 )
	$idLabel1 = GUICtrlCreateLabel( "Version: ",        20, 32, 210,  16 )
	$idLabel2 = GUICtrlCreateLabel( "Vendor: ",         20, 54, 210,  16 )
	$idLabel3 = GUICtrlCreateLabel( "Renderer: ",       20, 76, 210,  28 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	$idGroup2 = GUICtrlCreateGroup( "Current context", 250, 10, 230, 100 )
	$idLabel4 = GUICtrlCreateLabel( "Version: ",       260, 32, 210,  16 )
	$idLabel5 = GUICtrlCreateLabel( "Vendor: ",        260, 54, 210,  16 )
	$idLabel6 = GUICtrlCreateLabel( "Renderer: ",      260, 76, 210,  28 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	GUISetState( @SW_HIDE )
EndFunc

; --- Select context ---

Func CreateContextSelectWindow()
	$hConSelect = GUICreate( "", 490, 125, 0, 0, $WS_CHILD, -1, $hGui )

	GUIStartGroup()

	$aRadio[0] = GUICtrlCreateRadio( "Simple", 20, 40, 50, 18 )
	$aRadio[1] = GUICtrlCreateRadio( "Proper", 90, 40, 50, 18 )

	$aRadio[2] = GUICtrlCreateRadio( "3.3",   180, 40, 40, 18 )
	$aRadio[3] = GUICtrlCreateRadio( "3.2",   225, 40, 40, 18 )
	$aRadio[4] = GUICtrlCreateRadio( "3.1",   270, 40, 40, 18 )
	$aRadio[5] = GUICtrlCreateRadio( "3.0",   315, 40, 40, 18 )
	$aRadio[6] = GUICtrlCreateRadio( "2.1",   360, 40, 40, 18 )

	$aRadio[7] = GUICtrlCreateRadio( "1.1",   430, 40, 40, 18 )

	For $i = 0 To 7
		GUICtrlSetOnEvent( $aRadio[$i], "RadioClick" )
	Next

	GUICtrlCreateGroup( "Supported context", 10, 10, 150, 68 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	GUICtrlCreateGroup( "Proper context",  170, 10, 240, 68 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	GUICtrlCreateGroup( "Generic",         420, 10,  60, 68 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	GUICtrlCreateGroup( "",                330, 83, 150, 26 )
	GUICtrlCreateGroup( "", -99, -99, 1, 1 )

	$idButTst = GUICtrlCreateButton( "Test context",  10, 88,  97, 22 )
	$idButOgl = GUICtrlCreateButton( "Test OpenGL",  117, 88,  97, 22 )
	$idButSav = GUICtrlCreateButton( "Save context", 224, 88,  97, 22 )
	$idLabel7 = GUICtrlCreateLabel( "Test result",   335, 90, 140, 18 )
	GUICtrlSetColor( $idLabel7, 0x0000FF )
	GUICtrlSetFont( $idLabel7, 10, 800 )

	GUICtrlSetOnEvent( $idButTst, "ButtonTest" )
	GUICtrlSetOnEvent( $idButOgl, "ButtonOpenGL" )
	GUICtrlSetOnEvent( $idButSav, "ButtonSave" )

	GUISetState( @SW_HIDE )
EndFunc

Func RadioClick()
	For $i = 0 To 7
		If @GUI_CTRLID = $aRadio[$i] Then ExitLoop
	Next
	$iRadio = $i
	GUICtrlSetState( $idButTst, $GUI_ENABLE )
	GUICtrlSetState( $idButOgl, $GUI_DISABLE )
	GUICtrlSetState( $idButSav, $GUI_DISABLE )
	GUICtrlSetData( $idLabel7, "Test result" )
	GUICtrlSetColor( $idLabel7, 0x0000FF )
EndFunc

Func ButtonTest()
	Local $iStatus, $ver1 = "", $ver2 = ""

	$hOpenGL = GUICreate( "OpenGL Test" )
	GUISwitch( $hGui )

	Switch $iRadio
		Case 0
			; Simple context, highest supported version
			$iStatus = OpenGLSimpleContext( $hOpenGL, $hDC, $hRC )
		Case 1
			; Proper context, highest supported version
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, -1, -1 )
		Case 2
			; Proper context, version 3.3
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 3, 3 )
			$ver1 = "3.3"
		Case 3
			; Proper context, version 3.2
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 3, 2 )
			$ver1 = "3.2"
		Case 4
			; Proper context, version 3.1
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 3, 1 )
			$ver1 = "3.1"
		Case 5
			; Proper context, version 3.0
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 3, 0 )
			$ver1 = "3.0"
		Case 6
			; Proper context, version 2.1
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 2, 1 )
			$ver1 = "2.1"
		Case 7
			; Generic context, version 1.1
			$iStatus = OpenGLProperContext( $hOpenGL, $hDC, $hRC, 1, 1 )
			$ver1 = "1.1"
	EndSwitch

	If $iStatus = 1 Then
		$aContextInfo[0] = glGetString( $GL_VERSION )
		$aContextInfo[1] = glGetString( $GL_VENDOR )
		$aContextInfo[2] = glGetString( $GL_RENDERER )
		If $iRadio >= 2 Then $ver2 = StringLeft( $aContextInfo[0], 3 )
	EndIf

	If $iStatus = 1 And $ver1 = $ver2 Then
		; It succeeded to create the context
		GUICtrlSetData( $idLabel7, "Test succeeded" )
		GUICtrlSetColor( $idLabel7, 0x006400 )
		GUICtrlSetState( $idButSav, $GUI_ENABLE )
		GUICtrlSetState( $idButOgl, $GUI_ENABLE )
	Else
		; It failed to create the context
		GUICtrlSetData( $idLabel7, "Test failed" )
		GUICtrlSetColor( $idLabel7, 0xFF0000 )
	EndIf

	DisableOpenGL( $hOpenGL, $hDC, $hRC )
	GUIDelete( $hOpenGL )

	GUICtrlSetState( $idButTst, $GUI_DISABLE )
EndFunc

Func ButtonOpenGL()
	LaunchExample( "Samples\OpenGL 1.1\Textures\Basic\Homer Simpson.au3", $iRadio+1 )
	GUICtrlSetState( $idButOgl, $GUI_DISABLE )
EndFunc

Func ButtonSave()
	Local $sContextType = "Proper", $iMajorVersion = -1, $iMinorVersion = -1, $grpTxt = "Current context "

	Switch $iRadio
		Case 0
			; Simple context, highest supported version
			$sContextType = "Simple"
			$grpTxt &= "(simple)"
		Case 1
			; Proper context, highest supported version
			; This is the values above
			$grpTxt &= "(proper)"
		Case 2
			; Proper context, version 3.3
			$iMajorVersion = 3
			$iMinorVersion = 3
			$grpTxt &= "(proper)"
		Case 3
			; Proper context, version 3.2
			$iMajorVersion = 3
			$iMinorVersion = 2
			$grpTxt &= "(proper)"
		Case 4
			; Proper context, version 3.1
			$iMajorVersion = 3
			$iMinorVersion = 1
			$grpTxt &= "(proper)"
		Case 5
			; Proper context, version 3.0
			$iMajorVersion = 3
			$iMinorVersion = 0
			$grpTxt &= "(proper)"
		Case 6
			; Proper context, version 2.1
			$iMajorVersion = 2
			$iMinorVersion = 1
			$grpTxt &= "(proper)"
		Case 7
			; Generic context, version 1.1
			$iMajorVersion = 1
			$iMinorVersion = 1
			$grpTxt &= "(generic)"
	EndSwitch

	Local $sVerPath = GetProjectPath() & "Version.ini"

	IniWrite( $sVerPath, "OpenGL Context", "ContextType", $sContextType )
	IniWrite( $sVerPath, "OpenGL Context", "MajorVersion", $iMajorVersion )
	IniWrite( $sVerPath, "OpenGL Context", "MinorVersion", $iMinorVersion )

	GUICtrlSetData( $idGroup2, $grpTxt )
	GUICtrlSetData( $idLabel4, "Version: "  & $aContextInfo[0] )
	GUICtrlSetData( $idLabel5, "Vendor: "   & $aContextInfo[1] )
	GUICtrlSetData( $idLabel6, "Renderer: " & $aContextInfo[2] )

	GUICtrlSetState( $idButSav, $GUI_DISABLE )
	GUICtrlSetData( $idLabel7, "Test result" )
	GUICtrlSetColor( $idLabel7, 0x0000FF )

	$grpTxt &= " version " & $aContextInfo[0]
	If $iRadio = 7 Then $grpTxt &= " (not hardware accelerated)"
	GUICtrlSetData( $idStatusBar2, $grpTxt )

	$fConSelectErr = False
EndFunc

; --- Rendering context ---

Func GetRenderingContext()
	; Get supported context, simple
	; This is the default context
	Local $sVersion, $iMajor = 0, $iMinor = 0
	$hOpenGL = GUICreate( "OpenGL Test" )
	GUISwitch( $hGui )
	If OpenGLSimpleContext( $hOpenGL, $hDC, $hRC ) Then
		; Fill out supported context group
		$sVersion = glGetString( $GL_VERSION )
		GUICtrlSetData( $idLabel1, "Version: " & $sVersion )
		GUICtrlSetData( $idLabel2, "Vendor: " & glGetString( $GL_VENDOR ) )
		GUICtrlSetData( $idLabel3, "Renderer: " & glGetString( $GL_RENDERER ) )
		$sVersion = StringLeft( $sVersion, 3 )
		$iMajor = Number( StringLeft( $sVersion, 1 ) )   ; Major version supported by video card
		$iMinor = Number( StringRight( $sVersion, 1 ) )  ; Minor version supported by video card
		DisableOpenGL( $hOpenGL, $hDC, $hRC )
		GUIDelete( $hOpenGL )
	Else
		; Can't get a context. Terminate.
		DisableOpenGL( $hOpenGL, $hDC, $hRC )
		GUIDelete( $hOpenGL )
		GUI_EVENT_CLOSE()
	EndIf
	$iRadio = 0 ; Check (click) default radio button
	GUICtrlSetState( $aRadio[$iRadio], $GUI_CHECKED )

	; Disable radio buttons that not matches the OpenGL versions supported by your video card

	If $iMajor < 3 Then
		; A "Proper" context is only supported by 3.0+ versions of OpenGL
		; Disable all "Proper" radio buttons
		For $i = 1 To 7
			GUICtrlSetState( $aRadio[$i], $GUI_DISABLE )
		Next
	ElseIf $iMajor = 3 And $iMinor < 3 Then
		; Disable the radio buttons with too high minor values
		For $i = 0 To 3 - $iMinor - 1
			GUICtrlSetState( $aRadio[2+$i], $GUI_DISABLE )
		Next
	EndIf

	; Get current context in Version.ini
	; If no inifile set current context to simple context
	$hOpenGL = GUICreate( "OpenGL Test" )
	GUISwitch( $hGui )
	Local $iStatus = GetOpenGLContext( $hOpenGL, $hDC, $hRC, 1 )
	If $iStatus Then
		; Fill current context group
		Local $grpTxt = "Current context "
		Switch $iStatus - 1
			Case 0
				; Simple context
				$grpTxt &= "(simple)"
			Case 1 To 6
				; Proper context
				$grpTxt &= "(proper)"
			Case 7
				; Generic context
				$grpTxt &= "(generic)"
		EndSwitch
		GUICtrlSetData( $idGroup2, $grpTxt )
		GUICtrlSetData( $idLabel4, "Version: " & glGetString( $GL_VERSION ) )
		GUICtrlSetData( $idLabel5, "Vendor: " & glGetString( $GL_VENDOR ) )
		GUICtrlSetData( $idLabel6, "Renderer: " & glGetString( $GL_RENDERER ) )
		$grpTxt &= " version " & glGetString( $GL_VERSION )
		If $iStatus = 8 Then $grpTxt &= " (not hardware accelerated)"
		GUICtrlSetData( $idStatusBar2, $grpTxt )

		; Check (click) radio button that matches current context
		GUICtrlSetState( $aRadio[$iStatus-1], $GUI_CHECKED )
		$iRadio = $iStatus - 1
	Else
		$fConSelectErr = True
	EndIf
	DisableOpenGL( $hOpenGL, $hDC, $hRC )
	GUIDelete( $hOpenGL )
EndFunc
