
// Per-fragment Blinn-Phong shader for a single directional light source.

attribute vec3 vertexXYZ;
attribute vec3 normalXYZ;
attribute vec2 textureUV;
uniform mat4 m, v, p;
uniform mat3 m_3x3_inv_transp;
varying vec3 normal;
varying vec2 colorUV;

void main()
{
  mat4 mvp = p*v*m;
	gl_Position = mvp * vec4(vertexXYZ, 1.0);

	normal = normalize(m_3x3_inv_transp * normalXYZ);

	gl_TexCoord[0] = gl_MultiTexCoord0;
  colorUV = textureUV;
}
