attribute vec3 vertexXYZ;
attribute vec3 normalXYZ;
attribute vec2 textureUV;
uniform mat4 m, v, p;
uniform mat3 m_3x3_inv_transp;
varying vec2 colorUV;
varying vec4 color;

void main(void)
{
  mat4 mv = v*m;
  mat4 mvp = p*v*m;
	vec3 v = vec3(mv * vec4(vertexXYZ, 1.0));
  vec3 normalDirection = normalize(m_3x3_inv_transp * normalXYZ);

	gl_Position = mvp * vec4(vertexXYZ, 1.0);

	vec3 L = normalize(gl_LightSource[0].position.xyz - v); 
	vec3 E = normalize(-v);
	vec3 R = normalize(-reflect(L,normalDirection));
 	vec4 amb, spec, diff;
 
	amb = gl_FrontLightProduct[0].ambient * gl_FrontMaterial.ambient;

	diff = gl_FrontLightProduct[0].diffuse * max(dot(normalDirection,L), 0.0);

	spec = gl_FrontLightProduct[0].specular	* pow(max(dot(R,E),0.0),0.1);
 
	color = amb + diff + spec;

	gl_TexCoord[0] = gl_MultiTexCoord0;
  colorUV = textureUV;
}
