#include <ListboxConstants.au3>
#include <GuiMenu.au3>
#include <Array.au3>
#include <File.au3>
#include <Misc.au3>

#include-once

Global $bDrawLight, $bDrawTextures, $bCurrentShader, $bDrawNormals

Global $iScaleFactor = 0, $iRotXdirection = 0, $iRotYdirection = 0, $iRotZdirection = 0
Global $iTransXdirection = 0, $iTransYdirection = 0, $iTransZdirection = 0, $bTransforms = 0

; --- Menu system globals ---

Global $hMenu, $iMenuId, $bMenuCmd = False, $idMenuCmd, $hFileMenu, $hModelsMenu, $hModelsModels, $hModelsMtls, $hViewMenu, $hMaxVectorsMenu, $hOptionsMenu, $hNormalsMenu, $hShadersMenu
Global Enum $idFileOpen = 1000, $idFileReload, $idFileSave, $idFileDel
Global Enum $idModelsSamples = 1100, $idModelsSmall, $idModelsMedium, $idModelsLarge
Global Enum $idViewWire = 1200, $idViewNormals, $idMaxVectors3000, $idMaxVectorsNoLimit, $idViewTransformations
Global Enum $idCalculateNormals = 1300, $idAverageNormals, $idNoNormals
Global Enum $idBlinnPhong = 1400, $idPerpixelLight, $idTextureCoords
Global Enum $idOptionsLight = 1500, $idOptionsTextures, $idOptionsQuads, $idOptionsSave, $idOptionsSaveTransforms
Global $idxModels = 1, $idModelsLast = 0, $idModelsMtls = 1600, $idModelsMtlsMax, $iMtlFile, $sMtlFile, $sMtlFileNew, $aMtlFileList[1]
Global $bOptions, $bOptionsIni, $bOpen = 0, $bWire = 0, $bVectors = 0
; $bVectors
;   + 1: Sample models, vectors can only be shown for sample models
;   + 2: Vectors can only be shown for models with max 3000 vectors
;   + 4: Normal vectors
;   + 8: Tangent vectors
;   +16: Bitangent vectors

; Child window and controls to show models list and launch models
Global $hModels, $hModelList, $idModelList, $iModel = 0, $aModelList[1], $nModels, $sModelPath, $bModelWin = False
Global $idButNext, $idButPlay, $idButPrev, $idButClose, $idModelLaunch, $aAccelKeys[1][2]
Global $sNewModel = "Small\Art\Greek vase\greek_vase.obj"

; --- Menu system functions ---

Func CreateMenuSystem()
	; File menu
	Local $hFileBinaries = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hFileBinaries, 0, "Save", $idFileSave )
	_GUICtrlMenu_InsertMenuItem( $hFileBinaries, 1, "Del", $idFileDel )
	$hFileMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hFileMenu, 0, "Open", $idFileOpen )
	_GUICtrlMenu_InsertMenuItem( $hFileMenu, 1, "Reload", $idFileReload )
	_GUICtrlMenu_InsertMenuItem( $hFileMenu, 2, "", 0 )
	_GUICtrlMenu_InsertMenuItem( $hFileMenu, 3, "Binaries", 0, $hFileBinaries )

	; Models menu
	$hModelsModels = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hModelsModels, 0, "Small",  $idModelsSmall )
	_GUICtrlMenu_InsertMenuItem( $hModelsModels, 1, "Medium", $idModelsMedium )
	_GUICtrlMenu_InsertMenuItem( $hModelsModels, 2, "Large",  $idModelsLarge )
	_GUICtrlMenu_SetItemState(   $hModelsModels, $idModelsSmall,  $MFS_CHECKED, True,  False )
	_GUICtrlMenu_SetItemState(   $hModelsModels, $idModelsMedium, $MFS_CHECKED, False, False )
	_GUICtrlMenu_SetItemState(   $hModelsModels, $idModelsLarge,  $MFS_CHECKED, False, False )
	$hModelsMtls = _GUICtrlMenu_CreateMenu()
	$hModelsMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hModelsMenu, 0, "Samples", $idModelsSamples )
	_GUICtrlMenu_InsertMenuItem( $hModelsMenu, 1, "Models", 0, $hModelsModels )
	_GUICtrlMenu_SetItemState(   $hModelsMenu, $idModelsSamples,$MFS_CHECKED, False, False )
	_GUICtrlMenu_SetItemState(   $hModelsMenu, 1,               $MFS_CHECKED, True,  True  )
	_GUICtrlMenu_InsertMenuItem( $hModelsMenu, 2, "", 0 )
	_GUICtrlMenu_InsertMenuItem( $hModelsMenu, 3, "Materials", 0, $hModelsMtls )

	; View menu
	$hViewMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hViewMenu, 0, "Wireframe", $idViewWire )
	If $bOpenGL21 Then
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 1, "", 0 )
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 2, "Transformations", $idViewTransformations )
	Else
		; Vectors menu
		$bVectors += 2
		$hMaxVectorsMenu = _GUICtrlMenu_CreateMenu()
		_GUICtrlMenu_InsertMenuItem( $hMaxVectorsMenu, 0, "3000", $idMaxVectors3000 )
		_GUICtrlMenu_InsertMenuItem( $hMaxVectorsMenu, 1, "No limit", $idMaxVectorsNoLimit )
		_GUICtrlMenu_SetItemState(   $hMaxVectorsMenu, $idMaxVectors3000,    $MFS_CHECKED, True,  False )
		_GUICtrlMenu_SetItemState(   $hMaxVectorsMenu, $idMaxVectorsNoLimit, $MFS_CHECKED, False, False )
		; Vectors in view menu
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 1, "", 0 )
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 2, "Normal vectors", $idViewNormals )
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 3, "Max vectors", 0, $hMaxVectorsMenu )
		_GUICtrlMenu_SetItemState(   $hViewMenu, $idViewNormals, $MFS_DISABLED, True, False )
		_GUICtrlMenu_SetItemState(   $hViewMenu, 3, $MFS_DISABLED, True, True )
		; Transformations
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 4, "", 0 )
		_GUICtrlMenu_InsertMenuItem( $hViewMenu, 5, "Transformations", $idViewTransformations )
	EndIf

	; Options menu
	$hOptionsMenu = _GUICtrlMenu_CreateMenu()
	If Not $bOpenGL21 Then _
		_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 0, "Light enabled", $idOptionsLight )
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 1, "Use textures", $idOptionsTextures )
	If $bOpenGL21 Then
		; Shaders menu
		$hShadersMenu = _GUICtrlMenu_CreateMenu()
		_GUICtrlMenu_InsertMenuItem( $hShadersMenu, 0, "Blinn-Phong", $idBlinnPhong )
		_GUICtrlMenu_InsertMenuItem( $hShadersMenu, 1, "Perpixel-Light", $idPerpixelLight )
		_GUICtrlMenu_InsertMenuItem( $hShadersMenu, 2, "Texture-Coords", $idTextureCoords )
		_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 2, "Set shaders", 0, $hShadersMenu )
	EndIf
	; Normals menu
	$hNormalsMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hNormalsMenu, 0, "Calculate", $idCalculateNormals )
	_GUICtrlMenu_InsertMenuItem( $hNormalsMenu, 1, "Average", $idAverageNormals )
	_GUICtrlMenu_InsertMenuItem( $hNormalsMenu, 2, "None", $idNoNormals )
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 3, "Normal vectors", 0, $hNormalsMenu )
	; Options menu, continued
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 4, "Load quads", $idOptionsQuads )
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 5, "", 0 )
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 6, "Save options", $idOptionsSave )
	_GUICtrlMenu_InsertMenuItem( $hOptionsMenu, 7, "Save transforms", $idOptionsSaveTransforms )

	; Main menu
	$hMenu = _GUICtrlMenu_CreateMenu()
	_GUICtrlMenu_InsertMenuItem( $hMenu, 0, "File",    0, $hFileMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 1, "Models",  0, $hModelsMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 2, "View",    0, $hViewMenu )
	_GUICtrlMenu_InsertMenuItem( $hMenu, 3, "Options", 0, $hOptionsMenu )

	; Dummy control to run menu commands
	$idMenuCmd = GUICtrlCreateDummy()
	GUICtrlSetOnEvent( $idMenuCmd, "MenuCommand" )

	; Models list
	CreateModelsListWindow()

	; Set window menu
	_GUICtrlMenu_SetMenu( $hGui, $hMenu )
EndFunc

Func WM_COMMAND( $hWnd, $iMsg, $iwParam, $ilParam )
	If $hWnd = $hGui Then
		$iMenuId = _WinAPI_LoWord( $iwParam )
		GUICtrlSendToDummy( $idMenuCmd )
	ElseIf $hWnd = $hModels Then
		Switch $ilParam
			Case $hModelList
				Switch BitShift( $iwParam, 16 )
					Case $LBN_DBLCLK
						$iModel = GetModel()
						GUICtrlSendToDummy( $idModelLaunch )
				EndSwitch
		EndSwitch
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc

Func MenuCommand()
	Switch $iMenuId
		; File menu
		Case $idFileOpen
			Local $sWd = @WorkingDir
			Local Static $sCurDir = "::{450D8FBA-AD25-11D0-98A8-0800361B1103}"
			Local $sObj = FileOpenDialog( "Open Wavefront (OBJ) 3D Model", $sCurDir, "OBJ-files (*.obj)", 3, "", $hGui )
			If Not @error Then
				$bOpen = 1
				$sNewModel = $sObj
				$sCurDir = @WorkingDir
				FileChangeDir( $sWd )
			EndIf
		Case $idFileReload
			$sNewModel = ""
		Case $idFileSave
			SaveBinaries()
		Case $idFileDel
			DelBinaries()

		; Models menu
		Case $idModelsSamples
			If $bModelWin And $idModelsLast = $idModelsSamples Then
				CloseList()
			Else
				If $idModelsLast <> $idModelsSamples Then
					; Get OBJ samples list
					_GUICtrlMenu_SetItemState( $hModelsMenu,   $idModelsSamples,  $MFS_CHECKED,  True,  False )
					_GUICtrlMenu_SetItemState( $hModelsMenu,   1,                 $MFS_CHECKED,  False, True  )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsSmall,    $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsMedium,   $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsLarge,    $MFS_CHECKED,  False, False )
					If Not $bOpenGL21 Then
						_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, False, False )
						_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, False, True )
						If Not BitAND( $bVectors, 1 ) Then $bVectors += 1
					EndIf
					GetModelsList( $idModelsSamples, "Samples\box2.obj" )
					$idModelsLast = $idModelsSamples
				EndIf
				ShowList()
			EndIf
		Case $idModelsSmall
			If $bModelWin And $idModelsLast = $idModelsSmall Then
				CloseList()
			Else
				If $idModelsLast <> $idModelsSmall Then
					; Get OBJ models list
					_GUICtrlMenu_SetItemState( $hModelsMenu,   $idModelsSamples,  $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsMenu,   1,                 $MFS_CHECKED,  True,  True  )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsSmall,    $MFS_CHECKED,  True,  False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsMedium,   $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsLarge,    $MFS_CHECKED,  False, False )
					If Not $bOpenGL21 Then
						_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, True,  False )
						_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, True, True )
						If BitAND( $bVectors, 1 ) Then $bVectors -= 1
					EndIf
					GetModelsList( $idModelsSmall, "Small\Art\Greek vase\greek_vase.obj" )
					$idModelsLast = $idModelsSmall
				EndIf
				ShowList()
			EndIf
		Case $idModelsMedium
			If $bModelWin And $idModelsLast = $idModelsMedium Then
				CloseList()
			Else
				If $idModelsLast <> $idModelsMedium Then
					; Get OBJ models list
					_GUICtrlMenu_SetItemState( $hModelsMenu,   $idModelsSamples,  $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsMenu,   1,                 $MFS_CHECKED,  True,  True  )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsSmall,    $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsMedium,   $MFS_CHECKED,  True,  False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsLarge,    $MFS_CHECKED,  False, False )
					If Not $bOpenGL21 Then
						_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, True,  False )
						_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, True, True )
						If BitAND( $bVectors, 1 ) Then $bVectors -= 1
					EndIf
					GetModelsList( $idModelsMedium, "Medium\Art\Greek vase\greek_vase.obj" )
					$idModelsLast = $idModelsMedium
				EndIf
				ShowList()
			EndIf
		Case $idModelsLarge
			If $bModelWin And $idModelsLast = $idModelsLarge Then
				CloseList()
			Else
				If $idModelsLast <> $idModelsLarge Then
					; Get OBJ models list
					_GUICtrlMenu_SetItemState( $hModelsMenu,   $idModelsSamples,  $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsMenu,   1,                 $MFS_CHECKED,  True,  True  )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsSmall,    $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsMedium,   $MFS_CHECKED,  False, False )
					_GUICtrlMenu_SetItemState( $hModelsModels, $idModelsLarge,    $MFS_CHECKED,  True,  False )
					If Not $bOpenGL21 Then
						_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, True,  False )
						_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, True, True )
						If BitAND( $bVectors, 1 ) Then $bVectors -= 1
					EndIf
					GetModelsList( $idModelsLarge, "Large\Art\Greek vase\greek_vase.obj" )
					$idModelsLast = $idModelsLarge
				EndIf
				ShowList()
			EndIf
		Case $idModelsMtls To $idModelsMtlsMax
			If $iMenuId = $idModelsMtlsMax Then
				SetModelsMenuMaterials( "", $sMtlFile, True )
				$sMtlFileNew = $aMtlFileList[$iMtlFile]
				$sMtlFile = ""
				$bMenuCmd = True
			Else
				Local $sFile = $aMtlFileList[$iMenuId-$idModelsMtls]
				If FileExists( $sFile ) Then
					If $sFile = $sMtlFile Then $sMtlFile = ""
					_GUICtrlMenu_SetItemState( $hModelsMtls, $iMtlFile, $MFS_CHECKED, False,  True  )
					_GUICtrlMenu_SetItemState( $hModelsMtls, $iMenuId-$idModelsMtls, $MFS_CHECKED, True,  True  )
					$iMtlFile = $iMenuId-$idModelsMtls
					$sMtlFileNew = $sFile
					$bMenuCmd = True
				EndIf
			EndIf

		; View menu
		Case $idViewWire
			$bWire = 1 - $bWire
			_GUICtrlMenu_SetItemState( $hViewMenu, $idViewWire, $MFS_CHECKED, $bWire, False )
			$bMenuCmd = True
		Case $idViewNormals
			$bVectors += 4 - 4 * 2 * ( BitAND( $bVectors, 4 ) = 4 )
			_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_CHECKED, BitAND( $bVectors, 4 ), False )
			$bMenuCmd = True
		Case $idMaxVectors3000, $idMaxVectorsNoLimit
			$bVectors += 2 - 2 * 2 * ( BitAND( $bVectors, 2 ) = 2 )
			_GUICtrlMenu_SetItemState( $hMaxVectorsMenu, $idMaxVectors3000,    $MFS_CHECKED,       BitAND( $bVectors, 2 ) = 2,   False )
			_GUICtrlMenu_SetItemState( $hMaxVectorsMenu, $idMaxVectorsNoLimit, $MFS_CHECKED, Not ( BitAND( $bVectors, 2 ) = 2 ), False )
			$bMenuCmd = True
		Case $idViewTransformations
			ViewTransformations()

		; Options menu
		Case $idOptionsLight
			$bMenuCmd = True
		Case $idOptionsTextures
			$bMenuCmd = True
		Case $idBlinnPhong, $idPerpixelLight, $idTextureCoords
			$bMenuCmd = True
		Case $idCalculateNormals, $idAverageNormals
			$bMenuCmd = True
		Case $idNoNormals
			$bMenuCmd = True
		Case $idOptionsQuads
			$bMenuCmd = True
		Case $idOptionsSave
			$bOptionsIni = $bOptions
			SetModelSettings( $aModel[11], $bOpenGL21 )
			_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )
		Case $idOptionsSaveTransforms
			SaveTransforms()
	EndSwitch
EndFunc

; --- File menu ---

Func SaveBinaries()
	Local $sExt, $sIniSection
	If Not $bModelQuads Then
		$sIniSection = "LoadBinFiles"
		$sExt = ".bin"
	Else
		$sIniSection = "LoadBinFiles4"
		$sExt = "4.bin"
	EndIf

	Local $sObjModel = $aModel[11]

	; Save buffer data to binary files
	Local $iVbo, $iSize, $aBuffer ; $aBuffer[0] = structure ; $aBuffer[1] = pointer
	Local $pStruct, $tStruct, $tFloats, $tShorts, $sBinData, $sFile, $hFile

	; Vertex coordinates
	$sFile = "V" & $sExt
	If $aModel[8] = 1 Then
		; No texture coordinates in model
		; No normal vectors in model
		; Normal vectors calculated
		If $bModelNormals Then
			; With average
			$sFile = "VAvg" & $sExt
		Else
			; Without average
			$sFile = "VCal" & $sExt
		EndIf
	EndIf
	If $bOpenGL21 Then
		$iVbo = $aModel[0]
		glBindBuffer( $GL_ARRAY_BUFFER, $iVbo )
		glGetBufferParameteriv( $GL_ARRAY_BUFFER, $GL_BUFFER_SIZE, $iSize )
		glGetBufferSubData( $GL_ARRAY_BUFFER, $GL_FLOAT, 0, $iSize, $tFloats )
		$pStruct = DllStructGetPtr( $tFloats )
		$tStruct = DllStructCreate( "byte[" & $iSize & "]", $pStruct )
	Else
		$aBuffer = $aModel[0]
		$tStruct = DllStructCreate( "byte[" & DllStructGetSize( $aBuffer[0] ) & "]", $aBuffer[1] )
	EndIf
	$sBinData = BinaryToString( DllStructGetData( $tStruct, 1 ) )
	$hFile = FileOpen( $sObjModel & $sFile, 18 ) ; 18 = write + binary mode
	FileWrite( $hFile, $sBinData )
	FileClose( $hFile )

	; Texture coordinates
	If BitAND( $aModel[8], 2 ) And ( IsArray( $aModel[1] ) Or $aModel[1] ) Then
		If $bOpenGL21 Then
			$iVbo = $aModel[1]
			glBindBuffer( $GL_ARRAY_BUFFER, $iVbo )
			glGetBufferParameteriv( $GL_ARRAY_BUFFER, $GL_BUFFER_SIZE, $iSize )
			glGetBufferSubData( $GL_ARRAY_BUFFER, $GL_FLOAT, 0, $iSize, $tFloats )
			$pStruct = DllStructGetPtr( $tFloats )
			$tStruct = DllStructCreate( "byte[" & $iSize & "]", $pStruct )
		Else
			$aBuffer = $aModel[1]
			$tStruct = DllStructCreate( "byte[" & DllStructGetSize( $aBuffer[0] ) & "]", $aBuffer[1] )
		EndIf
		$sBinData = BinaryToString( DllStructGetData( $tStruct, 1 ) )
		$hFile = FileOpen( $sObjModel & "Vt" & $sExt, 18 ) ; 18 = write + binary mode
		FileWrite( $hFile, $sBinData )
		FileClose( $hFile )
	EndIf

	; Normal vectors
	If IsArray( $aModel[2] ) Or $aModel[2] Then
		If $bOpenGL21 Then
			$iVbo = $aModel[2]
			glBindBuffer( $GL_ARRAY_BUFFER, $iVbo )
			glGetBufferParameteriv( $GL_ARRAY_BUFFER, $GL_BUFFER_SIZE, $iSize )
			glGetBufferSubData( $GL_ARRAY_BUFFER, $GL_FLOAT, 0, $iSize, $tFloats )
			$pStruct = DllStructGetPtr( $tFloats )
			$tStruct = DllStructCreate( "byte[" & $iSize & "]", $pStruct )
		Else
			$aBuffer = $aModel[2]
			$tStruct = DllStructCreate( "byte[" & DllStructGetSize( $aBuffer[0] ) & "]", $aBuffer[1] )
		EndIf
		$sBinData = BinaryToString( DllStructGetData( $tStruct, 1 ) )
		If BitAND( $aModel[8], 4 ) Then
			; Normal vectors supplied in model
			$sFile = "Vn" & $sExt
		Else
			; Normal vectors calculated
			If $bModelNormals Then
				; With average
				$sFile = "VnAvg" & $sExt
			Else
				; Without average
				$sFile = "VnCal" & $sExt
			EndIf
		EndIf
		$hFile = FileOpen( $sObjModel & $sFile, 18 ) ; 18 = write + binary mode
		FileWrite( $hFile, $sBinData )
		FileClose( $hFile )
	EndIf

	; Face polygons
	If IsArray( $aModel[3] ) Or $aModel[3] Then
		If $bOpenGL21 Then
			$iVbo = $aModel[3]
			glBindBuffer( $GL_ELEMENT_ARRAY_BUFFER, $iVbo )
			glGetBufferParameteriv( $GL_ELEMENT_ARRAY_BUFFER, $GL_BUFFER_SIZE, $iSize )
			glGetBufferSubData( $GL_ELEMENT_ARRAY_BUFFER, $GL_UNSIGNED_SHORT, 0, $iSize, $tShorts )
			$pStruct = DllStructGetPtr( $tShorts )
			$tStruct = DllStructCreate( "byte[" & $iSize & "]", $pStruct )
		Else
			$aBuffer = $aModel[3]
			$tStruct = DllStructCreate( "byte[" & DllStructGetSize( $aBuffer[0] ) & "]", $aBuffer[1] )
		EndIf
		$sBinData = BinaryToString( DllStructGetData( $tStruct, 1 ) )
		$hFile = FileOpen( $sObjModel & "F" & $sExt, 18 ) ; 18 = write + binary mode
		FileWrite( $hFile, $sBinData )
		FileClose( $hFile )
	EndIf

	; Save other data to inifile
	Local $aVertInfo  = $aModel[4]
	Local $aMaterials = $aModel[5], $sMtls = $aMaterials[0]
	Local $sMtlFile   = $aModel[6]
	Local $iStatus    = $aModel[7]
	Local $iFaceType  = $aModel[8]
	Local $sMeshType  = $aModel[9]
	Local $iObjects   = $aModel[13]
	Local $aVertStart = $aVertInfo[0], $sStart = $aVertStart[0]
	Local $aVertCnts  = $aVertInfo[1], $sCnts = $aVertCnts[0]
	For $i = 1 To $iObjects - 1
		$sMtls &= "|" & $aMaterials[$i]
		$sStart &= "|" & $aVertStart[$i]
		$sCnts &= "|" & $aVertCnts[$i]
	Next
	$sMtls &= "|" & $aMaterials[$iObjects]
	Local $aData[8][2] = [ _
		[ "Status", $iStatus ], _
		[ "FaceType", $iFaceType ], _
		[ "Objects", $iObjects ], _
		[ "MeshType", $sMeshType ], _
		[ "MtlFile", $sMtlFile ], _
		[ "VertCnts", $sCnts ], _
		[ "VertStart", $sStart ], _
		[ "Materials", $sMtls ] ]
	IniWriteSection( $sObjModel & ".ini", $sIniSection, $aData, 0 )
EndFunc

Func DelBinaries()
	Local $sExt, $sPath
	If Not $bModelQuads Then
		$sExt = ".bin"
	Else
		$sExt = "4.bin"
	EndIf
	Local $aFiles[8] = [ "V",  "VAvg",  "VCal",  _ ; Vertex coordinates
	                     "Vt",                   _ ; Texture coordinates
	                     "Vn", "VnAvg", "VnCal", _ ; Normal vectors
	                     "F" ]                     ; Face polygons
	Local $sObjModel = $aModel[11]
	For $i = 0 To 7
		$sPath = $sObjModel & $aFiles[$i] & $sExt
		If FileExists( $sPath ) Then FileDelete( $sPath )
	Next
EndFunc

; --- Models menu ---

Func CreateModelsListWindow()
	$hModels = GUICreate( "", 490, 125, 0, 0, $WS_CHILD, -1, $hGui )

	; Create list
	$idModelList = GUICtrlCreateList( "", 10, 10, 470, 69, BitOR( $GUI_SS_DEFAULT_LIST, $LBS_NOINTEGRALHEIGHT ), $WS_EX_STATICEDGE )
	$hModelList = ControlGetHandle( $hGui, "", $idModelList )

	; Detect enter key
	Local $kbdEnter = GUICtrlCreateDummy()
	$aAccelKeys[0][0] = "{ENTER}"
	$aAccelKeys[0][1] = $kbdEnter
	GUICtrlSetOnEvent( $kbdEnter, "kbdEnter" )
	GUISetAccelerators( $aAccelKeys, $hGui )
	GUISwitch( $hModels )

	; Dummy control to launch model
	$idModelLaunch = GUICtrlCreateDummy( )
	GUICtrlSetOnEvent( $idModelLaunch, "LaunchModel" )

	; Buttons and checkbox
	$idButNext  = GUICtrlCreateButton( "Next",   10, 90, 91, 22 )
	$idButPlay  = GUICtrlCreateButton( "Play",  111, 90, 91, 22 )
	$idButPrev  = GUICtrlCreateButton( "Prev",  212, 90, 91, 22 )
	$idButClose = GUICtrlCreateButton( "Close", 313, 90, 91, 22 )
	GUICtrlSetOnEvent( $idButNext,  "NextModel"  )
	GUICtrlSetOnEvent( $idButPlay,  "PlayModel"  )
	GUICtrlSetOnEvent( $idButPrev,  "PrevModel"  )
	GUICtrlSetOnEvent( $idButClose, "CloseList"  )

	GUISetState( @SW_HIDE )
	GUISwitch( $hGui )
EndFunc

Func GetModel()
	$sNewModel = GUICtrlRead( $idModelList )
	For $i = 0 To $nModels - 1
		If $sNewModel = $aModelList[$i] Then Return $i
	Next
EndFunc

Func kbdEnter()
	$iModel = GetModel()
	GUICtrlSendToDummy( $idModelLaunch )
EndFunc

Func LaunchModel()
	$sNewModel = $aModelList[$iModel]
EndFunc

Func NextModel()
	$iModel = GetModel() + 1
	If $iModel = $nModels Then $iModel = 0
	GUICtrlSetData( $idModelList, $aModelList[$iModel] )
	LaunchModel()
EndFunc

Func PlayModel()
	$iModel = GetModel()
	LaunchModel()
EndFunc

Func PrevModel()
	$iModel = GetModel() - 1
	If $iModel = -1 Then $iModel = $nModels - 1
	GUICtrlSetData( $idModelList, $aModelList[$iModel] )
	LaunchModel()
EndFunc

Func CloseList()
	$bModelWin = False
	GUISetState( @SW_HIDE, $hModels )
	GUICtrlSetState( $idInput, $GUI_FOCUS )
EndFunc

Func GetModelsList( $menuId, $sModel )
	Local $sPath, $aTmp, $j = -1
	; Get Wavefront OBJ models
	Switch $iMenuId
		Case $idModelsSamples
			$sPath = "Samples"
			$aTmp = _FileListToArrayRec( $models & "\" & $sPath, "*.obj|*-a.obj;*-b.obj|0;1;2;3;4;Large;Medium;Small", 0, 1, 2 )
		Case $idModelsSmall
			$sPath = "Small"
			$aTmp = _FileListToArrayRec( $models & "\" & $sPath, "*.obj|*-a.obj;*-b.obj|0;1;2;3;4;Large;Medium;Samples", 0, 1, 2 )
		Case $idModelsMedium
			$sPath = "Medium"
			$aTmp = _FileListToArrayRec( $models & "\" & $sPath, "*.obj|*-a.obj;*-b.obj|0;1;2;3;4;Large;Samples;Small", 0, 1, 2 )
		Case $idModelsLarge
			$sPath = "Large"
			$aTmp = _FileListToArrayRec( $models & "\" & $sPath, "*.obj|*-a.obj;*-b.obj|0;1;2;3;4;Medium;Samples;Small", 0, 1, 2 )
	EndSwitch
	; No folders
	$nModels = 0
	ReDim $aModelList[$aTmp[0]]
	For $i = 1 To $aTmp[0]
		If StringRight( $aTmp[$i], 4 ) <> ".obj" Then ContinueLoop
		$aModelList[$nModels] = $sPath & "\" & $aTmp[$i]
		$nModels += 1
	Next
	ReDim $aModelList[$nModels]
	; Fill listbox
	; Set current model to $sModel
	GUICtrlSetData( $idModelList, "" )
	For $i = 0 To $nModels - 1
		GUICtrlSetData( $idModelList, $aModelList[$i] )
		If $j = -1 And $sModel = $aModelList[$i] Then $j = $i
	Next
	GUICtrlSetData( $idModelList, $aModelList[$j] )
	$sNewModel = $aModelList[$j]
EndFunc

Func ShowList()
	; Calculate list position
	Local $tRect, $aRet[2], $aPos
	$tRect = _GUICtrlMenu_GetItemRectEx( $hGui, $hMenu, $idxModels )
	$aRet[0] = DllStructGetData( $tRect, "Left" )
	$aRet[1] = DllStructGetData( $tRect, "Bottom" )
	$aPos = WinGetPos( $hGui )
	; Show samples list window
	WinMove( $hModels, "", $aRet[0]-$aPos[0]-4, $aRet[1]-$aPos[1]-$iMenuBarHeight-$iStatusBarHeight, 490, 125 )
	GUISetState( @SW_SHOW, $hModels )
	ControlFocus( $hModels, "", $idModelList )
	$bModelWin = True
EndFunc

Func SetModelsMenuMaterials( $sObjModel, $sMtlFile, $bRefresh = False )

	Local Static $sObjPath, $sMtlFileList = ""

	If Not $bRefresh Then
		$sObjPath = StringLeft( $sObjModel, StringInStr( $sObjModel, "\", 0, -1 ) - 1 )
		$sMtlFileList = $sObjModel & "-MtlFiles.txt"
		$sMtlFile = $sObjPath & "\" & $sMtlFile
		$sMtlFileNew = $sMtlFile
	EndIf

	Local $aTmp, $nObjs = 0, $j = 0
	$aTmp = _FileListToArrayRec( $sObjPath, "*.obj|*-a.obj;*-b.obj|0;1;2;3;4", 0, 1, 2 )
	If $aTmp[0] Then
		For $i = 1 To $aTmp[0]
			If StringRight( $aTmp[$i], 4 ) <> ".obj" Then ContinueLoop
			$nObjs += 1
			If $nObjs = 2 Then ExitLoop
		Next
	EndIf

	If FileExists( $sMtlFileList ) Then
		; If $sMtlFileList ($sObjModel & "-MtlFiles.txt") exists,
		; read the names of the material files in this list.
		Local $aLines, $line
		_FileReadToArray( $sMtlFileList, $aLines )
		ReDim $aMtlFileList[$aLines[0]]
		For $i = 1 To $aLines[0]
			If StringRight( $aLines[$i], 4 ) <> ".mtl" Then ContinueLoop
			If Not FileExists( $sObjPath & "\" & $aLines[$i] ) Then ContinueLoop
			$aMtlFileList[$j] = $sObjPath & "\" & $aLines[$i]
			$j += 1
		Next
		ReDim $aMtlFileList[$j]
		If $j < 2 Then
			_GUICtrlMenu_SetItemState( $hModelsMenu, 3, $MFS_DISABLED, True, True )
			Return
		EndIf

	ElseIf $nObjs = 1 Then
		; If $sMtlFileList does not exists and the folder only contains one OBJ-model,
		; then use _FileListToArrayRec to create a list of material files.
		$aTmp = _FileListToArrayRec( $sObjPath, "*.mtl|*-a.mtl;*-b.mtl|0;1;2;3;4", 0, 1, 2 )
		If $aTmp[0] Then
			ReDim $aMtlFileList[$aTmp[0]]
			For $i = 1 To $aTmp[0]
				If StringRight( $aTmp[$i], 4 ) <> ".mtl" Then ContinueLoop
				$aMtlFileList[$j] = $sObjPath & "\" & $aTmp[$i]
				$j += 1
			Next
			ReDim $aMtlFileList[$j]
		EndIf
		If $j < 2 Then
			_GUICtrlMenu_SetItemState( $hModelsMenu, 3, $MFS_DISABLED, True, True )
			Return
		EndIf

	Else
		_GUICtrlMenu_SetItemState( $hModelsMenu, 3, $MFS_DISABLED, True, True )
		Return
	EndIf

	; Delete previous menu items
	For $i = _GUICtrlMenu_GetItemCount( $hModelsMtls ) - 1 To 0 Step -1
		_GUICtrlMenu_DeleteMenu( $hModelsMtls, $i )
	Next

	; Add material files to the menu
	Local $s
	_GUICtrlMenu_SetItemState( $hModelsMenu, 3, $MFS_DISABLED, False, True )
	For $i = 0 To UBound( $aMtlFileList ) - 1
		$s = $aMtlFileList[$i]
		$j = StringInStr( $s, "\", 0, -1 )
		$s = StringRight( $s, StringLen( $s ) - $j )
		_GUICtrlMenu_InsertMenuItem( $hModelsMtls, $i, $s, $idModelsMtls + $i )
		If $sMtlFile = $aMtlFileList[$i] Then
			_GUICtrlMenu_SetItemState( $hModelsMtls, $i, $MFS_CHECKED, True,  True  )
			$iMtlFile = $i
		EndIf
	Next
	_GUICtrlMenu_InsertMenuItem( $hModelsMtls, $i, "", 0 )
	_GUICtrlMenu_InsertMenuItem( $hModelsMtls, $i + 1, "Refresh", $idModelsMtls + $i + 1 )
	; The Refresh menu item can be used to update the list of material files, and to reload
	; the current material file without the need to reload the entire OBJ-model.
	$idModelsMtlsMax = $idModelsMtls + $i + 1

EndFunc

; --- View menu ---

Func ViewTransformations()
	If $bOpenGL21 Then
		Local $m = $aModel[12]
		Local $aData[4][2] = [ _
			[ "(   [0],   [1],   [2],   [3] ) = ", sf3(  $m[0] ) & sf3(  $m[1] ) & sf3(  $m[2] ) & StringFormat( "%.4f",  $m[3] ) ], _
			[ "(   [4],   [5],   [6],   [7] ) = ", sf3(  $m[4] ) & sf3(  $m[5] ) & sf3(  $m[6] ) & StringFormat( "%.4f",  $m[7] ) ], _
			[ "(   [8],   [9], [10], [11] ) = ", sf3(  $m[8] ) & sf3(  $m[9] ) & sf3( $m[10] ) & StringFormat( "%.4f", $m[11] ) ], _
			[ "( [12], [13], [14], [15] ) = ", sf3( $m[12] ) & sf3( $m[13] ) & sf3( $m[14] ) & StringFormat( "%.4f", $m[15] ) ] ]
			_ArrayDisplay( $aData, "Model transformations" )
	Else
		Local $aTransforms = $aModel[12]

		; Calculate transformations as OpenGL 2.1 transformations
		Local $m = $IDENTITY_MATRIX
		; Rotations
		Local $axisX[3] = [ 1.0, 0.0, 0.0 ], $axisY[3] = [ 0.0, 1.0, 0.0 ], $axisZ[3] = [ 0.0, 0.0, 1.0 ]
		Local $rx = Number( $aTransforms[1] ), $ry = Number( $aTransforms[2] ), $rz = Number( $aTransforms[3] )
		If $rx <> 0 Then $m = glmRotate( $m, $rx, $axisX )
		If $ry <> 0 Then $m = glmRotate( $m, $ry, $axisY )
		If $rz <> 0 Then $m = glmRotate( $m, $rz, $axisZ )
		; Translations
		Local $tx[3] = [ Number( $aTransforms[4] ), 0, 0 ], $ty[3] = [ 0, Number( $aTransforms[5] ), 0 ], $tz[3] = [ 0, 0, Number( $aTransforms[6] ) ]
		If $tx[0] <> 0 Then $m = glmTranslate( $m, $tx )
		If $ty[1] <> 0 Then $m = glmTranslate( $m, $ty )
		If $tz[2] <> 0 Then $m = glmTranslate( $m, $tz )
		; Scaling
		Local $s[3] = [ $aTransforms[0], $aTransforms[0], $aTransforms[0] ]
		If $s[0] <> 1 Then $m = glmScale( $m, $s )
		; Create a |-separated list for [Transforms 2.1]-section in inifile
		Local $sList = "Transforms="
		For $i = 0 To 15
			If $i Then $sList &= "|"
			Switch $m[$i]
				Case -1
					$sList &= "-1"
				Case 0
					$sList &= "0"
				Case 1
					$sList &= "1"
				Case Else
					$sList &= StringFormat( "%.4f", $m[$i] )
			EndSwitch
		Next

		; Display transformations
		Local $aData[16][2] = [ _
			[ "OpenGL 1.1", "" ], _
			[ "fScale", StringFormat( "%.4f", $aTransforms[0] ) ], _
			[ "fRotX", StringFormat( "%.4f", $aTransforms[1] ) ], _
			[ "fRotY", StringFormat( "%.4f", $aTransforms[2] ) ], _
			[ "fRotZ", StringFormat( "%.4f", $aTransforms[3] ) ], _
			[ "fTransX", StringFormat( "%.4f", $aTransforms[4] ) ], _
			[ "fTransY", StringFormat( "%.4f", $aTransforms[5] ) ], _
			[ "fTransZ", StringFormat( "%.4f", $aTransforms[6] ) ], _
			[ "", "" ], _
			[ "OpenGL 2.1", "" ], _
			[ "(   [0],   [1],   [2],   [3] ) = ", sf3(  $m[0] ) & sf3(  $m[1] ) & sf3(  $m[2] ) & StringFormat( "%.4f",  $m[3] ) ], _
			[ "(   [4],   [5],   [6],   [7] ) = ", sf3(  $m[4] ) & sf3(  $m[5] ) & sf3(  $m[6] ) & StringFormat( "%.4f",  $m[7] ) ], _
			[ "(   [8],   [9], [10], [11] ) = ", sf3(  $m[8] ) & sf3(  $m[9] ) & sf3( $m[10] ) & StringFormat( "%.4f", $m[11] ) ], _
			[ "( [12], [13], [14], [15] ) = ", sf3( $m[12] ) & sf3( $m[13] ) & sf3( $m[14] ) & StringFormat( "%.4f", $m[15] ) ], _
			[ "", "" ], _
			[ "[Transforms 2.1]", $sList ] ]
			_ArrayDisplay( $aData, "Model transformations" )
	EndIf
EndFunc

; --- Options menu ---

Func SetOptionsMenuStates( ByRef $aModel )

	$bOptionsIni = 0

	; Light
	If Not $bOpenGL21 Then
		If $bModelLight Then $bOptionsIni += 1
		_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsLight, $MFS_CHECKED, $bModelLight, False )
		$bDrawLight = $bModelLight
	EndIf

	; Texture maps
	If BitAND( $aModel[7], 3 ) = 3 Then
		; If texture maps exists they can optionally be turned on/off
		_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsTextures, $MFS_DISABLED, False, False )
		_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsTextures, $MFS_CHECKED, $bModelTextures, False )
		If $bModelTextures Then $bOptionsIni += 2
		$bDrawTextures = $bModelTextures
	Else
		_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsTextures, $MFS_CHECKED, False, False )
		_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsTextures, $MFS_DISABLED, True, False )
		$bDrawTextures = 0
	EndIf

	; Shaders
	If $bOpenGL21 Then
		$bOptionsIni += 2 ^ ( $bModelShader + 1 )
		_GUICtrlMenu_SetItemState( $hShadersMenu, $idBlinnPhong,    $MFS_CHECKED, $bModelShader = 1, False )
		_GUICtrlMenu_SetItemState( $hShadersMenu, $idPerpixelLight, $MFS_CHECKED, $bModelShader = 2, False )
		_GUICtrlMenu_SetItemState( $hShadersMenu, $idTextureCoords, $MFS_CHECKED, $bModelShader = 3, False )
		If $aModel[7] = 0 Then
			; No texture maps / texture coordinates, calculated normal vectors
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idBlinnPhong,    $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idPerpixelLight, $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idTextureCoords, $MFS_DISABLED, True,  False )
		ElseIf $aModel[7] = 3 And $bModelNormals <> -1 Then
			; Texture maps / texture coordinates, no normal vectors
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idBlinnPhong,    $MFS_DISABLED, True,  False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idPerpixelLight, $MFS_DISABLED, True,  False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idTextureCoords, $MFS_DISABLED, False, False )
		Else
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idBlinnPhong,    $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idPerpixelLight, $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hShadersMenu, $idTextureCoords, $MFS_DISABLED, False, False )
		EndIf
		$bCurrentShader = $bModelShader
	EndIf

	; Normal vectors
	Select
		Case $aModel[7] = 0
			; No texture maps/coordinates, calculated normal vectors
			_GUICtrlMenu_SetItemState( $hOptionsMenu, 2, $MFS_DISABLED, False, True )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idCalculateNormals, $MFS_CHECKED,  $bModelNormals = 0, False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idAverageNormals,   $MFS_CHECKED,  $bModelNormals = 1, False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idNoNormals,        $MFS_CHECKED,  False,              False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idCalculateNormals, $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idAverageNormals,   $MFS_DISABLED, False, False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idNoNormals,        $MFS_DISABLED, True,  False )
			If $bModelNormals Then $bOptionsIni += 32
			If Not $bOpenGL21 And $idModelsLast = $idModelsSamples Then
				_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, False, False )
				_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, False, True )
				If Not BitAND( $bVectors, 1 ) Then $bVectors += 1
			EndIf
		Case $aModel[7] = 3 And $bModelNormals <> -1
			; Texture maps/coordinates, no normal vectors
			_GUICtrlMenu_SetItemState( $hOptionsMenu, 2, $MFS_DISABLED, True, True )
			If Not $bOpenGL21 And $idModelsLast = $idModelsSamples Then
				_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, True, False )
				_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, True, True )
				If BitAND( $bVectors, 1 ) Then $bVectors -= 1
			EndIf
		Case $aModel[7] = 7 Or $bModelNormals = -1
			; Texture maps/coordinates, normal vectors
			_GUICtrlMenu_SetItemState( $hOptionsMenu, 2, $MFS_DISABLED, False, True )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idCalculateNormals, $MFS_CHECKED,  False,               False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idAverageNormals,   $MFS_CHECKED,  False,               False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idNoNormals,        $MFS_CHECKED,  $bModelNormals = -1, False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idCalculateNormals, $MFS_DISABLED, True,  False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idAverageNormals,   $MFS_DISABLED, True,  False )
			_GUICtrlMenu_SetItemState( $hNormalsMenu, $idNoNormals,        $MFS_DISABLED, False, False )
			If $bModelNormals Then $bOptionsIni += 64
			If Not $bOpenGL21 And $idModelsLast = $idModelsSamples Then
				_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, $bModelNormals = -1, False )
				_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, $bModelNormals = -1, True )
				If Not BitAND( $bVectors, 1 ) Then $bVectors += 1
			EndIf
		Case BitAND( $aModel[7], 4 )
			; No texture maps/coordinates, normal vectors
			_GUICtrlMenu_SetItemState( $hOptionsMenu, 2, $MFS_DISABLED, True, True )
	EndSelect
	$bDrawNormals = $bModelNormals

	; Quad mesh
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsQuads, $MFS_CHECKED,  $bModelQuads,          False )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsQuads, $MFS_DISABLED, $aModel[9] <> "Quads", False )
	If $bModelQuads Then $bOptionsIni += 128

	; Vectors (View menu)
	If Not $bOpenGL21 Then
		If Not BitAND( $bVectors, 2 ) Then
			$bVectors += 2
			_GUICtrlMenu_SetItemState( $hMaxVectorsMenu, $idMaxVectors3000,    $MFS_CHECKED, True,  False )
			_GUICtrlMenu_SetItemState( $hMaxVectorsMenu, $idMaxVectorsNoLimit, $MFS_CHECKED, False, False )
		EndIf
	EndIf

	$bOptions = $bOptionsIni
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )

EndFunc

Func SetLight()
	$bModelLight = 1 - $bModelLight
	$bOptions += 1 - 1 * 2 * ( $bModelLight = 1 )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsLight, $MFS_CHECKED, $bModelLight, False )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )
EndFunc

Func SetTextures()
	$bModelTextures = 1 - $bModelTextures
	$bOptions += 2 - 2 * 2 * ( $bModelTextures = 1 )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsTextures, $MFS_CHECKED, $bModelTextures, False )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )
EndFunc

Func SetShader( $bNewShader )
	$bOptions -= 2 ^ ( $bModelShader + 1 )
	$bOptions += 2 ^ ( $bNewShader + 1 )
	_GUICtrlMenu_SetItemState( $hShadersMenu, $idBlinnPhong,    $MFS_CHECKED,  $bNewShader = 1, False )
	_GUICtrlMenu_SetItemState( $hShadersMenu, $idPerpixelLight, $MFS_CHECKED,  $bNewShader = 2, False )
	_GUICtrlMenu_SetItemState( $hShadersMenu, $idTextureCoords, $MFS_CHECKED,  $bNewShader = 3, False )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave,   $MFS_DISABLED, $bOptions = $bOptionsIni, False )
	$bModelShader = $bNewShader
EndFunc

Func SetNormals( $bNormals )
	If $bNormals = -1 Or $bModelNormals = -1 Then
		$bModelNormals = $bNormals
		$bOptions += 64 - 64 * 2 * ( $bModelNormals = 0 )
	Else
		$bModelNormals = 1 - $bModelNormals
		$bOptions += 32 - 32 * 2 * ( $bModelNormals = 0 )
	EndIf
	If $aModel[7] = 0 Then
		; No texture maps/coordinates, calculated normal vectors
		_GUICtrlMenu_SetItemState( $hNormalsMenu, $idCalculateNormals, $MFS_CHECKED,  $bModelNormals =  0, False )
		_GUICtrlMenu_SetItemState( $hNormalsMenu, $idAverageNormals,   $MFS_CHECKED,  $bModelNormals =  1, False )
	Else
		_GUICtrlMenu_SetItemState( $hNormalsMenu, $idNoNormals,        $MFS_CHECKED,  $bModelNormals = -1, False )
		If $idModelsLast = $idModelsSamples Then
			_GUICtrlMenu_SetItemState( $hViewMenu, $idViewNormals, $MFS_DISABLED, $bModelNormals = -1, False )
			_GUICtrlMenu_SetItemState( $hViewMenu, 3, $MFS_DISABLED, $bModelNormals = -1, True )
		EndIf
	EndIf
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )
EndFunc

Func SetQuads()
	$bModelQuads = 1 - $bModelQuads
	$bOptions += 128 - 128 * 2 * ( $bModelQuads = 0 )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsQuads, $MFS_CHECKED, $bModelQuads, False )
	_GUICtrlMenu_SetItemState( $hOptionsMenu, $idOptionsSave, $MFS_DISABLED, $bOptions = $bOptionsIni, False )
EndFunc

Func ReadTransforms( $sObjModel, ByRef $aTransforms )
	If FileExists( $sObjModel & ".ini" ) Then
		Local $sSection = "Transforms "
		If $bOpenGL21 Then
			$sSection &= "2.1"
		Else
			$sSection &= "1.1"
		EndIf
		Local $aData = IniReadSection( $sObjModel & ".ini", $sSection )
		If IsArray( $aData ) And $aData[1][0] = "Transforms" Then _
			$aTransforms = StringSplit( $aData[1][1], "|", 2 )
	EndIf
EndFunc

Func SaveTransforms()
	Local $sObjModel = $aModel[11]
	Local $aTransforms = $aModel[12], $str = $aTransforms[0]
	For $i = 1 To UBound( $aTransforms ) - 1
		$str &= "|" & $aTransforms[$i]
	Next
	Local $sSection = "Transforms "
	If $bOpenGL21 Then
		$sSection &= "2.1"
	Else
		$sSection &= "1.1"
	EndIf
	Local $aData[1][2] = [ [ "Transforms", $str ] ]
	IniWriteSection( $sObjModel & ".ini", $sSection, $aData, 0 )
EndFunc

; --- Shortcut functions ---

Func HandleKeystrokes( ByRef $aModel, $bOpenGL21 = True )

	Local Static $bKey = 0, $nKey = 0
	Local Static $nStrokes = 0

	Select
		Case _IsPressed( "21", $dllUser32 ) ; Page up
			$bKey =  1
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "22", $dllUser32 ) ; Page down
			$bKey =  2
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "24", $dllUser32 ) ; Home
			$bKey =  3
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "51", $dllUser32 ) ; Q
			$bKey =  4
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "41", $dllUser32 ) ; A
			$bKey =  5
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "57", $dllUser32 ) ; W
			$bKey =  6
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "53", $dllUser32 ) ; S
			$bKey =  7
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "45", $dllUser32 ) ; E
			$bKey =  8
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "44", $dllUser32 ) ; D
			$bKey =  9
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "55", $dllUser32 ) ; U
			$bKey = 10
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4A", $dllUser32 ) ; J
			$bKey = 11
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "49", $dllUser32 ) ; I
			$bKey = 12
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4B", $dllUser32 ) ; K
			$bKey = 13
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4F", $dllUser32 ) ; O
			$bKey = 14
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4C", $dllUser32 ) ; L
			$bKey = 15
			if Not $nKey Then $nKey = 1
		Case Else
			$nKey = 0
			Return
	EndSelect

	If $nKey = 1 Or $nKey = 3 Then
		Switch $bKey
			Case  1 ; Page up
				$iScaleFactor = +1
				$bTransforms = 1
			Case  2 ; Page down
				If $bOpenGL21 Then
					$iScaleFactor = -1
					$bTransforms = 1
				Else
					Local $aTransforms = $aModel[12]
					If $aTransforms[0] > 0.02 Then
						$iScaleFactor = -1
						$bTransforms = 1
					EndIf
				EndIf
			Case  3 ; Home
				ResetModel( $aModel )
				InitializeView()
			Case  4 ; Q
				$iRotXdirection = +1
				$bTransforms = 1
			Case  5 ; A
				$iRotXdirection = -1
				$bTransforms = 1
			Case  6 ; W
				$iRotYdirection = +1
				$bTransforms = 1
			Case  7 ; S
				$iRotYdirection = -1
				$bTransforms = 1
			Case  8 ; E
				$iRotZdirection = +1
				$bTransforms = 1
			Case  9 ; D
				$iRotZdirection = -1
				$bTransforms = 1
			Case 10 ; U
				$iTransXdirection = +1
				$bTransforms = 1
			Case 11 ; J
				$iTransXdirection = -1
				$bTransforms = 1
			Case 12 ; I
				$iTransYdirection = +1
				$bTransforms = 1
			Case 13 ; K
				$iTransYdirection = -1
				$bTransforms = 1
			Case 14 ; O
				$iTransZdirection = +1
				$bTransforms = 1
			Case 15 ; L
				$iTransZdirection = -1
				$bTransforms = 1
		EndSwitch
		$bKey = 0
	EndIf

	Switch $nKey
		Case 1
			; First keypress
			$nKey = 2
			$nStrokes = 0
		Case 2
			; Wait a few loops for next keypress
			; To get time to release the key for a single keypress
			$nStrokes += 1
			If $nStrokes > 3 Then _
				$nKey = 3
	EndSwitch

EndFunc
