
// Per-fragment Blinn-Phong shader for a single directional light source.

uniform sampler2D colorMap;
varying vec3 normal;
varying vec2 colorUV;

void main()
{
	float nDotL = max(0.0, dot(normal, gl_LightSource[0].position.xyz));
	float nDotH = max(0.0, dot(normal, vec3(gl_LightSource[0].halfVector)));
	float power = (nDotL == 0.0) ? 0.0 : pow(nDotH, gl_FrontMaterial.shininess);

	vec4 ambient = gl_FrontLightProduct[0].ambient;
	vec4 diffuse = gl_FrontLightProduct[0].diffuse * nDotL;
	vec4 specular = gl_FrontLightProduct[0].specular * power;
	vec4 color = gl_FrontLightModelProduct.sceneColor + ambient + diffuse + specular;

	gl_FragColor = color * texture2D(colorMap, colorUV);
}
