; This is a modified version of a sparkler by trancexx
; http://www.autoitscript.com/forum/index.php?showtopic=83581

#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>

; AutoIt options
Opt( "GUIOnEventMode", 1 )
Opt( "MustDeclareVars", 1 )

; --- Project includes ---

#include "utilities\globals.au3"
#include "utilities\includes.au3"
#include "..\utilities\Stars 2.au3"
#include "utilities\utilities.au3"
#include "utilities\statusbar.au3"

; --- Program code ---

MainFunc()

While 1
	If $iSparklers <> $newSparklers Then
		$iSparklers = $newSparklers
		CreateSparklers()
	EndIf
	If $bStars Then
		CreateStars()
		$bStars = False
	EndIf
	If $bResize Then
		ResizeOpenGLwindow( 0, 0, $iWidth, $iHeight, 45.0, 1.0, 100.0 )
		$bResize = False
	EndIf
	DisplayFunction()
	Sleep(10)
WEnd


Func MainFunc()
	If Not InitGUIwindow( True ) Then GUI_EVENT_CLOSE()
	If Not InitOpenGLwindow() Then GUI_EVENT_CLOSE()
	If Not CreateResources( True ) Then GUI_EVENT_CLOSE()
	If Not GetFASMcode() Then GUI_EVENT_CLOSE()
EndFunc


Func GetFASMcode()
	If Not StarsFASMcode() Then Return 0
	Return 1
EndFunc


Func DisplayFunction()

	glClear( $GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT )
	glLoadIdentity()

	glTranslatef( 0, 0, -7 )

	If $bShowStars Then _
		DllCallAddress( "none", $pCodeStars, "byte", $iStars, "ptr", $pStars, "ptr", $pDataStars )

	glScalef( 3.25, 3.25, 3.25 )

	Local $m
	For $i = 0 To $iSparklers - 1

		$m = $aSparklers[$i][0]

		; Show sparkler
		Sparkler( $m, _
			$aSparklers[$i][1], _ ; $x
			$aSparklers[$i][2], _ ; $y
			$aSparklers[$i][3], _ ; $dx
			$aSparklers[$i][4], _ ; $dy
			$aSparklers[$i][5] )  ; $pColor

		; If a sparkler has burned out create a new
		If $m = 0 Then NewSparkler( $i )

	Next

	SwapBuffers( $hDC )

	; Increace $m
	For $i = 0 To $iSparklers - 1
		$aSparklers[$i][0] += 0.0003
	Next

EndFunc
