#include-once

Func InitGUIwindow( $fStars = False )

	$hGui = GUICreate( ScriptName(), $iGuiWidth, $iGuiHeight, 400, 50, $WS_OVERLAPPEDWINDOW )

	GUISetOnEvent( $GUI_EVENT_MAXIMIZE, "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESIZED,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESTORE,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_CLOSE,    "GUI_EVENT_CLOSE"  )

	GUIRegisterMsg( $WM_SIZING, "WM_SIZING" )

	CreateStatusbar( $fStars )

	Return 1

EndFunc


Func InitOpenGLwindow()

	$hOpenGL = GUICreate( "", $iWidth, $iHeight, 0, 0, $WS_CHILD, -1, $hGui )
	GUISetState()

	If GetOpenGLContext( $hOpenGL, $hDC, $hRC ) = 0 Then Return 0
	GUISetState()

	glClearColor( 0.0, 0.0, 0.0, 0.0 )

	glClearDepth( 1.0 )
	glDisable( $GL_DEPTH_TEST )

	glEnable( $GL_BLEND )
	glBlendFunc( $GL_SRC_COLOR, $GL_DST_COLOR )

	glLineWidth( 2 )

	GUISwitch( $hGui )
	GUISetState()

	Return 1

EndFunc


Func CreateResources( $fStars = False )

	Local Static $stRed, $stYellow, $stGreen

	; Red sparkler
	Local $aRed[3] = [ 1.0, 0.0, 0.0 ]
	$pColors[0] = MakeColors( $stRed, $aRed )

	; Yellow sparkler
	Local $aYellow[3] = [ 1.0, 1.0, 0.0 ]
	$pColors[1] = MakeColors( $stYellow, $aYellow )

	; Green sparkler
	Local $aGreen[3] = [ 0.0, 1.0, 0.0 ]
	$pColors[2] = MakeColors( $stGreen, $aGreen )

	; Create sparklers
	CreateSparklers()

	If $fStars And Not CreateStars() Then Return 0

	Return 1

EndFunc


Func MakeColors( ByRef $stColor, ByRef $aColor )
	$stColor = DllStructCreate( "float[3]" )
	For $i = 0 To 2
		DllStructSetData( $stColor, 1, $aColor[$i], $i+1 )
	Next
	Return DllStructGetPtr( $stColor )
EndFunc


Func CreateSparklers()
	Local $m = 0, $dm = 0.14 / $iSparklers
	For $i = 0 To $iSparklers - 1
		NewSparkler( $i, $m )
		$m += $dm
	Next
EndFunc


Func NewSparkler( $iSparkler, $m = 0 )
	$aSparklers[$iSparkler][0] = $m
	$aSparklers[$iSparkler][3] = Random( -0.2, 0.2 ) 						; $dx, change the $x position a little
	$aSparklers[$iSparkler][4] = Random( -0.2, 0.2 ) 						; $dy, change the $y position a little
	$aSparklers[$iSparkler][5] = $pColors[ Random( 0, 2, 1 ) ]	; $pColor
EndFunc


Func Sparkler( ByRef $m, $x, $y, $dx, $dy, $pColor )

	; The stick
	If $m < 0.125 Then																					; turn off if $m > 0.125
		glLineWidth( 2.0 )																				; thick line for the stick
		glEnable( $GL_LINE_SMOOTH )																; a little thicker and smoother
		glBegin( $GL_LINES )
			glColor3fv( $pColor )																		; stick color on the one side
			glVertex2f( $x+$dx, $y+$dy )														; stick starts here
			glColor3f( 0.0, 0.0, 1.0 )															; stick color on the other side
			glVertex2f( $x+$dx-0.25, $y+$dy-0.5 )										; stick ends here
		glEnd()
	EndIf

	; The sparks
	Local $s, $t, $u
	glLineWidth( 1.0 )																					; thin line
	glDisable( $GL_LINE_SMOOTH )																; not smooth
	glBegin( $GL_LINES )
		For $i = 1 To 10
			$i += 2 * ( $m > 0.08 ) + 3 * ( $m > 0.1 )							; blowing out
			$m *= ( $m < 0.14 )																			; looping
			If $m < 0.12 Then
				$s = Random( -9, 9, 1 ) / 32
				$t = Random( -9, 9, 1 ) / 35
				glColor3f( 1.0, 0.0, 0.0 )														; begin with this color
				glVertex2f( -$m+$x+$dx, -2*$m+$y+$dy )								; start line here
				glColor3f( 0.0, 1.0, 1.0 )														; end with this color
				glVertex2f( $s-$m+$x+$dx, $t-2*$m+$y+$dy )						; end line here
				$u = Floor( 10000 * $m )
				If $u = 201 Or $u = 402 Or $u = 603 Or $u = 803 Then	; few flashes to make it more real
					glColor3f( 1.0, 0.0, 0.0 )													; begin with this color
					glVertex2f( -$m+$x+$dx, -2*$m+$y+$dy )							; start line here
					glColor3f( 0.0, 1.0, 1.0 )													; end with this color
					glVertex2f( 2*$s-$m+$x+$dx, 2*$t-2*$m+$y+$dy )			; end line here
				EndIf
			EndIf
		Next
	glEnd()

EndFunc


Func WM_SIZING( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $iMsg, $iwParam
	Switch $hWnd
		Case $hGui
			Local $tRECT = DllStructCreate( $tagRECT, $ilParam )
			Local $y = DllStructGetData( $tRECT, "Top" )
			Local $iHeight = DllStructGetData( $tRECT, "Bottom" ) - $y - $iTitleBarHeight - $iBorderWidth - $iStatusBarHeight
			If $hStars Then WinMove( $hStars, "", $iStarsXpos, $iHeight + $iHeightXP )
			WinMove( $hStatusbar, "", 2, $iHeight + $iHeightXP )
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc


Func GUI_EVENT_RESIZE()
	Local $aPos = WinGetPos( $hGui )
	$iWidth = $aPos[2] - 2 * $iBorderWidth
	$iHeight = $aPos[3] - $iTitleBarHeight - $iBorderWidth - $iStatusBarHeight
	If $hStars Then WinMove( $hStars, "", $iStarsXpos, $iHeight + $iHeightXP )
	WinMove( $hStatusbar, "", 2, $iHeight + $iHeightXP )
	WinMove( $hOpenGL, "", 0, 0, $iWidth, $iHeight )
	$bResize = True
EndFunc


Func GUI_EVENT_CLOSE()
	DisableOpenGL( $hOpenGL, $hDC, $hRC )
	GUIDelete( $hGui )
	ExLauncherWin()
	CloseDlls()
	Exit
EndFunc
