#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>

; AutoIt options
Opt( "GUIOnEventMode", 1 )
Opt( "MustDeclareVars", 1 )

; GUI globals
Global $hStatusbar = 0
Global $iStarsXpos = 0
Global $hStars = 0

; Project includes
#include "utilities\globals.au3"
#include "utilities\includes.au3"
#include "utilities\utils.au3"

; --- Program code ---

MainFunc()

While 1
	If $bResize Then
		ResizeOpenGLwindow( 0, 0, $iWidth, $iHeight, 45.0, 1.0, 100.0 )
		$fWidthHeightRatio = $iWidth / $iHeight / $fWidthHeightRatioInit
		$bResize = False
	EndIf
	DisplayFunction()
	Sleep(10)
WEnd


Func MainFunc()
	If Not InitGUIwindow() Then GUI_EVENT_CLOSE()
	If Not InitOpenGLwindowEx() Then GUI_EVENT_CLOSE()
	;If Not CreateResources() Then GUI_EVENT_CLOSE()
EndFunc


Func InitGUIwindow()

	$hGui = GUICreate( ScriptName(), $iGuiWidth, $iGuiHeight, 400, 50, $WS_OVERLAPPEDWINDOW )

	; Statusbar
	Local $idStatus
	$idStatus = GUICtrlCreateLabel( "", 0, $iHeight + 1, $iGuiWidth + 2, $iStatusBarHeight, $SS_ETCHEDFRAME )
	$idLabel = GUICtrlCreateLabel( "", 3, $iHeight + 1 + 6, $iGuiWidth - 6, $iStatusBarHeight - 10 )
	GUICtrlSetData( $idLabel, "Point follows mouse in a resizable window with a perspective view." )
	GUICtrlSetResizing( $idStatus, $GUI_DOCKSTATEBAR )
	GUICtrlSetResizing( $idLabel, $GUI_DOCKSTATEBAR )

	GUISetOnEvent( $GUI_EVENT_MAXIMIZE, "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESIZED,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESTORE,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_CLOSE,    "GUI_EVENT_CLOSE"  )

	GUIRegisterMsg( $WM_MOUSEMOVE, "WM_MOUSEMOVE" )

	Return 1

EndFunc


Func InitOpenGLwindowEx()

	$hOpenGL = GUICreate( "", $iWidth, $iHeight, 0, 0, $WS_CHILD, -1, $hGui )

	EnableOpenGL( $hOpenGL, $hDC, $hRC )

	glClearColor( 0.0, 0.0, 0.0, 0.0 )

	glEnable( $GL_POINT_SMOOTH )
	glPointSize( 10.0 )
	
	GUISetState()
	GUISwitch( $hGui )
	GUISetState()

	$bResize = True

	Return 1

EndFunc


Func CreateResources()
	Return 1
EndFunc


Func DisplayFunction()

	glClear( $GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT )
	glLoadIdentity()

	glTranslatef( 0, 0, -7 )

	Local $x0 = 4.95 * $fWidthHeightRatio, $y0 = 3.7, $x, $y
	$x = -$x0 + 2 * $x0 * ( $xMouse / $iWidth ) 
	$y = -$y0 + 2 * $y0 * ( $yMouse / $iHeight ) 

	glBegin( $GL_POINTS )
		glColor3f( 1.0, 0, 0 )
		glVertex3f( $x, -$y, -2 )
	glEnd()

	SwapBuffers( $hDC )

EndFunc


Func GUI_EVENT_CLOSE()
	DisableOpenGL( $hOpenGL, $hDC, $hRC )
	GUIDelete( $hGui )
	ExLauncherWin()
	CloseDlls()
	Exit
EndFunc
