#include-once

#include <EditConstants.au3>

Global $hStars = 0
Global $idShowStars, $idStars, $idSpeed, $idUpdStars
Global $newShow = $bShowStars, $newStars = $iStars, $newSpeed = $iSpeed, $bStars = False

Func StarsControls( $hWnd, $xPos, $yPos, $bDisableCheckbox = False )

	; Use a child window as a container for star controls
	$hStars = GUICreate( "", 320, 24, $xPos, $yPos, $WS_CHILD, -1, $hWnd )

	; Turn stars on/off
	$idShowStars = GUICtrlCreateCheckbox( "Stars", 2, 3, 50, 18 )
	GUICtrlSetState( $idShowStars, $GUI_CHECKED )
	If $bDisableCheckbox Then _
		GUICtrlSetState( $idShowStars, $GUI_DISABLE )
	GUICtrlSetOnEvent( $idShowStars, "ShowStars" )

	; Number of stars, 50 - 250
	GUICtrlCreateLabel( "Stars:", 62, 5, 32, 14 )
	$idStars = GUICtrlCreateInput( "25", 94, 2, 36, 20 )
	GUICtrlSetData( $idStars, $newStars / 10 )
	GUICtrlSetStyle( $idStars, $ES_READONLY )
	GUICtrlSetBkColor( $idStars, 0xFFFFFF )
	GUICtrlCreateUpdown( $idStars )
	GUICtrlSetLimit( -1, 25, 5 )
	GUICtrlCreateLabel( "x 10", 134, 5, 20, 14 )
	GUICtrlSetOnEvent( $idStars, "iStars" )

	; Velocity of stars, 1 - 5
	GUICtrlCreateLabel( "Speed:", 170, 5, 40, 14 )
	$idSpeed = GUICtrlCreateInput( "5", 210, 2, 36, 20 )
	GUICtrlSetData( $idSpeed, 6 - $newSpeed )
	GUICtrlSetStyle( $idSpeed, $ES_READONLY )
	GUICtrlSetBkColor( $idSpeed, 0xFFFFFF )
	GUICtrlCreateUpdown( $idSpeed )
	GUICtrlSetLimit( -1, 5, 1 )
	GUICtrlSetOnEvent( $idSpeed, "Speed" )

	; Implement settings
	$idUpdStars = GUICtrlCreateButton( "Stars", 266, 2, 50, 20 )
	GUICtrlSetState( $idUpdStars, $GUI_DISABLE )
	GUICtrlSetOnEvent( $idUpdStars, "Stars" )

	GUISetState( @SW_SHOW, $hStars )
	GUISwitch( $hWnd )

EndFunc


Func ShowStars()
	If GUICtrlRead( $idShowStars ) = $GUI_CHECKED Then
		$newShow = True
	Else
		$newShow = False
	EndIf
	SetStarsState()
EndFunc


Func iStars()
	$newStars = GUICtrlRead( $idStars ) * 10
	SetStarsState()
EndFunc


Func Speed()
	$newSpeed = 6 - GUICtrlRead( $idSpeed )
	SetStarsState()
EndFunc


Func SetStarsState()
	If $newShow  <> $bShowStars Or _
		 $newStars <> $iStars  Or _
		 $newSpeed <> $iSpeed  Then
		 GUICtrlSetState( $idUpdStars, $GUI_ENABLE )
	Else
		 GUICtrlSetState( $idUpdStars, $GUI_DISABLE )
	EndIf
EndFunc


Func Stars()
	$bStars = True
	GUICtrlSetState( $idUpdStars, $GUI_DISABLE )
EndFunc


Func StarsWinMove( $xPos, $yPos )
	WinMove( $hStars, "", $xPos, $yPos )
EndFunc
