        ; FASM assembler code

        ; $aStarsData = DllStructCreate( "float;float;uint[2];ptr[4];ushort" )
        ; Element 1, index 1,     offset  0 : Constant float: 5
        ; Element 2, index 1      offset  4 : Float: RGB color
        ; Element 3, index 1,     offset  8 : Uint $GL_LINE_STRIP
        ; Element 3, index 2,     offset 12 : Unused, added to secure 8 bytes memory alignment in x64
        ; Element 4, index 1 - 4, offset 16 : Pointers: glBegin, glColor3f, glVertex3f, glEnd  ; 8-bytes pointers in x64
        ; Element 5, index 1,     offset 48 : Ushort $iStars

        ; $aStars = DllStructCreate( "float[" & ( $iStars + 1 ) * 5 & "]" )

        ; For $i = 0 To $iStars
        ;
        ;   glBegin( $GL_LINE_STRIP )
        ;
        ;     ; Start point
        ;     glColor3f( 0, 0, 0 )
        ;     glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][2] ) ; p0: x,y,z
        ;
        ;     ; End point
        ;     $rgbColor = $aStars[$i][3] / 5
        ;     glColor3f( $rgbColor, $rgbColor, $rgbColor )
        ;     glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][3] ) ; p1: x,y,z
        ;
        ;     ; Start point = end point
        ;     $aStars[$i][2] = $aStars[$i][3] ; p0.z = p1.z
        ;
        ;     ; Increase z-coordinate of end point
        ;     $aStars[$i][3] += $aStars[$i][4] ; p1.z += dz
        ;
        ;     If $aStars[$i][2] >= 10 Then
        ;       $aStars[$i][2] = 0 ; p0.z
        ;       $aStars[$i][3] = 0 ; p1.z
        ;     EndIf
        ;
        ;   glEnd()
        ;
        ; Next

        ; Parameters:
        ; rcx : $iStars
        ; rdx : $pStars
        ; r8  : $pStarsData


        use64


        ; --- Initializations ---

        ; Handle parameters and fill in the $aStarsData table

        ; $iStars
        mov        r12,                rcx                 ; $iStars -> r12
        inc        r12                                     ; $iStars += 1

        ; r13 is pointer in $aStars table
        mov        r13,                rdx                 ; $aStars start

        ; r14 is pointer in $aStarsData table
        mov        r14,                r8                  ; $aStarsData start

        ; Initialize $i in iLoop
        mov        [r14 + 48],         word 0              ; This is $i in "For $i = 0 To $iStars"


        ; --- Calculations ---

iLoop:  ; For $i = 0 To $iStars

        ; glBegin( $GL_LINE_STRIP )
        sub        rsp,                40
        mov        ecx,                dword [r14 + 08]    ; $GL_LINE_STRIP
        call       qword [r14 + 16]                        ; glBegin
        add        rsp,                40

        ; Start point

        ; glColor3f( 0, 0, 0 ), black
        sub        rsp,                40
        xor        eax,                eax                 ; eax = 0
        cvtsi2ss   xmm0,               eax                 ; RGBcolor r
        movss      xmm1,               xmm0                ; RGBcolor g
        movss      xmm2,               xmm0                ; RGBcolor b
        call       qword [r14 + 24]                        ; glColor3f
        add        rsp,                40

        ; glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][2] ) ; p0: x,y,z
        sub        rsp,                40
        movss      xmm0,               dword [r13 + 00]    ; $aStars[$i][0]
        movss      xmm1,               dword [r13 + 04]    ; $aStars[$i][1]
        movss      xmm2,               dword [r13 + 08]    ; $aStars[$i][2]
        call       qword [r14 + 32]                        ; glVertex3f
        add        rsp,                40

        ; End point

        finit                                              ; Init FPU

        ;$rgbColor = $aStars[$i][3] / 5
        fld        dword [r13 + 12]                        ; $aStars[$i][3] -> st0
        fdiv       dword [r14 + 00]                        ; / 5
        fst        dword [r14 + 04]                        ; Store result, $rgbColor

        ; glColor3f( $rgbColor, $rgbColor, $rgbColor )
        sub        rsp,                40
        movss      xmm0,               dword [r14 + 04]    ; $rgbColor
        movss      xmm1,               xmm0                ; $rgbColor
        movss      xmm2,               xmm0                ; $rgbColor
        call       qword [r14 + 24]                        ; glColor3f
        add        rsp,                40

        ; glVertex3f( $aStars[$i][0], $aStars[$i][3], $aStars[$i][2] ) ; p1: x,y,z
        sub        rsp,                40
        movss      xmm0,               dword [r13 + 00]    ; $aStars[$i][0]
        movss      xmm1,               dword [r13 + 04]    ; $aStars[$i][1]
        movss      xmm2,               dword [r13 + 12]    ; $aStars[$i][3]
        call       qword [r14 + 32]                        ; glVertex3f
        add        rsp,                40

        ; Start point = end point
        ; $aStars[$i][2] = $aStars[$i][3] ; p0.z = p1.z
        fld        dword [r13 + 12]                        ; $aStars[$i][3] -> st0
        fst        dword [r13 + 08]                        ; st0 -> $aStars[$i][2]

        ; Increase z-coordinate of end point
        ; $aStars[$i][3] += $aStars[$i][4] ; p1.z += dz
        fadd       dword [r13 + 16]                        ; += $aStars[$i][4]
        fst        dword [r13 + 12]                        ; Store result

        ; If $aStars[$i][2] >= 10 Then
        fld        dword [r14 + 00]                        ; 5
        fadd       st0,                st0                 ; * 2 = 10
        fld        dword [r13 + 08]                        ; $aStars[$i][2] -> st0, st0 -> st1
        fcom                                               ; Compare st0 and st1 ( $aStars[$i][2] and 10 )
        fstsw      ax                                      ; Copy status word to ax
        sahf                                               ; Store ah into flags
        jb         Cont                                    ; Continue if $aStars[$i][2] < 10
        ; $aStars[$i][2] >= 10, reset z-coordinates to create a new star
        fldz                                               ; 0.0 -> st0
        fst        dword [r13 + 08]                        ; st0 -> $aStars[$i][2] = 0 ; p0.z
        fst        dword [r13 + 12]                        ; st0 -> $aStars[$i][3] = 0 ; p1.z

Cont:   ; glEnd()
        sub        rsp,                40
        call       qword [r14 + 40]                        ; glEnd
        add        rsp,                40

iNext:  ; For $i = 0 To $iStars

        add        r13,                20                  ; Next star

        inc        word [r14 + 48]                         ; This is $i in "For $i = 0 To $iStars", $i += 1
        cmp        r12w,               word [r14 + 48]     ; Compare $i with $iStars
        jne        iLoop                                   ; Jump to next star if not equal


        ret
