        ; FASM assembler code

        ; $aStarsData = DllStructCreate( "float;float;uint[2];ptr[4];ushort" )
        ; Element 1, index 1,     offset  0 : Constant float: 5
        ; Element 2, index 1      offset  4 : Float: RGB color
        ; Element 3, index 1,     offset  8 : Uint $GL_LINE_STRIP
        ; Element 3, index 2,     offset 12 : Unused, added to secure 8 bytes memory alignment in x64
        ; Element 4, index 1 - 4, offset 16 : Pointers: glBegin, glColor3f, glVertex3f, glEnd
        ; Element 5, index 1,     offset 32 : Ushort $iStars

        ; $aStars = DllStructCreate( "float[" & ( $iStars + 1 ) * 5 & "]" )

        ; For $i = 0 To $iStars
        ;
        ;   glBegin( $GL_LINE_STRIP )
        ;
        ;     ; Start point
        ;     glColor3f( 0, 0, 0 )
        ;     glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][2] ) ; p0: x,y,z
        ;
        ;     ; End point
        ;     $rgbColor = $aStars[$i][3] / 5
        ;     glColor3f( $rgbColor, $rgbColor, $rgbColor )
        ;     glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][3] ) ; p1: x,y,z
        ;
        ;     ; Start point = end point
        ;     $aStars[$i][2] = $aStars[$i][3] ; p0.z = p1.z
        ;
        ;     ; Increase z-coordinate of end point
        ;     $aStars[$i][3] += $aStars[$i][4] ; p1.z += dz
        ;
        ;     If $aStars[$i][2] >= 10 Then
        ;       $aStars[$i][2] = 0 ; p0.z
        ;       $aStars[$i][3] = 0 ; p1.z
        ;     EndIf
        ;
        ;   glEnd()
        ;
        ; Next

        ; Parameters:
        ; [ebp + 08] : $iStars
        ; [ebp + 12] : $pStars
        ; [ebp + 16] : $pStarsData


        use32
        push       ebp
        mov        ebp,                esp


        ; --- Initializations ---

        ; Handle parameters and fill in the $aStarsData table

        ; ebx is pointer in $aStars table
        mov        ebx,                [ebp + 12]          ; $aStars start

        ; ecx is pointer in $aStarsData table
        mov        ecx,                [ebp + 16]          ; $aStarsData start

        ; Initialize $i in iLoop
        mov        [ecx + 32],         word 0              ; This is $i in "For $i = 0 To $iStars"


        ; --- Calculations ---

iLoop:  ; For $i = 0 To $iStars

        ; glBegin( $GL_LINE_STRIP )
        pusha
        push       dword [ecx + 08]                        ; $GL_LINE_STRIP
        call       dword [ecx + 16]                        ; glBegin
        popa

        ; Start point

        ; glColor3f( 0, 0, 0 ), black
        pusha
        push       dword 0                                 ; RGBcolor b
        push       dword 0                                 ; RGBcolor g
        push       dword 0                                 ; RGBcolor r
        call       dword [ecx + 20]                        ; glColor3f
        popa

        ; glVertex3f( $aStars[$i][0], $aStars[$i][1], $aStars[$i][2] ) ; p0: x,y,z
        pusha
        push       dword [ebx + 08]                        ; $aStars[$i][2]
        push       dword [ebx + 04]                        ; $aStars[$i][1]
        push       dword [ebx + 00]                        ; $aStars[$i][0]
        call       dword [ecx + 24]                        ; glVertex3f
        popa

        ; End point

        finit                                              ; Init FPU

        ;$rgbColor = $aStars[$i][3] / 5
        fld        dword [ebx + 12]                        ; $aStars[$i][3] -> st0
        fdiv       dword [ecx + 00]                        ; / 5
        fst        dword [ecx + 04]                        ; Store result, $rgbColor

        ; glColor3f( $rgbColor, $rgbColor, $rgbColor )
        pusha
        push       dword [ecx + 04]                        ; $rgbColor
        push       dword [ecx + 04]                        ; $rgbColor
        push       dword [ecx + 04]                        ; $rgbColor
        call       dword [ecx + 20]                        ; glColor3f
        popa

        ; glVertex3f( $aStars[$i][0], $aStars[$i][3], $aStars[$i][2] ) ; p1: x,y,z
        pusha
        push       dword [ebx + 12]                        ; $aStars[$i][3]
        push       dword [ebx + 04]                        ; $aStars[$i][1]
        push       dword [ebx + 00]                        ; $aStars[$i][0]
        call       dword [ecx + 24]                        ; glVertex3f
        popa

        ; Start point = end point
        ; $aStars[$i][2] = $aStars[$i][3] ; p0.z = p1.z
        fld        dword [ebx + 12]                        ; $aStars[$i][3] -> st0
        fst        dword [ebx + 08]                        ; st0 -> $aStars[$i][2]

        ; Increase z-coordinate of end point
        ; $aStars[$i][3] += $aStars[$i][4] ; p1.z += dz
        fadd       dword [ebx + 16]                        ; += $aStars[$i][4]
        fst        dword [ebx + 12]                        ; Store result

        ; If $aStars[$i][2] >= 10 Then
        fld        dword [ecx + 00]                        ; 5
        fadd       st0,                st0                 ; * 2 = 10
        fld        dword [ebx + 08]                        ; $aStars[$i][2] -> st0, st0 -> st1
        fcom                                               ; Compare st0 and st1 ( $aStars[$i][2] and 10 )
        fstsw      ax                                      ; Copy status word to ax
        sahf                                               ; Store ah into flags
        jb         Cont                                    ; Continue if $aStars[$i][2] < 10
        ; $aStars[$i][2] >= 10, reset z-coordinates to create a new star
        fldz                                               ; 0.0 -> st0
        fst        dword [ebx + 08]                        ; st0 -> $aStars[$i][2] = 0 ; p0.z
        fst        dword [ebx + 12]                        ; st0 -> $aStars[$i][3] = 0 ; p1.z

Cont:   ; glEnd()
        pusha
        call       dword [ecx + 28]                        ; glEnd
        popa

iNext:  ; For $i = 0 To $iStars

        add        ebx,                20                  ; Next star

        inc        word [ecx + 32]                         ; This is $i in "For $i = 0 To $iStars", $i += 1
        mov        ax,                 [ebp + 08]          ; $iStars
        inc        ax                                      ; $iStars += 1
        cmp        ax,                 word [ecx + 32]     ; Compare $i with $iStars
        jne        iLoop                                   ; Jump to next star if not equal


        pop        ebp
        ret        12
