#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

Opt( "GUIOnEventMode", 1 )
Opt( "MustDeclareVars", 1 )

Global $iTexture, $iSideList, $iCornerList

Global $hGui, $hDC, $hRC, $bResize = True

#include "utilities\images.au3"
#include "utilities\includes.au3"
#include "utilities\utilities.au3"

MainFunc()

While 1
	If $bResize Then
		ResizeOpenGLwindow( 0, 0, $iWidth, $iHeight, 20, 5, 15 )
		$bResize = False
	EndIf
	DisplayFunction()
	Sleep(10)
WEnd

Func MainFunc()
	If Not InitOpenGLwindow() Then GUI_EVENT_CLOSE()
	If Not CreateResources() Then GUI_EVENT_CLOSE()
EndFunc

Func CreateResources()
	Local $w, $h
	If Not LoadTextureImage( $iTexture, $images & "\Cubes\Cube Homer Simpson.jpg", $w, $h ) Then Return 0
	glBindTexture( $GL_TEXTURE_2D, $iTexture )

	CreateCubeSides()
	CreateCubeCorners( $iCornerList, False )
	GUISetState()
	Return 1
EndFunc

Func CreateCubeSides()

	$iSideList = glGenLists( 1 )

	glNewList( $iSideList, $GL_COMPILE )

		; 6 sides
		glBegin( $GL_QUADS )

		  glColor3f( 1.0, 1.0, 1.0 )

			; Texture coordinates
			#cs#####################    Note how 0,0 migrate from upper left to lower right
			 1      2      3      4
			---    ---    ---    ---
			0,0    0,1    1,1    1,0
			1,0    0,0    0,1    1,1
			1,1    1,0    0,0    0,1
			0,1    1,1    1,0    0,0
			########################    Note how 1,1 migrate from upper left to lower right
			 5      6      7      8
			---    ---    ---    ---
			1,1    0,1    0,0    1,0
			1,0    1,1    0,1    0,0
			0,0    1,0    1,1    0,1
			0,1    0,0    1,0    1,1
			#ce#####################

			; Green side
			; Texture coordinates: #6
			glColor3f( 1.0, 1.0, 1.0 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f(   0.45, -0.45, -0.5 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f(   0.45,  0.45, -0.5 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f(  -0.45,  0.45, -0.5 )
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f(  -0.45, -0.45, -0.5 )

			; Blue side
			; Texture coordinates: #4
			glColor3f( 1.0, 1.0, 1.0 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f(   0.45, -0.45, 0.5 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f(   0.45,  0.45, 0.5 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f(  -0.45,  0.45, 0.5 )
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f(  -0.45, -0.45, 0.5 )

			; Red side
			; Texture coordinates: #1
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f( 0.5, -0.45, -0.45 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f( 0.5,  0.45, -0.45 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f( 0.5,  0.45,  0.45 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f( 0.5, -0.45,  0.45 )

			; Orange side
			; Texture coordinates: #1
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f(  -0.5, -0.45,  0.45 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f(  -0.5,  0.45,  0.45 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f(  -0.5,  0.45, -0.45 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f(  -0.5, -0.45, -0.45 )

			; White side
			; Texture coordinates: #3
			glColor3f( 1.0, 1.0, 1.0 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f(   0.45,  0.5,  0.45 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f(   0.45,  0.5, -0.45 )
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f(  -0.45,  0.5, -0.45 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f(  -0.45,  0.5,  0.45 )

			; Yellow side
			; Texture coordinates: #3
			glColor3f( 1.0, 1.0, 1.0 )
			glTexCoord2f( 1.0,   1.0 )
			glVertex3f(   0.45, -0.5, -0.45 )
			glTexCoord2f( 0.0,   1.0 )
			glVertex3f(   0.45, -0.5,  0.45 )
			glTexCoord2f( 0.0,   0.0 )
			glVertex3f(  -0.45, -0.5,  0.45 )
			glTexCoord2f( 1.0,   0.0 )
			glVertex3f(  -0.45, -0.5, -0.45 )

	  glEnd() ; Sides

	glEndList()

EndFunc

Func DisplayFunction()

	Local Static $angle = 0

	glClear( $GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT )
	glLoadIdentity()

	glTranslatef( 0, 0, -11 )
	glScalef( 2.0, 2.0, 2.0 )

	glRotatef( $angle, 1.0, 1.0, 0.0 )

	glCallList( $iSideList )
	glCallList( $iCornerList )

	SwapBuffers( $hDC )

	$angle += 1

EndFunc

Func GUI_EVENT_CLOSE()
	glDeleteLists( $iSideList, 1 )
	glDeleteLists( $iCornerList, 1 )
	glDeleteTextures( 1, $iTexture )
	DisableOpenGL( $hGui, $hDC, $hRC )
	GUIDelete( $hGui )
	ExLauncherWin()
	CloseDlls()
	Exit
EndFunc
