#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

Opt( "GUIOnEventMode", 1 )
Opt( "MustDeclareVars", 1 )

Global $nImages = 6

Global $aTextures[$nImages], $iSideList, $iCornerList

Global $hGui, $hDC, $hRC, $bResize = True

#include "utilities\images.au3"
#include "utilities\includes.au3"
#include "utilities\utilities.au3"
#include "utilities\cubes.au3"

MainFunc()

While 1
	If $bResize Then
		ResizeOpenGLwindow( 0, 0, $iWidth, $iHeight, 20, 5, 15 )
		$bResize = False
	EndIf
	DisplayFunction()
	Sleep(10)
WEnd

Func MainFunc()
	If Not InitOpenGLwindow() Then GUI_EVENT_CLOSE()
	If Not CreateResources() Then GUI_EVENT_CLOSE()
EndFunc

Func DisplayFunction()

	Local Static $angle = 0

	glClear( $GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT )
	glLoadIdentity()

	glTranslatef( 0, 0, -11 )
	glScalef( 2.0/3, 2.0/3, 2.0/3 )

	glRotatef( $angle, 1.0, 1.0, 0.0 )

	For $x = 0 To 2
		For $y = 0 To 2
			For $z = 0 To 2
				glPushMatrix()
				glTranslatef( $x-1, $y-1, $z-1 )
				glCallList( $iSideList )
				glCallList( $iCornerList )
				glPopMatrix()
			Next
		Next
	Next

	SwapBuffers( $hDC )

	$angle += 1

EndFunc

Func GUI_EVENT_CLOSE()
	glDeleteLists( $iSideList, 1 )
	glDeleteLists( $iCornerList, 1 )
	glDeleteTextures( $nImages, $aTextures )
	DisableOpenGL( $hGui, $hDC, $hRC )
	GUIDelete( $hGui )
	ExLauncherWin()
	CloseDlls()
	Exit
EndFunc
