; Constants and functions common to cube examples

#include-once

Global $iWidth	= 400
Global $iHeight	= 300

Global Const $iBorderWidth     =  4
Global Const $iTitleBarHeight  = 30

Func InitOpenGLwindow()

	$hGui = GUICreate( ScriptName(), $iWidth, $iHeight, 400, 100, $WS_OVERLAPPEDWINDOW )

	GUISetOnEvent( $GUI_EVENT_MAXIMIZE, "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESIZED,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_RESTORE,  "GUI_EVENT_RESIZE" )
	GUISetOnEvent( $GUI_EVENT_CLOSE,    "GUI_EVENT_CLOSE"  )

	If GetOpenGLContext( $hGui, $hDC, $hRC ) = 0 Then Return 0

	glClearColor( 0.8, 0.8, 0.8, 1.0 )

	glEnable( $GL_DEPTH_TEST )

	Return 1

EndFunc

Func CreateCubeCorners( ByRef $CallList, $fBlack = True )

	$CallList = glGenLists( 1 )

	glNewList( $CallList, $GL_COMPILE )

		; Corner color, black
		If $fBlack Then _
			glColor3f( 0.0, 0.0, 0.0 )

	  ; 8 corners
	  glBegin( $GL_TRIANGLES )

		  glVertex3f( 0.45, -0.45, -0.5  )
		  glVertex3f( 0.5,  -0.45, -0.45 )
		  glVertex3f( 0.45, -0.5,  -0.45 )

		  glVertex3f( 0.45, 0.45, -0.5  )
		  glVertex3f( 0.5,  0.45, -0.45 )
		  glVertex3f( 0.45, 0.5,  -0.45 )

		  glVertex3f( -0.45, 0.45, -0.5  )
		  glVertex3f( -0.5,  0.45, -0.45 )
		  glVertex3f( -0.45, 0.5,  -0.45 )

		  glVertex3f( -0.45, -0.45, -0.5  )
		  glVertex3f( -0.5,  -0.45, -0.45 )
		  glVertex3f( -0.45, -0.5,  -0.45 )

		  glVertex3f( 0.45, -0.45, 0.5  )
		  glVertex3f( 0.5,  -0.45, 0.45 )
		  glVertex3f( 0.45, -0.5,  0.45 )

		  glVertex3f( 0.45, 0.45, 0.5  )
		  glVertex3f( 0.5,  0.45, 0.45 )
		  glVertex3f( 0.45, 0.5,  0.45 )

		  glVertex3f( -0.45, 0.45, 0.5  )
		  glVertex3f( -0.5,  0.45, 0.45 )
		  glVertex3f( -0.45, 0.5,  0.45 )

		  glVertex3f( -0.45, -0.45, 0.5  )
		  glVertex3f( -0.5,  -0.45, 0.45 )
		  glVertex3f( -0.45, -0.5,  0.45 )

	  glEnd() ; Corners

	  ; 12 corner sides
	  glBegin( $GL_QUADS )

		  glVertex3f( 0.45, -0.45, -0.5  )
		  glVertex3f( 0.5,  -0.45, -0.45 )
		  glVertex3f( 0.5,   0.45, -0.45 )
		  glVertex3f( 0.45,  0.45, -0.5  )

		  glVertex3f(  0.45, 0.45, -0.5  )
		  glVertex3f(  0.45, 0.5,  -0.45 )
		  glVertex3f( -0.45, 0.5,  -0.45 )
		  glVertex3f( -0.45, 0.45, -0.5  )

		  glVertex3f( -0.45, -0.45, -0.5  )
		  glVertex3f( -0.5,  -0.45, -0.45 )
		  glVertex3f( -0.5,   0.45, -0.45 )
		  glVertex3f( -0.45,  0.45, -0.5  )

		  glVertex3f(  0.45, -0.45, -0.5  )
		  glVertex3f(  0.45, -0.5,  -0.45 )
		  glVertex3f( -0.45, -0.5,  -0.45 )
		  glVertex3f( -0.45, -0.45, -0.5  )

		  glVertex3f( 0.45, -0.45, 0.5  )
		  glVertex3f( 0.5,  -0.45, 0.45 )
		  glVertex3f( 0.5,   0.45, 0.45 )
		  glVertex3f( 0.45,  0.45, 0.5  )

		  glVertex3f(  0.45, 0.45, 0.5  )
		  glVertex3f(  0.45, 0.5,  0.45 )
		  glVertex3f( -0.45, 0.5,  0.45 )
		  glVertex3f( -0.45, 0.45, 0.5  )

		  glVertex3f( -0.45, -0.45, 0.5  )
		  glVertex3f( -0.5,  -0.45, 0.45 )
		  glVertex3f( -0.5,   0.45, 0.45 )
		  glVertex3f( -0.45,  0.45, 0.5  )

		  glVertex3f(  0.45, -0.45, 0.5  )
		  glVertex3f(  0.45, -0.5,  0.45 )
		  glVertex3f( -0.45, -0.5,  0.45 )
		  glVertex3f( -0.45, -0.45, 0.5  )

		  glVertex3f( 0.5,  -0.45, -0.45 )
		  glVertex3f( 0.5,  -0.45,  0.45 )
		  glVertex3f( 0.45, -0.5,   0.45 )
		  glVertex3f( 0.45, -0.5,  -0.45 )

		  glVertex3f( 0.5,  0.45, -0.45 )
		  glVertex3f( 0.5,  0.45,  0.45 )
		  glVertex3f( 0.45, 0.5,   0.45 )
		  glVertex3f( 0.45, 0.5,  -0.45 )

		  glVertex3f( -0.5,  -0.45, -0.45 )
		  glVertex3f( -0.5,  -0.45,  0.45 )
		  glVertex3f( -0.45, -0.5,   0.45 )
		  glVertex3f( -0.45, -0.5,  -0.45 )

		  glVertex3f( -0.5,  0.45, -0.45 )
		  glVertex3f( -0.5,  0.45,  0.45 )
		  glVertex3f( -0.45, 0.5,   0.45 )
		  glVertex3f( -0.45, 0.5,  -0.45 )

	  glEnd() ; Corner sides

	glEndList()

EndFunc

Func GUI_EVENT_RESIZE()
	Local $aPos = WinGetPos( $hGui )
	$iWidth = $aPos[2] - 2 * $iBorderWidth
	$iHeight = $aPos[3] - $iTitleBarHeight - $iBorderWidth
	$bResize = True
EndFunc
