        ; FASM assembler code

        ; Tunnel x,y-coordinates
        ; For $i = 0 To 12
        ;   For $j = 0 To 32
        ;     $aTunnel[$i][$j][0] = ( 3 - $j / 12 ) * Cos( 2 * $PI / 12 * $i ) + 2 * Sin( ( $fAngle + 2 * $j ) / 29 ) + Cos( ( $fAngle + 2 * $j ) / 13 ) - 2 * Sin( $fAngle / 29 ) - Cos( $fAngle / 13 )
        ;     $aTunnel[$i][$j][1] = ( 3 - $j / 12 ) * Sin( 2 * $PI / 12 * $i ) + 2 * Cos( ( $fAngle + 2 * $j ) / 33 ) + Sin( ( $fAngle + 2 * $j ) / 17 ) - 2 * Cos( $fAngle / 33 ) - Sin( $fAngle / 17 )
        ;   Next
        ; Next

        ; $aData1 = DllStructCreate( "ushort;ushort;ushort[6];float[6];ptr" )
        ; Element 1, offset  0 : ushort $i
        ; Element 2, offset  2 : ushort $j
        ; Element 3, offset  4 : ushort[6] for constants
        ; Element 4, offset 16 : float[6] for calculations
        ; Element 5, offset 40 : ptr $pTunnel

        ; DllStructSetData( $aData1, 1,  0 )        ; Element 1, index 1 : $i
        ; DllStructSetData( $aData1, 2,  0 )        ; Element 2, index 1 : $j
        ; DllStructSetData( $aData1, 3,  3, 1 )     ; Element 3, index 1 : constant 3
        ; DllStructSetData( $aData1, 3, 12, 2 )     ; Element 3, index 2 : constant 12
        ; DllStructSetData( $aData1, 3, 13, 3 )     ; Element 3, index 3 : constant 13
        ; DllStructSetData( $aData1, 3, 17, 4 )     ; Element 3, index 4 : constant 17
        ; DllStructSetData( $aData1, 3, 29, 5 )     ; Element 3, index 5 : constant 29
        ; DllStructSetData( $aData1, 3, 33, 6 )     ; Element 3, index 6 : constant 33
        ; DllStructSetData( $aData1, 4, $x, 1 )     ; Element 4, index 1 : constant 2 * $PI / 12
        ; DllStructSetData( $aData1, 5, $pTunnel )  ; Element 5, index 1 : $pTunnel

        ; Parameters:
        ; [ebp + 08] : $fAngle
        ; [ebp + 12] : $pData


        use32
        push       ebp
        mov        ebp,                esp


        ; --- Initializations ---

        ; ebx is pointer in $aData table
        mov        ebx,                [ebp + 12]          ; $aData start

        ; eax is pointer in $aTunnel table
        mov        eax,                dword [ebx + 40]    ; $aTunnel start

        ; Initialize iLoop
        mov        word  [ebx + 00],   0                   ; This is $i in "For $i = 0 To 12", $i = 0


        ; --- Calculations ---

iLoop:  ; For $i = 0 To 12

        finit                                              ; Init FPU

        ; Cos( 2 * $PI / 12 * $i ), Sin( 2 * $PI / 12 * $i )
        fild       word  [ebx + 00]                        ; $i
        fmul       dword [ebx + 16]                        ; * 2 * $PI / 12
        fsincos                                            ; cos -> st0, sin -> st1
        fstp       dword [ebx + 20]                        ; Store cos value in $aData offset 20, then st1 -> st0
        fst        dword [ebx + 24]                        ; Store sin value in $aData offset 24

        ; Initialize jLoop
        mov        word  [ebx + 02],   0                   ; This is $j in "For $j = 0 To 32", $j = 0

jLoop:  ; For $j = 0 To 32

        finit                                              ; Init FPU

        ; $fAngle + 2 * $j
        fild       word  [ebx + 02]                        ; $j -> st0
        fadd       st0,                st0                 ; * 2
        fadd       dword [ebp + 08]                        ; + $fAngle
        fst        dword [ebx + 28]                        ; Store value in $aData offset 28

        ; 3 - $j / 12
        fild       word  [ebx + 02]                        ; $j -> st0
        fidiv      word  [ebx + 06]                        ; / 12
        fchs                                               ; st0 = -st0
        fiadd      word  [ebx + 04]                        ; + 3
        fst        dword [ebx + 32]                        ; Store value in $aData offset 32

jNext:  ; For $j = 0 To 32

        add        eax,                12                  ; Next point in $aTunnel

        inc        word  [ebx + 02]                        ; This is $j in "For $j = 0 To 32", $j += 1
        cmp        word  [ebx + 02],   33                  ; $j = 33 ends the loop
        jne        jLoop                                   ; Jump to next loop

iNext:  ; For $i = 0 To 12

        inc        word  [ebx + 00]                        ; This is $i in "For $i = 0 To 12", $i += 1
        cmp        word  [ebx + 00],   13                  ; $i = 13 ends the loop
        jne        iLoop                                   ; Jump to next loop

        pop        ebp
        ret        8
