Global $hdc
#include "..\includes.au3"

Opt( "MustDeclareVars", 1 )

Global $aTunnelOld[13][33][3]
Global $aTunnel, $pTunnel

; FASM
Global $aData1, $pData1, $pCode1

If Not CreateResources() Then Exit
If Not GetFASMcode() Then Exit
DisplayFunction()
Exit

Func CreateResources()

	; Tunnel z-coordinates
	For $i = 0 To 12
		For $j = 0 To 32
			$aTunnelOld[$i][$j][2] = -$j
		Next
	Next

	$aTunnel = DllStructCreate( "float[" & 13 * 33 * 3 & "]" )
	$pTunnel = DllStructGetPtr( $aTunnel )

	; Tunnel z-coordinates
	Local $k = 3
	For $i = 0 To 12
		For $j = 0 To 32
			DllStructSetData( $aTunnel, 1, -$j, $k )
			$k += 3
		Next
	Next

	Return 1

EndFunc

Func GetFASMcode()

	; --- Fasm1 ---

	Local Static $oFasm1, $sCode1, $tCode1
	;Local Static $oFasm1, $aData1, $sCode1, $tCode1

	Local Const $PI = 3.14159265358979323846
	Local $x = 2 * $PI / 12

	; Fasm1 data

	; Tunnel x,y-coordinates
	; For $i = 0 To 12
	; 	For $j = 0 To 32
	; 		$aTunnel[$i][$j][0] = ( 3 - $j / 12 ) * Cos( 2 * $PI / 12 * $i ) + 2 * Sin( ( $fAngle + 2 * $j ) / 29 ) + Cos( ( $fAngle + 2 * $j ) / 13 ) - 2 * Sin( $fAngle / 29 ) - Cos( $fAngle / 13 )
	; 		$aTunnel[$i][$j][1] = ( 3 - $j / 12 ) * Sin( 2 * $PI / 12 * $i ) + 2 * Cos( ( $fAngle + 2 * $j ) / 33 ) + Sin( ( $fAngle + 2 * $j ) / 17 ) - 2 * Cos( $fAngle / 33 ) - Sin( $fAngle / 17 )
	; 	Next
	; Next

	$aData1 = DllStructCreate( "ushort;ushort;ushort[6];float[6];ptr" )
	; Element 1, offset  0 : ushort $i
	; Element 2, offset  2 : ushort $j
	; Element 3, offset  4 : ushort[6] for constants
	; Element 4, offset 16 : float[6] for calculations
	; Element 5, offset 40 : ptr $pTunnel

	DllStructSetData( $aData1, 1,  0 )				; Element 1, index 1 : $i
	DllStructSetData( $aData1, 2,  0 )				; Element 2, index 1 : $j
	DllStructSetData( $aData1, 3,  3, 1 )			; Element 3, index 1 : constant 3
	DllStructSetData( $aData1, 3, 12, 2 )			; Element 3, index 2 : constant 12
	DllStructSetData( $aData1, 3, 13, 3 )			; Element 3, index 3 : constant 13
	DllStructSetData( $aData1, 3, 17, 4 )			; Element 3, index 4 : constant 17
	DllStructSetData( $aData1, 3, 29, 5 )			; Element 3, index 5 : constant 29
	DllStructSetData( $aData1, 3, 33, 6 )			; Element 3, index 6 : constant 33
	DllStructSetData( $aData1, 4, $x, 1 )			; Element 4, index 1 : constant 2 * $PI / 12
	DllStructSetData( $aData1, 5, $pTunnel )	; Element 5, index 1 : $pTunnel

	$pData1 = DllStructGetPtr( $aData1 )

	; Fasm1 code

	If @AutoItX64 Then
		If Not ReadX64code( "fasm1-x64.bin", "fasm1-mk-x64-bin.au3", $sCode1 ) Then Return 0
		;If Not ReadX64code( "utilities\fasm\fasm1-x64.bin", "utilities\fasm\fasm1-mk-x64-bin.au3", $sCode1 ) Then Return 0
	Else
		$oFasm1 = FasmInit()
		If Not ReadFasmCode( "fasm1.asm", $oFasm1, $sCode1 ) Then Return 0
		;If Not ReadFasmCode( "utilities\fasm\fasm1.asm", $oFasm1, $sCode1 ) Then Return 0
		FasmExit( $oFasm1 )
	EndIf
	$pCode1 = _MemVirtualAlloc( 0, 1024, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE )
	$tCode1 = DllStructCreate( "byte[1024]", $pCode1 )
	DllStructSetData( $tCode1, 1, $sCode1 )

	Return 1

EndFunc

Func DisplayFunction()

	Local Const $PI = 3.14159265358979323846
	Local $fAngle = 30 * $PI / 180

	; --- Old ---

	#cs
	; Tunnel x,y-coordinates
	For $i = 0 To 12
		For $j = 0 To 32
			$aTunnelOld[$i][$j][0] = ( 3 - $j / 12 ) * Cos( 2 * $PI / 12 * $i ) + 2 * Sin( ( $fAngle + 2 * $j ) / 29 ) + Cos( ( $fAngle + 2 * $j ) / 13 ) - 2 * Sin( $fAngle / 29 ) - Cos( $fAngle / 13 )
			$aTunnelOld[$i][$j][1] = ( 3 - $j / 12 ) * Sin( 2 * $PI / 12 * $i ) + 2 * Cos( ( $fAngle + 2 * $j ) / 33 ) + Sin( ( $fAngle + 2 * $j ) / 17 ) - 2 * Cos( $fAngle / 33 ) - Sin( $fAngle / 17 )
		Next
	Next
	#ce

	; --- New ---

	DllCallAddress( "none", $pCode1, _
		"float", $fAngle, "ptr", $pData1 )

	Local $hFile = FileOpen( "Tunnel1.txt", 2 )

	FileWrite( $hFile, "$fAngle = " & $fAngle & @CRLF )
	FileWrite( $hFile, "Cos( 2 * $PI / 12 * 12 ) = " & DllStructGetData( $aData1, 4, 2 ) & @CRLF )
	FileWrite( $hFile, "Sin( 2 * $PI / 12 * 12 ) = " & DllStructGetData( $aData1, 4, 3 ) & @CRLF )
	FileWrite( $hFile, "$fAngle + 2 * 32 = " & DllStructGetData( $aData1, 4, 4 ) & @CRLF )
	FileWrite( $hFile, "3 - 32 / 12 = " & DllStructGetData( $aData1, 4, 5 ) & @CRLF & @CRLF )

	FileClose( $hFile )

EndFunc
