        ; FASM assembler code

        ; For $j = 0 To 30
        ;   $j1 = $j / 32 + $fAngle * 0.02
        ;   $j2 = ( $j + 1 ) / 32 + $fAngle * 0.02
        ; 
        ;   ; Fade the effect away near the end of the tunnel
        ;   If $j > 24 Then
        ;     $c = 1.0 - ( $j - 24 ) / 10
        ;   Else
        ;     $c = 1.0
        ;   EndIf
        ;   glColor3f( $c, $c, $c )
        ; 
        ;   glBegin( $GL_QUADS )
        ;     For $i = 0 To 11
        ;       glTexCoord2f( ( $i - 3 ) / 12, $j1 )
        ;       glVertex3f( $aTunnel[$i  ][$j  ][0], $aTunnel[$i  ][$j  ][1], $aTunnel[$i  ][$j  ][2] )
        ;       glTexCoord2f( ( $i - 2 ) / 12, $j1 )
        ;       glVertex3f( $aTunnel[$i+1][$j  ][0], $aTunnel[$i+1][$j  ][1], $aTunnel[$i+1][$j  ][2] )
        ;       glTexCoord2f( ( $i - 2 ) / 12, $j2 )
        ;       glVertex3f( $aTunnel[$i+1][$j+1][0], $aTunnel[$i+1][$j+1][1], $aTunnel[$i+1][$j+1][2] )
        ;       glTexCoord2f( ( $i - 3 ) / 12, $j2 )
        ;       glVertex3f( $aTunnel[$i  ][$j+1][0], $aTunnel[$i  ][$j+1][1], $aTunnel[$i  ][$j+1][2] )
        ;     Next
        ;   glEnd()
        ; Next

        ; $aData2 = DllStructCreate( "ushort;ushort;ushort[6];float[6];float[7];uint;ptr;ptr[5]" )
        ; Element 1, offset  0      : ushort $i
        ; Element 2, offset  2      : ushort $j
        ; Element 3, offset  4      : ushort[6] for constants
        ; Element 4, offset 16      : float[6] for calculations: 0.02, $j1, $j2, ( $i - 2 ) / 12, ( $i - 3 ) / 12
        ; Element 5, offset 40      : float[7] for 1.0 and $c = 1.0 - ( $j - 24 ) / 10, 25 <= $j <= 30
        ; Element 6, offset 68      : uint $GL_QUADS
        ; Element 7, offset 72      : ptr $pTunnel
        ; Element 8, offset 76 (80) : ptr[5]: glColor3f, glBegin, glTexCoord2f, glVertex3f, glEnd  ; 4/8-bytes pointers in x86/x64
        ; (The number in brackets is x64 offset)

        ; DllStructSetData( $aData2, 1,  0 )        ; Element 1, index 1 : $i
        ; DllStructSetData( $aData2, 2,  0 )        ; Element 2, index 1 : $j
        ; DllStructSetData( $aData2, 3,  2, 1 )     ; Element 3, index 1 : constant 2
        ; DllStructSetData( $aData2, 3,  3, 2 )     ; Element 3, index 2 : constant 3
        ; DllStructSetData( $aData2, 3, 12, 3 )     ; Element 3, index 3 : constant 12
        ; DllStructSetData( $aData2, 3, 32, 4 )     ; Element 3, index 4 : constant 32
        ; DllStructSetData( $aData2, 4, 0.02, 1 )   ; Element 4, index 1 : constant 0.02
        ; DllStructSetData( $aData2, 5, 1.0, 1 )    ; Element 5, index 1 : constant 1.0
        ; For $j = 25 To 30
        ;   DllStructSetData( $aData2, 5, 1.0 - ( $j - 24 ) / 10, $j - 23 )
        ; Next
        ; DllStructSetData( $aData2,6,$GL_QUADS,1 ) ; Element 6, index 1 : constant $GL_QUADS
        ; DllStructSetData( $aData2, 7, $pTunnel )  ; Element 7, index 1 : $pTunnel
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glColor3f" ),    1 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glBegin" ),      2 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glTexCoord2f" ), 3 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glVertex3f" ),   4 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glEnd" ),        5 )

        ; Parameters:
        ; [ebp + 08] : $fAngle
        ; [ebp + 12] : $pData


        use32
        push       ebp
        mov        ebp,                esp


        ; --- Initializations ---

        ; ebx is pointer in $aData table
        mov        ebx,                [ebp + 12]          ; $aData start

        ; Initialize jLoop
        mov        word  [ebx + 02],   0                   ; This is $j in "For $j = 0 To 30", $j = 0

        ; Initialize Column offset in $aTunnel
        mov        word  [ebx + 12],   0                   ; Column offset in $aTunnel, 12 bytes per column

        ; --- Calculations ---

jLoop:  ; For $j = 0 To 30, loop through the columns

        mov        eax,                dword [ebx + 72]    ; $aTunnel start
        add        ax,                 word  [ebx + 12]    ; Column offset, 12 bytes per column

        finit                                              ; Init FPU

        ; $j1 = $j / 32 + $fAngle * 0.02
        fild       word  [ebx + 02]                        ; $j
        fidiv      word  [ebx + 10]                        ; / 32
        fld        dword [ebp + 08]                        ; $fAngle -> st0, st0-> st1
        fmul       dword [ebx + 16]                        ; * 0.02
        fst        dword [ebx + 24]                        ; Store $fAngle * 0.02 in $aData offset 24
        fadd       st0,                st1                 ; + $j / 32
        fst        dword [ebx + 20]                        ; Store value in $aData offset 20

        ; $j2 = ( $j + 1 ) / 32 + $fAngle * 0.02
        fld1                                               ; +1.0 -> st0
        fiadd      word  [ebx + 02]                        ; + $j
        fidiv      word  [ebx + 10]                        ; / 32
        fadd       dword [ebx + 24]                        ; + $fAngle * 0.02
        fst        dword [ebx + 24]                        ; Store value in $aData offset 24

        ; If $j > 24 Then
        xor        ecx,                ecx                 ; ecx = 0, use ecx for calculations
        cmp        word  [ebx + 02],   24                  ; $j > 24?
        jbe        notgt24                                 ; If $j <= 24 then jump to notgt24
        ; Calculate index in the table with color ( $c ) values
        mov        cx,                 word [ebx + 02]     ; $j
        sub        cx,                 24                  ; - 24
        shl        ecx,                2                   ; * 4
notgt24:
        ; Else
        add        ecx,                ebx                 ; Add start of $aData table to ecx
        ; EndIf
        add        ecx,                40                  ; Add the base of the color values table

        ; glColor3f( $c, $c, $c )
        pusha
        push       dword [ecx]                             ; RGBcolor b
        push       dword [ecx]                             ; RGBcolor g
        push       dword [ecx]                             ; RGBcolor r
        call       dword [ebx + 76]                        ; glColor3f
        popa

        ; glBegin( $GL_QUADS )
        pusha
        push       dword [ebx + 68]                        ; $GL_QUADS
        call       dword [ebx + 80]                        ; glBegin
        popa

        ; Initialize iLoop
        mov        word  [ebx + 00],   0                   ; This is $i in "For $i = 0 To 11", $i = 0

iLoop:  ; For $i = 0 To 11, loop through the rows

iNext:  ; For $i = 0 To 11

        add        eax,                396                 ; Next row, 396 = 33 * 3 * 4 bytes per row, 33 (x,y,z) float points

        inc        word  [ebx + 00]                        ; This is $i in "For $i = 0 To 11", $i += 1
        cmp        word  [ebx + 00],   12                  ; $i = 12 ends the loop
        jne        iLoop                                   ; Jump to next loop

        ; glEnd()
        pusha
        call       dword [ebx + 92]                        ; glEnd
        popa

jNext:  ; For $j = 0 To 30

        add        word  [ebx + 12],   12                  ; Column offset in $aTunnel, 12 bytes per column

        inc        word  [ebx + 02]                        ; This is $j in "For $j = 0 To 30", $j += 1
        cmp        word  [ebx + 02],   31                  ; $j = 31 ends the loop
        jne        jLoop                                   ; Jump to next loop


        pop        ebp
        ret        8
