Global $hdc
#include "..\includes.au3"

Opt( "MustDeclareVars", 1 )

Global $aTunnelOld[13][33][3]
Global $aTunnel, $pTunnel

; FASM
Global $aData1, $pData1, $pCode1
Global $aData2, $pData2, $pCode2

If Not CreateResources() Then Exit
If Not GetFASMcode() Then Exit
DisplayFunction()
Exit

Func CreateResources()

	; Tunnel z-coordinates
	For $i = 0 To 12
		For $j = 0 To 32
			$aTunnelOld[$i][$j][2] = -$j
		Next
	Next

	$aTunnel = DllStructCreate( "float[" & 13 * 33 * 3 & "]" )
	$pTunnel = DllStructGetPtr( $aTunnel )

	; Tunnel z-coordinates
	Local $k = 3
	For $i = 0 To 12
		For $j = 0 To 32
			DllStructSetData( $aTunnel, 1, -$j, $k )
			$k += 3
		Next
	Next

	Return 1

EndFunc

Func GetFASMcode()

	; --- Fasm1 ---

	Local Static $oFasm1, $sCode1, $tCode1
	;Local Static $oFasm1, $aData1, $sCode1, $tCode1

	Local Const $PI = 3.14159265358979323846
	Local $x = 2 * $PI / 12

	; Fasm1 data

	; Tunnel x,y-coordinates
	; For $i = 0 To 12
	; 	For $j = 0 To 32
	; 		$aTunnel[$i][$j][0] = ( 3 - $j / 12 ) * Cos( 2 * $PI / 12 * $i ) + 2 * Sin( ( $fAngle + 2 * $j ) / 29 ) + Cos( ( $fAngle + 2 * $j ) / 13 ) - 2 * Sin( $fAngle / 29 ) - Cos( $fAngle / 13 )
	; 		$aTunnel[$i][$j][1] = ( 3 - $j / 12 ) * Sin( 2 * $PI / 12 * $i ) + 2 * Cos( ( $fAngle + 2 * $j ) / 33 ) + Sin( ( $fAngle + 2 * $j ) / 17 ) - 2 * Cos( $fAngle / 33 ) - Sin( $fAngle / 17 )
	; 	Next
	; Next

	$aData1 = DllStructCreate( "ushort;ushort;ushort[6];float[6];ptr" )
	; Element 1, offset  0 : ushort $i
	; Element 2, offset  2 : ushort $j
	; Element 3, offset  4 : ushort[6] for constants
	; Element 4, offset 16 : float[6] for calculations
	; Element 5, offset 40 : ptr $pTunnel

	DllStructSetData( $aData1, 1,  0 )				; Element 1, index 1 : $i
	DllStructSetData( $aData1, 2,  0 )				; Element 2, index 1 : $j
	DllStructSetData( $aData1, 3,  3, 1 )			; Element 3, index 1 : constant 3
	DllStructSetData( $aData1, 3, 12, 2 )			; Element 3, index 2 : constant 12
	DllStructSetData( $aData1, 3, 13, 3 )			; Element 3, index 3 : constant 13
	DllStructSetData( $aData1, 3, 17, 4 )			; Element 3, index 4 : constant 17
	DllStructSetData( $aData1, 3, 29, 5 )			; Element 3, index 5 : constant 29
	DllStructSetData( $aData1, 3, 33, 6 )			; Element 3, index 6 : constant 33
	DllStructSetData( $aData1, 4, $x, 1 )			; Element 4, index 1 : constant 2 * $PI / 12
	DllStructSetData( $aData1, 5, $pTunnel )	; Element 5, index 1 : $pTunnel

	$pData1 = DllStructGetPtr( $aData1 )

	; Fasm1 code

	If @AutoItX64 Then
		If Not ReadX64code( "fasm1-x64.bin", "fasm1-mk-x64-bin.au3", $sCode1 ) Then Return 0
		;If Not ReadX64code( "utilities\fasm\fasm1-x64.bin", "utilities\fasm\fasm1-mk-x64-bin.au3", $sCode1 ) Then Return 0
	Else
		$oFasm1 = FasmInit()
		If Not ReadFasmCode( "fasm1.asm", $oFasm1, $sCode1 ) Then Return 0
		;If Not ReadFasmCode( "utilities\fasm\fasm1.asm", $oFasm1, $sCode1 ) Then Return 0
		FasmExit( $oFasm1 )
	EndIf
	$pCode1 = _MemVirtualAlloc( 0, 1024, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE )
	$tCode1 = DllStructCreate( "byte[1024]", $pCode1 )
	DllStructSetData( $tCode1, 1, $sCode1 )

	; --- Fasm2 ---

	Local Static $oFasm2, $sCode2, $tCode2
	;Local Static $oFasm2, $aData2, $sCode2, $tCode2

	; Fasm2 data

	; For $j = 0 To 30
	; 	$j1 = $j / 32 + $fAngle * 0.02
	; 	$j2 = ( $j + 1 ) / 32 + $fAngle * 0.02
  ;
	; 	; Fade the effect away near the end of the tunnel
	; 	If $j > 24 Then
  ; 		$c = 1.0 - ( $j - 24 ) / 10
  ; 	Else
  ; 		$c = 1.0
  ; 	EndIf
  ; 	glColor3f( $c, $c, $c )
  ;
  ; 	glBegin( $GL_QUADS )
  ; 		For $i = 0 To 11
  ; 			glTexCoord2f( ( $i - 3 ) / 12, $j1 )
  ; 			glVertex3f( $aTunnel[$i  ][$j  ][0], $aTunnel[$i  ][$j  ][1], $aTunnel[$i  ][$j  ][2] )
  ; 			glTexCoord2f( ( $i - 2 ) / 12, $j1 )
  ; 			glVertex3f( $aTunnel[$i+1][$j  ][0], $aTunnel[$i+1][$j  ][1], $aTunnel[$i+1][$j  ][2] )
  ; 			glTexCoord2f( ( $i - 2 ) / 12, $j2 )
  ; 			glVertex3f( $aTunnel[$i+1][$j+1][0], $aTunnel[$i+1][$j+1][1], $aTunnel[$i+1][$j+1][2] )
  ; 			glTexCoord2f( ( $i - 3 ) / 12, $j2 )
  ; 			glVertex3f( $aTunnel[$i  ][$j+1][0], $aTunnel[$i  ][$j+1][1], $aTunnel[$i  ][$j+1][2] )
  ; 		Next
  ; 	glEnd()
  ; Next

	$aData2 = DllStructCreate( "ushort;ushort;ushort[6];float[6];float[7];uint;ptr;ptr[5]" )
	; Element 1, offset  0      : ushort $i
	; Element 2, offset  2      : ushort $j
	; Element 3, offset  4      : ushort[6] for constants
	; Element 4, offset 16      : float[6] for calculations: 0.02, $j1, $j2, ( $i - 2 ) / 12, ( $i - 3 ) / 12
	; Element 5, offset 40      : float[7] for 1.0 and $c = 1.0 - ( $j - 24 ) / 10, 25 <= $j <= 30
	; Element 6, offset 68      : uint $GL_QUADS
	; Element 7, offset 72      : ptr $pTunnel
	; Element 8, offset 76 (80) : ptr[5]: glColor3f, glBegin, glTexCoord2f, glVertex3f, glEnd  ; 4/8-bytes pointers in x86/x64
	; (The number in brackets is x64 offset)

	DllStructSetData( $aData2, 1,  0 )				; Element 1, index 1 : $i
	DllStructSetData( $aData2, 2,  0 )				; Element 2, index 1 : $j
	DllStructSetData( $aData2, 3,  2, 1 )			; Element 3, index 1 : constant 2
	DllStructSetData( $aData2, 3,  3, 2 )			; Element 3, index 2 : constant 3
	DllStructSetData( $aData2, 3, 12, 3 )			; Element 3, index 3 : constant 12
	DllStructSetData( $aData2, 3, 32, 4 )			; Element 3, index 4 : constant 32
	DllStructSetData( $aData2, 4, 0.02, 1 )		; Element 4, index 1 : constant 0.02
	DllStructSetData( $aData2, 5, 1.0, 1 )		; Element 5, index 1 : constant 1.0
	For $j = 25 To 30
		DllStructSetData( $aData2, 5, 1.0 - ( $j - 24 ) / 10, $j - 23 )
	Next
	DllStructSetData( $aData2,6,$GL_QUADS,1 )	; Element 6, index 1 : constant $GL_QUADS
	DllStructSetData( $aData2, 7, $pTunnel )	; Element 7, index 1 : $pTunnel
	DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glColor3f" ),    1 )
	DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glBegin" ),      2 )
	DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glTexCoord2f" ), 3 )
	DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glVertex3f" ),   4 )
	DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glEnd" ),        5 )

	$pData2 = DllStructGetPtr( $aData2 )

	; Fasm2 code

	If @AutoItX64 Then
		If Not ReadX64code( "fasm2-x64.bin", "fasm2-mk-x64-bin.au3", $sCode2 ) Then Return 0
		;If Not ReadX64code( "utilities\fasm\fasm2-x64.bin", "utilities\fasm\fasm2-mk-x64-bin.au3", $sCode2 ) Then Return 0
	Else
		$oFasm2 = FasmInit()
		If Not ReadFasmCode( "fasm2.asm", $oFasm2, $sCode2 ) Then Return 0
		;If Not ReadFasmCode( "utilities\fasm\fasm2.asm", $oFasm2, $sCode2 ) Then Return 0
		FasmExit( $oFasm2 )
	EndIf
	$pCode2 = _MemVirtualAlloc( 0, 1024, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE )
	$tCode2 = DllStructCreate( "byte[1024]", $pCode2 )
	DllStructSetData( $tCode2, 1, $sCode2 )

	Return 1

EndFunc

Func DisplayFunction()

	Local Const $PI = 3.14159265358979323846
	Local $fAngle = 30 * $PI / 180

	; --- Old ---

	#cs
	; Tunnel x,y-coordinates
	For $i = 0 To 12
		For $j = 0 To 32
			$aTunnelOld[$i][$j][0] = ( 3 - $j / 12 ) * Cos( 2 * $PI / 12 * $i ) + 2 * Sin( ( $fAngle + 2 * $j ) / 29 ) + Cos( ( $fAngle + 2 * $j ) / 13 ) - 2 * Sin( $fAngle / 29 ) - Cos( $fAngle / 13 )
			$aTunnelOld[$i][$j][1] = ( 3 - $j / 12 ) * Sin( 2 * $PI / 12 * $i ) + 2 * Cos( ( $fAngle + 2 * $j ) / 33 ) + Sin( ( $fAngle + 2 * $j ) / 17 ) - 2 * Cos( $fAngle / 33 ) - Sin( $fAngle / 17 )
		Next
	Next

	Local $hFileOld = FileOpen( "Tunnel1Old.txt", 2 ), $s

	FileWrite( $hFileOld, "$i = 3" & @CRLF )
	For $j = 0 To 32
		$s = StringFormat( "%2s: ", $j )
		FileWrite( $hFileOld, $s & "x = " & StringFormat( "%.5f", $aTunnelOld[3][$j][0] ) & @CRLF )
		FileWrite( $hFileOld, $s & "y = " & StringFormat( "%.5f", $aTunnelOld[3][$j][1] ) & @CRLF )
		FileWrite( $hFileOld, $s & "z = " & $aTunnelOld[3][$j][2] & @CRLF )
	Next

	FileClose( $hFileOld )
	#ce

	; --- New ---

	DllCallAddress( "none", $pCode1, _
		"float", $fAngle, "ptr", $pData1 )

	#cs
	Local $hFile = FileOpen( "Tunnel1.txt", 2 ), $s

	;FileWrite( $hFile, "$fAngle = " & $fAngle & @CRLF )
	;FileWrite( $hFile, "Cos( 2 * $PI / 12 * 12 ) = " & DllStructGetData( $aData1, 4, 2 ) & @CRLF )
	;FileWrite( $hFile, "Sin( 2 * $PI / 12 * 12 ) = " & DllStructGetData( $aData1, 4, 3 ) & @CRLF )
	;FileWrite( $hFile, "$fAngle + 2 * 32 = " & DllStructGetData( $aData1, 4, 4 ) & @CRLF )
	;FileWrite( $hFile, "3 - 32 / 12 = " & DllStructGetData( $aData1, 4, 5 ) & @CRLF & @CRLF )

	FileWrite( $hFile, "$i = 3" & @CRLF )
	Local $k = 3 * 33 * 3
	For $j = 0 To 32
		$s = StringFormat( "%2s: ", $j )
		FileWrite( $hFile, $s & "x = " & StringFormat( "%.5f", DllStructGetData( $aTunnel, 1, $k+1 ) ) & @CRLF )
		FileWrite( $hFile, $s & "y = " & StringFormat( "%.5f", DllStructGetData( $aTunnel, 1, $k+2 ) ) & @CRLF )
		FileWrite( $hFile, $s & "z = " & DllStructGetData( $aTunnel, 1, $k+3 ) & @CRLF )
		$k += 3
	Next

	FileClose( $hFile )
	#ce

	Local $hFile = FileOpen( "Tunnel2.txt", 2 ), $s

	DllCallAddress( "none", $pCode2, _
		"float", $fAngle, "ptr", $pData2 )

	FileWrite( $hFile, "$j = 30" & @CRLF )
	FileWrite( $hFile, "$fAngle = " & $fAngle & @CRLF )
	FileWrite( $hFile, "$j1 = $j / 32 + $fAngle * 0.02 = " & DllStructGetData( $aData2, 4, 2 ) & @CRLF )
	FileWrite( $hFile, "$j2 = ( $j + 1 ) / 32 + $fAngle * 0.02 = " & DllStructGetData( $aData2, 4, 3 ) & @CRLF )

	FileClose( $hFile )

EndFunc
