        ; FASM assembler code

        ; For $j = 0 To 30
        ;   $j1 = $j / 32 + $fAngle * 0.02
        ;   $j2 = ( $j + 1 ) / 32 + $fAngle * 0.02
        ; 
        ;   ; Fade the effect away near the end of the tunnel
        ;   If $j > 24 Then
        ;     $c = 1.0 - ( $j - 24 ) / 10
        ;   Else
        ;     $c = 1.0
        ;   EndIf
        ;   glColor3f( $c, $c, $c )
        ; 
        ;   glBegin( $GL_QUADS )
        ;     For $i = 0 To 11
        ;       glTexCoord2f( ( $i - 3 ) / 12, $j1 )
        ;       glVertex3f( $aTunnel[$i  ][$j  ][0], $aTunnel[$i  ][$j  ][1], $aTunnel[$i  ][$j  ][2] )
        ;       glTexCoord2f( ( $i - 2 ) / 12, $j1 )
        ;       glVertex3f( $aTunnel[$i+1][$j  ][0], $aTunnel[$i+1][$j  ][1], $aTunnel[$i+1][$j  ][2] )
        ;       glTexCoord2f( ( $i - 2 ) / 12, $j2 )
        ;       glVertex3f( $aTunnel[$i+1][$j+1][0], $aTunnel[$i+1][$j+1][1], $aTunnel[$i+1][$j+1][2] )
        ;       glTexCoord2f( ( $i - 3 ) / 12, $j2 )
        ;       glVertex3f( $aTunnel[$i  ][$j+1][0], $aTunnel[$i  ][$j+1][1], $aTunnel[$i  ][$j+1][2] )
        ;     Next
        ;   glEnd()
        ; Next

        ; $aData2 = DllStructCreate( "ushort;ushort;ushort[6];float[6];float[7];uint;ptr;ptr[5]" )
        ; Element 1, offset  0      : ushort $i
        ; Element 2, offset  2      : ushort $j
        ; Element 3, offset  4      : ushort[6] for constants
        ; Element 4, offset 16      : float[6] for calculations: 0.02, $j1, $j2, ( $i - 2 ) / 12, ( $i - 3 ) / 12
        ; Element 5, offset 40      : float[7] for 1.0 and $c = 1.0 - ( $j - 24 ) / 10, 25 <= $j <= 30
        ; Element 6, offset 68      : uint $GL_QUADS
        ; Element 7, offset 72      : ptr $pTunnel
        ; Element 8, offset 76 (80) : ptr[5]: glColor3f, glBegin, glTexCoord2f, glVertex3f, glEnd  ; 4/8-bytes pointers in x86/x64
        ; (The number in brackets is x64 offset)

        ; DllStructSetData( $aData2, 1,  0 )        ; Element 1, index 1 : $i
        ; DllStructSetData( $aData2, 2,  0 )        ; Element 2, index 1 : $j
        ; DllStructSetData( $aData2, 3,  2, 1 )     ; Element 3, index 1 : constant 2
        ; DllStructSetData( $aData2, 3,  3, 2 )     ; Element 3, index 2 : constant 3
        ; DllStructSetData( $aData2, 3, 12, 3 )     ; Element 3, index 3 : constant 12
        ; DllStructSetData( $aData2, 3, 32, 4 )     ; Element 3, index 4 : constant 32
        ; DllStructSetData( $aData2, 4, 0.02, 1 )   ; Element 4, index 1 : constant 0.02
        ; DllStructSetData( $aData2, 5, 1.0, 1 )    ; Element 5, index 1 : constant 1.0
        ; For $j = 25 To 30
        ;   DllStructSetData( $aData2, 5, 1.0 - ( $j - 24 ) / 10, $j - 23 )
        ; Next
        ; DllStructSetData( $aData2,6,$GL_QUADS,1 ) ; Element 6, index 1 : constant $GL_QUADS
        ; DllStructSetData( $aData2, 7, $pTunnel )  ; Element 7, index 1 : $pTunnel
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glColor3f" ),    1 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glBegin" ),      2 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glTexCoord2f" ), 3 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glVertex3f" ),   4 )
        ; DllStructSetData( $aData2, 8, GetProcAddress( "opengl32.dll", "glEnd" ),        5 )

        ; Parameters:
        ; xmm0 : $fAngle
        ; rdx  : $pData


        use64


        ; --- Initializations ---

        ; r12 is pointer in $aData table
        mov        r12,                rdx                 ; $aData start

        ; Store $fAngle in $aData offset 36
        movss      [r12 + 36],         xmm0                ; $fAngle -> $aData offset 36

        ; Initialize jLoop
        mov        word  [r12 + 02],   0                   ; This is $j in "For $j = 0 To 30", $j = 0

        ; Initialize Column offset in $aTunnel
        mov        word  [r12 + 12],   0                   ; Column offset in $aTunnel, 12 bytes per column

        ; --- Calculations ---

jLoop:  ; For $j = 0 To 30, loop through the columns

				xor        r13,                r13                 ; r13 = 0
        mov        r13d,               dword [r12 + 72]    ; $aTunnel start
        add        r13w,               word  [r12 + 12]    ; Column offset, 12 bytes per column

        finit                                              ; Init FPU

        ; $j1 = $j / 32 + $fAngle * 0.02
        fild       word  [r12 + 02]                        ; $j
        fidiv      word  [r12 + 10]                        ; / 32
        fld        dword [r12 + 36]                        ; $fAngle -> st0, st0-> st1
        fmul       dword [r12 + 16]                        ; * 0.02
        fst        dword [r12 + 24]                        ; Store $fAngle * 0.02 in $aData offset 24
        fadd       st0,                st1                 ; + $j / 32
        fst        dword [r12 + 20]                        ; Store value in $aData offset 20

        ; $j2 = ( $j + 1 ) / 32 + $fAngle * 0.02
        fld1                                               ; +1.0 -> st0
        fiadd      word  [r12 + 02]                        ; + $j
        fidiv      word  [r12 + 10]                        ; / 32
        fadd       dword [r12 + 24]                        ; + $fAngle * 0.02
        fst        dword [r12 + 24]                        ; Store value in $aData offset 24

        ; If $j > 24 Then
        xor        rcx,                rcx                 ; rcx = 0, use rcx for calculations
        cmp        word  [r12 + 02],   24                  ; $j > 24?
        jbe        notgt24                                 ; If $j <= 24 then jump to notgt24
        ; Calculate index in the table with color ( $c ) values
        mov        cx,                 word  [r12 + 02]    ; $j
        sub        cx,                 24                  ; - 24
        shl        ecx,                2                   ; * 4
notgt24:
        ; Else
        add        rcx,                r12                 ; Add start of $aData table to rcx
        ; EndIf
        add        rcx,                40                  ; Add the base of the color values table

        ; glColor3f( $c, $c, $c )
        sub        rsp,                40
        movss      xmm0,               dword [rcx]         ; RGBcolor r
        movss      xmm1,               dword [rcx]         ; RGBcolor g
        movss      xmm2,               dword [rcx]         ; RGBcolor b
        call       qword [r12 + 80]                        ; glColor3f
        add        rsp,                40

        ; glBegin( $GL_QUADS )
        sub        rsp,                40
        mov        ecx,                dword [r12 + 68]    ; $GL_QUADS
        call       qword [r12 + 88]                        ; glBegin
        add        rsp,                40

        ; Initialize iLoop
        mov        word  [r12 + 00],   0                   ; This is $i in "For $i = 0 To 11", $i = 0

iLoop:  ; For $i = 0 To 11, loop through the rows

        finit                                              ; Init FPU

        ; ( $i - 2 ) / 12
        fild       word  [r12 + 00]                        ; $i
        fisub      word  [r12 + 04]                        ; - 2
        fidiv      word  [r12 + 08]                        ; / 12
        fst        dword [r12 + 28]                        ; Store value in $aData offset 28

        ; ( $i - 3 ) / 12
        fild       word  [r12 + 00]                        ; $i
        fisub      word  [r12 + 06]                        ; - 3
        fidiv      word  [r12 + 08]                        ; / 12
        fst        dword [r12 + 32]                        ; Store value in $aData offset 32

        ; glTexCoord2f( ( $i - 3 ) / 12, $j1 )
        sub        rsp,                40
        movss      xmm0,               dword [r12 + 32]    ; ( $i - 3 ) / 12
        movss      xmm1,               dword [r12 + 20]    ; $j1
        call       qword [r12 + 96]                        ; glTexCoord2f
        add        rsp,                40

        ; glVertex3f( $aTunnel[$i][$j]x,y,z )
        sub        rsp,                40
        movss      xmm0,               dword [r13 + 00]    ; x
        movss      xmm1,               dword [r13 + 04]    ; y
        movss      xmm2,               dword [r13 + 08]    ; z
        call       qword [r12 + 104]                       ; glVertex3f
        add        rsp,                40

        ; glTexCoord2f( ( $i - 2 ) / 12, $j1 )
        sub        rsp,                40
        movss      xmm0,               dword [r12 + 28]    ; ( $i - 2 ) / 12
        movss      xmm1,               dword [r12 + 20]    ; $j1
        call       qword [r12 + 96]                        ; glTexCoord2f
        add        rsp,                40

        ; glVertex3f( $aTunnel[$i+1][$j]x,y,z )
        sub        rsp,                40
        movss      xmm0,               dword [r13+396 + 00]; x
        movss      xmm1,               dword [r13+396 + 04]; y
        movss      xmm2,               dword [r13+396 + 08]; z
        call       qword [r12 + 104]                       ; glVertex3f
        add        rsp,                40

        ; glTexCoord2f( ( $i - 2 ) / 12, $j2 )
        sub        rsp,                40
        movss      xmm0,               dword [r12 + 28]    ; ( $i - 2 ) / 12
        movss      xmm1,               dword [r12 + 24]    ; $j2
        call       qword [r12 + 96]                        ; glTexCoord2f
        add        rsp,                40

        ; glVertex3f( $aTunnel[$i+1][$j+1]x,y,z )
        sub        rsp,                40
        movss      xmm0,               dword [r13+408 + 00]; x
        movss      xmm1,               dword [r13+408 + 04]; y
        movss      xmm2,               dword [r13+408 + 08]; z
        call       qword [r12 + 104]                       ; glVertex3f
        add        rsp,                40

        ; glTexCoord2f( ( $i - 3 ) / 12, $j2 )
        sub        rsp,                40
        movss      xmm0,               dword [r12 + 32]    ; ( $i - 3 ) / 12
        movss      xmm1,               dword [r12 + 24]    ; $j2
        call       qword [r12 + 96]                        ; glTexCoord2f
        add        rsp,                40

        ; glVertex3f( $aTunnel[$i][$j+1]x,y,z )
        sub        rsp,                40
        movss      xmm0,               dword [r13+12 + 00] ; x
        movss      xmm1,               dword [r13+12 + 04] ; y
        movss      xmm2,               dword [r13+12 + 08] ; z
        call       qword [r12 + 104]                       ; glVertex3f
        add        rsp,                40

iNext:  ; For $i = 0 To 11

        add        r13,                396                 ; Next row, 396 = 33 * 3 * 4 bytes per row, 33 (x,y,z) float points

        inc        word  [r12 + 00]                        ; This is $i in "For $i = 0 To 11", $i += 1
        cmp        word  [r12 + 00],   12                  ; $i = 12 ends the loop
        jne        iLoop                                   ; Jump to next loop

        ; glEnd()
        sub        rsp,                40
        call       qword [r12 + 112]                       ; glEnd
        add        rsp,                40

jNext:  ; For $j = 0 To 30

        add        word  [r12 + 12],   12                  ; Column offset in $aTunnel, 12 bytes per column

        inc        word  [r12 + 02]                        ; This is $j in "For $j = 0 To 30", $j += 1
        cmp        word  [r12 + 02],   31                  ; $j = 31 ends the loop
        jne        jLoop                                   ; Jump to next loop


        ret
