#include-once

Global $hProgress, $idProgress1, $idProgress2, $idProLabel

Global $hStatusbar, $idRotate
Global $bRotate = False

Func CreateProgressbar()

	Local $w = 220, $h = 85, $x = ( $iWidth - $w ) / 2, $y = ( $iHeight - $h ) / 2

	; Use a child window as a container for controls in the Statusbar
	$hProgress = GUICreate( "", $w, $h, $x, $y, $WS_CHILD, -1, $hGui )

	GUICtrlCreateLabel( "Generating graph data", 10, 2, 200, 17, $SS_CENTER )
	$idProgress1 = GUICtrlCreateProgress( 10, 25, 200, 20 )
	$idProgress2 = GUICtrlCreateProgress( 10, 55, 200, 20 )

	GUISetState( @SW_SHOW, $hProgress )
	GUISwitch( $hGui )

	; Label for $hProgress to make it look nicer
	$idProLabel = GUICtrlCreateLabel( "", $x - 2, $y - 2, $w + 4, $h + 4, $SS_ETCHEDFRAME )
	GUICtrlSetResizing( -1, $GUI_DOCKSIZE )

EndFunc

Func UpdateProgressBar( $id, $n, $max )
	Local $pct = $n / $max * 100
	GUICtrlSetData( $id, $pct )
EndFunc

Func CreateStatusbar( $ex )

	; Use a child window as a container for controls in the Statusbar
	$hStatusbar = GUICreate( "", $iGuiWidth - 4 , 24, 2, $iHeight + $iStatusBarHeight + 3 , $WS_CHILD, -1, $hGui )

	; Show points
	$idRotate = GUICtrlCreateCheckbox( "Rotate", 2, 3, 60, 18 )
	GUICtrlSetOnEvent( $idRotate, "Rotate" )

	; Vertical splitterbar
	GUICtrlCreateLabel( "", 65, 2, 3, 20, $SS_ETCHEDFRAME )

	; Label in statusbar
	GUICtrlCreateLabel( "", 85, 5, 400, 14 )
	GUICtrlSetData( -1, "Use arrow keys to move. Page up/down to zoom. Home to reset. R to rotate." )

	GUISetState( @SW_SHOW, $hStatusbar )
	GUISwitch( $hGui )

	; Label for $hStatusbar to make it look nicer
	GUICtrlCreateLabel( "", 0, $iHeight + 1, $iGuiWidth + 4, $iStatusBarHeight + 1, $SS_ETCHEDFRAME )
	GUICtrlSetResizing( -1, $GUI_DOCKSTATEBAR )
	If $ex = 4 Then
		GUICtrlCreateLabel( "Plotting a three-dimensional graph.", _
												3, $iHeight + 1 + 6, $iGuiWidth - 6, $iStatusBarHeight - 10 )
	ElseIf $ex = 5 Then
		GUICtrlCreateLabel( "Plotting a surface with hidden line removal.", _
												3, $iHeight + 1 + 6, $iGuiWidth - 6, $iStatusBarHeight - 10 )
	EndIf
	GUICtrlSetResizing( -1, $GUI_DOCKSTATEBAR )

EndFunc

Func Rotate()
	$bRotate = Not $bRotate
EndFunc

Func CalcElapsedTime()
  If $bRotate Then
		If Not $iStartTime Then _
			$iStartTime = TimerInit()
		$fElapsedTime = TimerDiff( $iStartTime )
		$fElapsedTime = ( $fLastTime + $fLastElapsed + $fElapsedTime ) / 2 + 0.0
		$fLastTime = $fElapsedTime
  Else
		If $iStartTime Then
			$fLastElapsed = $fElapsedTime
			$iStartTime = 0
		EndIf
	EndIf
EndFunc

Func HandleKeystrokes()

	Local Static $bKey = 0, $nKey = 0
	Local Static $nStrokes = 0

	Select
		Case _IsPressed( "21", $dllUser32 ) ; Page up
			$bKey = 1
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "22", $dllUser32 ) ; Page down
			$bKey = 2
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "24", $dllUser32 ) ; Home
			$bKey = 3
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "25", $dllUser32 ) ; Left
			$bKey = 4
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "27", $dllUser32 ) ; Right
			$bKey = 5
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "26", $dllUser32 ) ; Up
			$bKey = 6
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "28", $dllUser32 ) ; Down
			$bKey = 7
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "52", $dllUser32 ) ; R key
			$bKey = 8
			if Not $nKey Then $nKey = 1
		Case Else
			$nKey = 0
			Return
	EndSelect

	If $nKey = 1 Or $nKey = 3 Then
		Switch $bKey
			Case 1 ; Page up
				$fScale /= 1.02
			Case 2 ; Page down
				$fScale *= 1.02
			Case 3 ; Home
				$fScale = 1.0
				$fOffsetX = 0.0
				$fOffsetY = 0.0
				$fLastTime = 0.0
				$fLastElapsed = 0.0
				$fElapsedTime = 0.0
				$iStartTime = 0
				$bRotate = False
				GUICtrlSetState( $idRotate, $GUI_UNCHECKED )
			Case 4 ; Left
				$fOffsetX += 0.02
			Case 5 ; Right
				$fOffsetX -= 0.02
			Case 6 ; Up
				$fOffsetY -= 0.02
			Case 7 ; Down
				$fOffsetY += 0.02
			Case 8 ; R key
				$bRotate = Not $bRotate
				If $bRotate Then
					GUICtrlSetState( $idRotate, $GUI_CHECKED )
				Else
					GUICtrlSetState( $idRotate, $GUI_UNCHECKED )
				EndIf
		EndSwitch
		$bKey = 0
	EndIf

	Switch $nKey
		Case 1
			; First keypress
			$nKey = 2
			$nStrokes = 0
		Case 2
			; Wait a few loops for next keypress
			; To get time to release the key for a single keypress
			$nStrokes += 1
			If $nStrokes > 3 Then _
				$nKey = 3
	EndSwitch

EndFunc

Func WM_SIZING( $hWnd, $iMsg, $iwParam, $ilParam )
	Switch $hWnd
		Case $hGui
			If $hProgress Then
				Local $aPos = ControlGetPos( $hGui, "", $idProLabel )
				WinMove( $hProgress, "", $aPos[0] + $iHeightXP - 1, $aPos[1] + $iHeightXP - 1 )
			EndIf
			Local $tRECT = DllStructCreate( $tagRECT, $ilParam )
			Local $y = DllStructGetData( $tRECT, "Top" )
			Local $iHeight = DllStructGetData( $tRECT, "Bottom" ) - $y - $iTitleBarHeight - $iBorderWidth - $iStatusBarHeight
			WinMove( $hStatusbar, "", 2, $iHeight + $iHeightXP )
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc

Func GUI_EVENT_RESIZE()
	If $hProgress Then
		Local $aPos = ControlGetPos( $hGui, "", $idProLabel )
		WinMove( $hProgress, "", $aPos[0] + $iHeightXP - 1, $aPos[1] + $iHeightXP - 1 )
	EndIf
	Local $aPos = WinGetPos( $hGui )
	$iWidth = $aPos[2] - 2 * $iBorderWidth
	$iHeight = $aPos[3] - $iTitleBarHeight - $iBorderWidth - $iStatusBarHeight * $iStatusBarRows
	WinMove( $hOpenGL, "", 0, 0, $iWidth, $iHeight )
	WinMove( $hStatusbar, "", 2, $iHeight + $iHeightXP + $iStatusBarHeight * ( $iStatusBarRows - 1 ) )
	$bResize = True
EndFunc

Func GUI_EVENT_CLOSE()
	glDeleteProgram( $iProgram )
  glDeleteTextures( 1, $iTextureId )
	glDeleteBuffers( UBound( $aVbo ), $aVbo )
	DisableOpenGL( $hOpenGL, $hDC, $hRC )
	GUIDelete( $hGui )
	ExLauncherWin()
	CloseDlls()
	Exit
EndFunc
