#include-once

Global $fSwapMouseButtons = False
Global $bArcballOn = False
Global $thisMousePos[2]
Global $lastMousePos[2]

GUIRegisterMsg( $WM_LBUTTONDOWN,   "WM_LBUTTONDOWN"   )
GUIRegisterMsg( $WM_LBUTTONUP,     "WM_LBUTTONUP"     )
GUIRegisterMsg( $WM_RBUTTONDOWN,   "WM_RBUTTONDOWN"   )
GUIRegisterMsg( $WM_RBUTTONUP,     "WM_RBUTTONUP"     )
GUIRegisterMsg( $WM_MOUSEMOVE,     "WM_MOUSEMOVE"     )

Func WM_LBUTTONDOWN( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam
	If Not $fSwapMouseButtons Then
		Local $ptMouse[2] = [ BitAND( $ilParam, 0xFFFF ), BitShift( $ilParam, 16 ) ]
		ArcballButtonDown( $ptMouse )
	EndIf
EndFunc

Func WM_LBUTTONUP( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam, $ilParam
	If Not $fSwapMouseButtons Then
		ArcballButtonUp()
	EndIf
EndFunc

Func WM_RBUTTONDOWN( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam
	If $fSwapMouseButtons Then
		Local $ptMouse[2] = [ BitAND( $ilParam, 0xFFFF ), BitShift( $ilParam, 16 ) ]
		ArcballButtonDown( $ptMouse )
	EndIf
EndFunc

Func WM_RBUTTONUP( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam, $ilParam
	If $fSwapMouseButtons Then
		ArcballButtonUp()
	EndIf
EndFunc

Func WM_MOUSEMOVE( $hWnd, $iMsg, $iwParam, $ilParam )
	#forceref $hWnd, $iMsg, $iwParam
	If $bArcballOn Then
		$thisMousePos[0] = BitAND( $ilParam, 0xFFFF )
		$thisMousePos[1] = BitShift( $ilParam, 16 )
	EndIf
EndFunc

Func ArcballButtonDown( ByRef $ptMouse )
	$thisMousePos = $ptMouse
	$lastMousePos = $ptMouse
	$bArcballOn = True
EndFunc

Func ArcballButtonUp()
	$bArcballOn = False
EndFunc

; Get a normalized vector from the center of the virtual ball O to
; a point P on the virtual ball surface, such that P is aligned on
; screen's (x,y) coordinates.  If (x,y) is too far away from the
; sphere, return the nearest point on the virtual ball surface.
Func GetArcballVector( ByRef $ptMouse )
	Local $P[3] = [ + $ptMouse[0] / $iWidth  * 2 - 1.0, _
									- $ptMouse[1] / $iHeight * 2 + 1.0, 0 ]
	Local $OPsquared = $P[0]*$P[0] + $P[1]*$P[1]
	If $OPsquared <= 1 Then
		$P[2] = Sqrt( 1 - $OPsquared )	; Pythagore
	Else
		$P = glmNormalizeVec3( $P )			; Nearest point
	EndIf
		Return $P
EndFunc

Func HandleArcball()
	Local $vLast = GetArcballVector( $lastMousePos )
	Local $vThis = GetArcballVector( $thisMousePos )
	Local $fAngle = ACos( Min( 1.0, glmDotVec3Num( $vLast, $vThis ) ) )
	Local $vAxisInCameraCoord = glmCrossVec3( $vLast, $vThis )
	Local $mMat1[9] = [ $mTransforms[0], $mTransforms[1], $mTransforms[2], _
											$mTransforms[4], $mTransforms[5], $mTransforms[6], _
											$mTransforms[8], $mTransforms[9], $mTransforms[10] ]
	Local $mMatrix = $aObject[6]
	Local $mMat2[9] = [ $mMatrix[0], $mMatrix[1], $mMatrix[2], _
											$mMatrix[4], $mMatrix[5], $mMatrix[6], _
											$mMatrix[8], $mMatrix[9], $mMatrix[10] ]
	Local $mMat = glmMultiplyMat3( $mMat1, $mMat2 )
	Local $mCamera2object = glmInverseMat3( $mMat )
	Local $vAxisInObjectCoord = glmMultiplyMat3Vec( $mCamera2object, $vAxisInCameraCoord )
	$aObject[6] = glmRotate( $mMatrix, Degrees( $fAngle ), $vAxisInObjectCoord )
	$lastMousePos = $thisMousePos
EndFunc
