#include <Misc.au3>

Global $bDemo = 1


Func HandleKeystrokes()

	Local Static $bKey = 0, $nKey = 0
	Local Static $nStrokes = 0

	If Not $bFocus Then Return

	If _IsPressed( "10", $dllUser32 ) Then ; Shift
		$Speed = 0.4
	Else
		$Speed = 0.1
	EndIf

	Select
		Case _IsPressed( "51", $dllUser32 ) ; Q
			$bKey = 1
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "41", $dllUser32 ) ; A
			$bKey = 2
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "57", $dllUser32 ) ; W
			$bKey = 3
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "53", $dllUser32 ) ; S
			$bKey = 4
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "45", $dllUser32 ) ; E
			$bKey = 5
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "44", $dllUser32 ) ; D
			$bKey = 6
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "52", $dllUser32 ) ; R
			$bKey = 7
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "46", $dllUser32 ) ; F
			$bKey = 8
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "54", $dllUser32 ) ; T
			$bKey = 9
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "47", $dllUser32 ) ; G
			$bKey = 10
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "59", $dllUser32 ) ; Y
			$bKey = 11
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "48", $dllUser32 ) ; H
			$bKey = 12
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "55", $dllUser32 ) ; U
			$bKey = 13
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4A", $dllUser32 ) ; J
			$bKey = 14
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4D", $dllUser32 ) ; M
			$bKey = 15
			if Not $nKey Then $nKey = 1
		Case _IsPressed( "4F", $dllUser32 ) ; O
			$bKey = 16
			if Not $nKey Then $nKey = 1
		Case Else
			$nKey = 0
			Return
	EndSelect

	If $nKey = 1 Or $nKey = 3 Then
		If $bDemo And $bKey < 15 Then
			$bDemo = 0
			RobotReset()
		EndIf
		Switch $bKey
			Case 1  ; Q
				AdjBaseAng( True )
			Case 2  ; A
				AdjBaseAng( False )
			Case 3  ; W
				AdjBasePos( True )
			Case 4  ; S
				AdjBasePos( False )
			Case 5  ; E
				AdjUpperArm( False )
			Case 6  ; D
				AdjUpperArm( True )
			Case 7  ; R
				AdjLowerArm( False )
			Case 8  ; F
				AdjLowerArm( True )
			Case 9  ; T
				AdjWristPitch( False )
			Case 10 ; G
				AdjWristPitch( True )
			Case 11 ; Y
				AdjWristRoll( True )
			Case 12 ; H
				AdjWristRoll( False )
			Case 13 ; U
				AdjFingerOpen( True )
			Case 14 ; J
				AdjFingerOpen( False )
			Case 15 ; M
				$bDemo = 1
				RobotReset()
			Case 16 ; O
				$bDemo = 0
				RobotReset()
		EndSwitch
		$bKey = 0
	EndIf

	Switch $nKey
		Case 1
			; First keypress
			$nKey = 2
			$nStrokes = 0
		Case 2
			; Wait a few loops for next keypress
			; To get time to release the key for a single keypress
			$nStrokes += 1
			If $nStrokes > 3 Then _
				$nKey = 3
	EndSwitch

EndFunc


Func AdjBaseAng( $bIncrement )
	If $bIncrement Then
		$angBase += $StandardAngelIncrement * $Speed
	Else
		$angBase -= $StandardAngelIncrement * $Speed
	EndIf
	$angBase = Mod( $angBase, 360.0 )
	$posBase[0] =   3.0 + $centerOffset * Sin( Radians( $angBase ) )
	$posBase[2] = -40.0 + $centerOffset * Cos( Radians( $angBase ) )
EndFunc


Func AdjBasePos( $bIncrement )
	If $bIncrement Then
		If $centerOffset < 10.0 Then _
			$centerOffset += 1.0 * $Speed
	Else
		If $centerOffset > -10.0 Then _
			$centerOffset -= 1.0 * $Speed
	EndIf
	$posBase[0] =   3.0 + $centerOffset * Sin( Radians( $angBase ) )
	$posBase[2] = -40.0 + $centerOffset * Cos( Radians( $angBase ) )
EndFunc


Func AdjUpperArm( $bIncrement )
	If $bIncrement Then
		$angUpperArm += $StandardAngelIncrement * $Speed
	Else
		$angUpperArm -= $StandardAngelIncrement * $Speed
	EndIf
	$angUpperArm = Clamp( $angUpperArm, -90.0, 0.0 )
EndFunc


Func AdjLowerArm( $bIncrement )
	If $bIncrement Then
		$angLowerArm += $StandardAngelIncrement * $Speed
	Else
		$angLowerArm -= $StandardAngelIncrement * $Speed
	EndIf
	$angLowerArm = Clamp( $angLowerArm, 0.0, 146.25 )
EndFunc


Func AdjWristPitch( $bIncrement )
	If $bIncrement Then
		$angWristPitch += $StandardAngelIncrement * $Speed
	Else
		$angWristPitch -= $StandardAngelIncrement * $Speed
	EndIf
	$angWristPitch = Clamp( $angWristPitch, 0.0, 90.0 )
EndFunc


Func AdjWristRoll( $bIncrement )
	If $bIncrement Then
		$angWristRoll += $StandardAngelIncrement * $Speed
	Else
		$angWristRoll -= $StandardAngelIncrement * $Speed
	EndIf
	$angWristRoll = Mod( $angWristRoll, 360.0 )
EndFunc


Func AdjFingerOpen( $bIncrement )
	If $bIncrement Then
		$angFingerOpen += $SmallAngelIncrement * $Speed
	Else
		$angFingerOpen -= $SmallAngelIncrement * $Speed
	EndIf
	$angFingerOpen = Clamp( $angFingerOpen, 9.0, 180.0 )
EndFunc


Func RobotDemo()
	$Speed = 0.4
	Switch $bDemo
		Case 1, 2
			Switch $bDemo
				Case 1
					If $angBase < 315.0 Then
						AdjBaseAng( True )
					Else
						$bDemo = 2
					EndIf
				Case 2
					If $angBase > -45.0 Then
						AdjBaseAng( False )
					Else
						$bDemo = 3
						RobotReset()
					EndIf
			EndSwitch
		Case 3, 4, 5
			Switch $bDemo
				Case 3
					If $centerOffset < 10.0 Then
						AdjBasePos( True )
					Else
						$bDemo = 4
					EndIf
				Case 4
					If $centerOffset > -10.0 Then
						AdjBasePos( False )
					Else
						$bDemo = 5
					EndIf
				Case 5
					If $centerOffset < 0.0 Then
						AdjBasePos( True )
					Else
						$bDemo = 6
						RobotReset()
					EndIf
			EndSwitch
		Case 6, 7, 8
			Switch $bDemo
				Case 6
					If $angUpperArm < 0.0 Then
						AdjUpperArm( True )
					Else
						$bDemo = 7
					EndIf
				Case 7
					If $angUpperArm > -90.0 Then
						AdjUpperArm( False )
					Else
						$bDemo = 8
					EndIf
				Case 8
					If $angUpperArm < -51.75 Then
						AdjUpperArm( True )
					Else
						$bDemo = 9
						RobotReset()
					EndIf
			EndSwitch
		Case 9, 10, 11
			Switch $bDemo
				Case 9
					If $angLowerArm < 146.25 Then
						AdjLowerArm( True )
					Else
						$bDemo = 10
					EndIf
				Case 10
					If $angLowerArm > 0.0 Then
						AdjLowerArm( False )
					Else
						$bDemo = 11
					EndIf
				Case 11
					If $angLowerArm < 47.25 Then
						AdjLowerArm( True )
					Else
						$bDemo = 12
						RobotReset()
					EndIf
			EndSwitch
		Case 12, 13, 14
			Switch $bDemo
				Case 12
					If $angWristPitch < 90.0 Then
						AdjWristPitch( True )
					Else
						$bDemo = 13
					EndIf
				Case 13
					If $angWristPitch > 0.0 Then
						AdjWristPitch( False )
					Else
						$bDemo = 14
					EndIf
				Case 14
					If $angWristPitch < 67.5 Then
						AdjWristPitch( True )
					Else
						$bDemo = 15
						RobotReset()
					EndIf
			EndSwitch
		Case 15, 16
			Switch $bDemo
				Case 15
					If $angWristRoll < 355.5 Then
						AdjWristRoll( True )
					Else
						$bDemo = 16
					EndIf
				Case 16
					If $angWristRoll > 0.0 Then
						AdjWristRoll( False )
					Else
						$bDemo = 17
						RobotReset()
					EndIf
			EndSwitch
		Case 17, 18, 19
			Switch $bDemo
				Case 17
					If $angFingerOpen > 9.0 Then
						AdjFingerOpen( False )
					Else
						$bDemo = 18
					EndIf
				Case 18
					If $angFingerOpen < 180.0 Then
						AdjFingerOpen( True )
					Else
						$bDemo = 19
					EndIf
				Case 19
					If $angFingerOpen > 50.0 Then
						AdjFingerOpen( False )
					Else
						$bDemo = 0
						RobotReset()
					EndIf
			EndSwitch
	EndSwitch
EndFunc


Func RobotReset()
	$centerOffset      = 0
	Local $tmp[3]      = [ 3.0, -5.0, -40.0 ]
	$posBase           = $tmp
	$angBase           = -45.0
	Local $tmp[3]      = [ 2.0, 0.0, 0.0 ]
	$posBaseLeft       = $tmp
	Local $tmp[3]      = [ -2.0, 0.0, 0.0 ]
	$posBaseRight      = $tmp
	$scaleBaseZ        = 3.0
	$angUpperArm       = -51.75
	$lenUpperArm       = 9.0
	Local $tmp[3]      = [ 0.0, 0.0, 8.0 ]
	$posLowerArm       = $tmp
	$angLowerArm       = 47.25
	$lenLowerArm       = 5.0
	$widthLowerArm     = 1.5
	Local $tmp[3]      = [ 0.0, 0.0, 5.0 ]
	$posWrist          = $tmp
	$angWristRoll      = 0.0
	$angWristPitch     = 67.5
	$lenWrist          = 2.0
	$widthWrist        = 2.0
	Local $tmp[3]      = [ 1.0, 0.0, 1.0 ]
	$posLeftFinger     = $tmp
	Local $tmp[3]      = [ -1.0, 0.0, 1.0 ]
	$posRightFinger    = $tmp
	$angFingerOpen     = 50.0
	$lenFinger         = 2.0
	$widthFinger       = 0.5
	$angLowerFinger    = 45.0
EndFunc
