#include-once

Global $iUnifIdx
; Example 7.1 -> 4
; Example 7.2 -> 3

Global $pData0, $pCode0
Global $pData1, $pCode1

Func GetFASMcode()

	; === FASM 0: Draw trees ===

	Local Static $oFasm0, $aData0, $sCode0, $tCode0

	; Fasm data

	$aData0 = DllStructCreate( _
		"ushort[4];"                                    & _ ;  1     :  offset    0,                      Loop
		"float[3];float[3];float[3];float[3];float[6];" & _ ;  2 -  6:  offsets   8,  20,  32,  44,  56,  5 vectors
		"float[16];float[16];float[16];float[16];"      & _ ;  7 - 10:  offsets  80, 144, 208, 272,       4 matrices
		"uint[6];float[6];uint[2];"                     & _ ; 11 - 13:  offsets 336, 360, 384,            Parameters to OpenGL functions
		"uint[3];uint[3];uint[4];"                      & _ ; 14 - 16:  offsets 392, 404, 416,            $aCylinderTintIndInfo[3][3]
		"uint[3];uint[3];"                              & _ ; 17 - 18:  offsets 432, 444,                 $aConeTintIndInfo[2][3]
		"ptr[6];"                                       & _ ; 19     :  offset  456,                      OpenGL function pointers
		"float[" & 4 * $iTrees * 4 & "]" )                  ; 20     :  offset  480 (504)                 $aTrees
	; (The number in brackets is x64 offset)

	; 1: offset 0, Loop
	; Element 1, index 1, offset 0 : ushort, variable $i
	; Element 1, index 2, offset 2 : ushort, constant $iTrees
	DllStructSetData( $aData0, 1, $iTrees, 2 )

	; 2 - 6: offsets 8, 20, 32, 44, 56, 5 vectors
	; Element 2, index 1 - 3, offset  8 : float, variable $vTrans1[3] = [ ?.?, 0.0, ?.? ]
	; Element 3, index 1 - 3, offset 20 : float, variable $vScale2[3] = [ 1.0, ?.?, 1.0 ]
	; Element 4, index 1 - 3, offset 32 : float, constant $vTrans2[3] = [ 0.0, 0.5, 0.0 ]
	; Element 5, index 1 - 3, offset 44 : float, variable $vTrans3[3] = [ 0.0, ?.?, 0.0 ]
	; Element 6, index 1 - 3, offset 56 : float, variable $vScale3[3] = [ 3.0, ?.?, 3.0 ]
	DllStructSetData( $aData0, 2, 0.0, 2 )
	DllStructSetData( $aData0, 3, 1.0, 1 )
	DllStructSetData( $aData0, 3, 1.0, 3 )
	DllStructSetData( $aData0, 4, 0.0, 1 )
	DllStructSetData( $aData0, 4, 0.5, 2 )
	DllStructSetData( $aData0, 4, 0.0, 3 )
	DllStructSetData( $aData0, 5, 0.0, 1 )
	DllStructSetData( $aData0, 5, 0.0, 3 )
	DllStructSetData( $aData0, 6, 3.0, 1 )
	DllStructSetData( $aData0, 6, 3.0, 3 )

	; 7 - 10: offsets 80, 144, 208, 272, 4 matrices
	; Element  7, index 1 - 16, offset  80 : float, constant $mIdenity
	For $i = 0 To 15
		DllStructSetData( $aData0, 7, $mIdenity[$i], $i + 1 )
	Next
	; Element  8, index 1 - 16, offset 144 : float, variable $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
	; $mTreeMatrix[0-11] is constant, can use glmTranslate2 in glmMaths.asm to calculate $mTreeMatrix
	For $i = 0 To 11
		DllStructSetData( $aData0, 8, $mIdenity[$i], $i + 1 )
	Next
	; Element  9, index 1 - 16, offset 208 : float matrix1
	; Element 10, index 1 - 16, offset 272 : float matrix2

	; 11 - 13: offsets 336, 360, 384, Parameters to OpenGL functions
	; Element 11, index 1,     offset 336 : uint  $aUniformColorTint[0]
	; Element 11, index 2,     offset 340 : uint  $aMeshCylinderTint[0]
	; Element 11, index 3,     offset 344 : uint  $aUniformColorTint[4]
	; Element 11, index 4,     offset 348 : uint  $aUniformColorTint[1]
	; Element 11, index 5,     offset 352 : uint  $aMeshConeTint[0]
	; Element 11, index 6,     offset 356 : uint  
	; Element 12, index 1 - 5, offset 360 : float 0.694, 0.4, 0.106, 1.0, 0.0
	; Element 13, index 1,     offset 384 : uint  $GL_FALSE
	; Element 13, index 2,     offset 388 : uint  $GL_UNSIGNED_SHORT
	DllStructSetData( $aData0, 11, $aUniformColorTint[0], 1 )
	DllStructSetData( $aData0, 11, $aMeshCylinderTint[0], 2 )
	DllStructSetData( $aData0, 11, $aUniformColorTint[$iUnifIdx], 3 )
	DllStructSetData( $aData0, 11, $aUniformColorTint[1], 4 )
	DllStructSetData( $aData0, 11, $aMeshConeTint[0],     5 )
	DllStructSetData( $aData0, 12, 0.694,                 1 )
	DllStructSetData( $aData0, 12, 0.4,                   2 )
	DllStructSetData( $aData0, 12, 0.106,                 3 )
	DllStructSetData( $aData0, 12, 1.0,                   4 )
	DllStructSetData( $aData0, 12, 0.0,                   5 )
	DllStructSetData( $aData0, 13, $GL_FALSE,             1 )
	DllStructSetData( $aData0, 13, $GL_UNSIGNED_SHORT,    2 )

	; 14 - 16: offsets 392, 404, 416, $aCylinderTintIndInfo[3][3]
	DllStructSetData( $aData0, 14, $aCylinderTintIndInfo[0][0], 1 ) ; uint offset 392
	DllStructSetData( $aData0, 14, $aCylinderTintIndInfo[0][1], 2 ) ; uint offset 396
	DllStructSetData( $aData0, 14, $aCylinderTintIndInfo[0][2], 3 ) ; uint offset 400
	DllStructSetData( $aData0, 15, $aCylinderTintIndInfo[1][0], 1 ) ; uint offset 404
	DllStructSetData( $aData0, 15, $aCylinderTintIndInfo[1][1], 2 ) ; uint offset 408
	DllStructSetData( $aData0, 15, $aCylinderTintIndInfo[1][2], 3 ) ; uint offset 412
	DllStructSetData( $aData0, 16, $aCylinderTintIndInfo[2][0], 1 ) ; uint offset 416
	DllStructSetData( $aData0, 16, $aCylinderTintIndInfo[2][1], 2 ) ; uint offset 420
	DllStructSetData( $aData0, 16, $aCylinderTintIndInfo[2][2], 3 ) ; uint offset 424

	; 17 - 18: offsets 432, 444, $aConeTintIndInfo[2][3]
	DllStructSetData( $aData0, 17, $aConeTintIndInfo[0][0], 1 ) ; uint offset 432
	DllStructSetData( $aData0, 17, $aConeTintIndInfo[0][1], 2 ) ; uint offset 436
	DllStructSetData( $aData0, 17, $aConeTintIndInfo[0][2], 3 ) ; uint offset 440
	DllStructSetData( $aData0, 18, $aConeTintIndInfo[1][0], 1 ) ; uint offset 444
	DllStructSetData( $aData0, 18, $aConeTintIndInfo[1][1], 2 ) ; uint offset 448
	DllStructSetData( $aData0, 18, $aConeTintIndInfo[1][2], 3 ) ; uint offset 452

	; 19: offset 456, OpenGL function pointers
	DllStructSetData( $aData0, 19, wglGetProcAddress( "glUseProgram" ),                1 ) ; ptr offset 456 (456)
	DllStructSetData( $aData0, 19, wglGetProcAddress( "glBindVertexArray" ),           2 ) ; ptr offset 460 (464)
	DllStructSetData( $aData0, 19, wglGetProcAddress( "glUniform4f" ),                 3 ) ; ptr offset 464 (472)
	DllStructSetData( $aData0, 19, wglGetProcAddress( "glUniformMatrix4fv" ),          4 ) ; ptr offset 468 (480)
	DllStructSetData( $aData0, 19, GetProcAddress( "opengl32.dll", "glDrawElements" ), 5 ) ; ptr offset 472 (488)
	; (The numbers in brackets are x64 offsets)

	; 20: offset 480 (504), $aTrees
	; (The number in brackets is x64 offset)
	For $i = 0 To $iTrees - 1
		DllStructSetData( $aData0, 20, $aTrees[$i][0], 4 * $i + 1 )
		DllStructSetData( $aData0, 20, $aTrees[$i][1], 4 * $i + 2 )
		DllStructSetData( $aData0, 20, $aTrees[$i][2], 4 * $i + 3 )
		DllStructSetData( $aData0, 20, $aTrees[$i][3], 4 * $i + 4 )
	Next

	$pData0 = DllStructGetPtr( $aData0 )

	; Fasm code

	If @AutoItX64 Then
		If Not ReadX64code( "utilities\fasm\Trees-x64.bin", "utilities\fasm\Trees-x64-mk-bin.au3", $sCode0 ) Then Return 0
	Else
		$oFasm0 = FasmInit()
		If Not ReadFasmCode( "utilities\fasm\Trees.asm", $oFasm0, $sCode0 ) Then Return 0
		FasmExit( $oFasm0 )
	EndIf
	$pCode0 = _MemVirtualAlloc( 0, 3072, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE )
	$tCode0 = DllStructCreate( "byte[3072]", $pCode0 )
	DllStructSetData( $tCode0, 1, $sCode0 )


	; === FASM 1: Draw Parthenon columns ===

	Local Static $oFasm1, $aData1, $sCode1, $tCode1

	; Fasm data

	$aData1 = DllStructCreate( _                          ; --- DrawParthenon function ---
		"ushort[4];float[4];"                           & _ ;  1 -  2:  offsets   0,   8,                 Constants
		"ushort[4];float[3];float[3];"                  & _ ;  3 -  5:  offsets  24,  32,  44,            Draw columns front/back
		"ushort[4];float[3];float[3];"                  & _ ;  6 -  8:  offsets  56,  64,  76,            Draw columns left/right
		"float[16];float[16];"                          & _ ;  9 - 10:  offsets  88, 152,                 Matrices
		""                                              & _ ; --- DrawColumn function ---
		"float[16];float[16];"                          & _ ; 11 - 12:  offsets 216, 280,                 2 matrices
		"float[3];float[3];float[3];float[3];float[6];" & _ ; 13 - 17:  offsets 344, 356, 368, 380, 392,  5 vectors
		"uint[6];float[2];uint[2];"                     & _ ; 18 - 20:  offsets 416, 440, 448,            Parameters to OpenGL functions
		"uint;uint;uint;"                               & _ ; 21 - 23:  offsets 456, 460, 464,            $aCubeTintIndInfo[1][3]
		"uint;uint;uint;"                               & _ ; 24 - 32:  offsets 468, 472, 476,            $aCylinderTintIndInfo[3][3]
		"uint;uint;uint;"                               & _ ;           offsets 480, 484, 488
		"uint;uint;uint;"                               & _ ;           offsets 492, 496, 500
		"ptr[6]" )                                          ; 33     :  offset  504,                      OpenGL function pointers

	; --- DrawParthenon function ---

	; 1 - 2: offsets 0, 8, Constants
	; Element 1, index 1, offset  0 : ushort $iParthenonWidth
	; Element 1, index 2, offset  2 : ushort $iParthenonLength
	; Element 2, index 1, offset  8 : float  $fParthenonColumnHeight
	; Element 2, index 2, offset 12 : float  $fParthenonBaseHeight
	; Element 2, index 3, offset 16 : float  $fParthenonTopHeight
	; Element 2, index 4, offset 20 : float  $fColumnBaseHeight
	;DllStructSetData( $aData1, 1, $iParthenonWidth,        1 )
	;DllStructSetData( $aData1, 1, $iParthenonLength,       2 )
	;DllStructSetData( $aData1, 2, $fParthenonColumnHeight, 1 )
	;DllStructSetData( $aData1, 2, $fParthenonBaseHeight,   2 )
	;DllStructSetData( $aData1, 2, $fParthenonTopHeight,    3 )
	;DllStructSetData( $aData1, 2, $fColumnBaseHeight,      4 )

	; Draw columns front/back
	; Local $vTrans1[3], $vTrans2[3], $x
	; $vTrans1[1] = $fParthenonBaseHeight
	; $vTrans1[2] = $iParthenonLength / 2 - 1
	; $vTrans2[1] = $fParthenonBaseHeight
	; $vTrans2[2] = - ( $iParthenonLength / 2 - 1 )
	; For $iColumnNum = 0 To $iParthenonWidth / 2 - 1
	; 	$x = 2 * $iColumnNum - ( $iParthenonWidth / 2 - 1 )
	;
	; 	$vTrans1[0] = $x
	; 	$mMatrix = glmTranslate( $mPartMatrix, $vTrans1 )
	; 	DrawColumn( $mMatrix, $fParthenonColumnHeight )
	;
	; 	$vTrans2[0] = $x
	; 	$mMatrix = glmTranslate( $mPartMatrix, $vTrans2 )
	; 	DrawColumn( $mMatrix, $fParthenonColumnHeight )
	; Next

	; 3 - 5: offsets 24, 32, 44, Draw columns front/back
	; Element 3, index 1, offset 24 : ushort, variable $iColumnNum
	; Element 3, index 2, offset 26 : ushort, constant $iParthenonWidth / 2 - 1 + 1 = Max( $iColumnNum ) + 1
	; Element 3, index 4, offset 30 : ushort, constant $iParthenonWidth / 2 - 1
	; Element 4, index 1, offset 32 : float,  variable $vTrans1[0] = $x
	; Element 4, index 2, offset 36 : float,  constant $vTrans1[1] = $fParthenonBaseHeight
	; Element 4, index 3, offset 40 : float,  constant $vTrans1[2] = $iParthenonLength / 2 - 1
	; Element 5, index 1, offset 44 : float,  variable $vTrans2[0] = $x
	; Element 5, index 2, offset 48 : float,  constant $vTrans2[1] = $fParthenonBaseHeight
	; Element 5, index 3, offset 52 : float,  constant $vTrans2[2] = - ( $iParthenonLength / 2 - 1 )
	DllStructSetData( $aData1, 3, $iParthenonWidth / 2 - 1 + 1,    2 )
	DllStructSetData( $aData1, 3, $iParthenonWidth / 2 - 1,        4 )
	DllStructSetData( $aData1, 4, $fParthenonBaseHeight,           2 )
	DllStructSetData( $aData1, 4, $iParthenonLength / 2 - 1,       3 )
	DllStructSetData( $aData1, 5, $fParthenonBaseHeight,           2 )
	DllStructSetData( $aData1, 5, - ( $iParthenonLength / 2 - 1 ), 3 )

	; Draw columns left/right
	; Don't draw the first or last columns, since they've been drawn already
	; Local $vTrans3[3], $vTrans4[3], $z
	; $vTrans3[0] = $iParthenonWidth / 2 - 1
	; $vTrans3[1] = $fParthenonBaseHeight
	; $vTrans4[0] = - ( $iParthenonWidth / 2 - 1 )
	; $vTrans4[1] = $fParthenonBaseHeight
	; For $iColumnNum = 1 To $iParthenonLength / 2 - 2
	; 	$z = 2 * $iColumnNum - ( $iParthenonLength / 2 - 1 )
	;
	; 	$vTrans3[2] = $z
	; 	$mMatrix = glmTranslate( $mPartMatrix, $vTrans3 )
	; 	DrawColumn( $mMatrix, $fParthenonColumnHeight )
	;
	; 	$vTrans4[2] = $z
	; 	$mMatrix = glmTranslate( $mPartMatrix, $vTrans4 )
	; 	DrawColumn( $mMatrix, $fParthenonColumnHeight )
	; Next

	; 6 - 8: offsets 56, 64, 76, Draw columns left/right
	; Element 6, index 1, offset 56 : ushort, variable $iColumnNum
	; Element 6, index 2, offset 58 : ushort, constant $iParthenonLength / 2 - 2 + 1 = Max( $iColumnNum ) + 1
	; Element 6, index 4, offset 62 : ushort, constant $iParthenonLength / 2 - 1
	; Element 7, index 1, offset 64 : float,  constant $vTrans3[0] = $iParthenonWidth / 2 - 1
	; Element 7, index 2, offset 68 : float,  constant $vTrans3[1] = $fParthenonBaseHeight
	; Element 7, index 3, offset 72 : float,  variable $vTrans3[2] = $z
	; Element 8, index 1, offset 76 : float,  constant $vTrans4[0] = - ( $iParthenonWidth / 2 - 1 )
	; Element 8, index 2, offset 80 : float,  constant $vTrans4[1] = $fParthenonBaseHeight
	; Element 8, index 3, offset 84 : float,  variable $vTrans4[2] = $z
	DllStructSetData( $aData1, 6, $iParthenonLength / 2 - 2 + 1,  2 )
	DllStructSetData( $aData1, 6, $iParthenonLength / 2 - 1,      4 )
	DllStructSetData( $aData1, 7, $iParthenonWidth / 2 - 1,       1 )
	DllStructSetData( $aData1, 7, $fParthenonBaseHeight,          2 )
	DllStructSetData( $aData1, 8, - ( $iParthenonWidth / 2 - 1 ), 1 )
	DllStructSetData( $aData1, 8, $fParthenonBaseHeight,          2 )

	; 9 - 10: offsets 88, 152, Matrices
	; $mPartMatrix is constant
	; Element 9, index 1, offset 88 : float $mPartMatrix
	For $i = 0 To 15
		DllStructSetData( $aData1, 9, $mPartMatrix[$i], $i + 1 )
	Next
	; $mMatrix[0-11] is constant, $mMatrix = glmTranslate( $mPartMatrix, $vTrans3 )
	; Can use glmTranslate2 in glmMaths.asm to calculate $mMatrix
	; Element 10, index 1, offset 152 : float $mMatrix
	For $i = 0 To 11
		DllStructSetData( $aData1, 10, $mPartMatrix[$i], $i + 1 )
	Next

	; --- DrawColumn function ---

	; 11 - 12: offsets 216, 280, 2 matrices
	; Element 11, index 1, offset 216 : float matrix1
	; Element 12, index 1, offset 280 : float matrix2

	; 13 - 17: offsets 344, 356, 368, 380, 392, 5 vectors
	; Element 13, index 1 - 3, offset 344 : float, constant $vScale1 = [ 1.0, $fColumnBaseHeight, 1.0 ]
	; Element 14, index 1 - 3, offset 356 : float, constant $vScale2 = [ 0.8, $fParthenonColumnHeight - $fColumnBaseHeight * 2.0, 0.8 ]
	; Element 15, index 1 - 3, offset 368 : float, constant $vTrans1 = [ 0.0, $fParthenonColumnHeight - $fColumnBaseHeight, 0.0 ]
	; Element 16, index 1 - 3, offset 380 : float, constant $vTrans2 = [ 0.0, $fColumnBaseHeight, 0.0 ]
	; Element 17, index 1 - 3, offset 392 : float, constant $vTrans3 = [ 0.0, 0.5, 0.0 ]
	DllStructSetData( $aData1, 13, 1.0,                                                1 )
	DllStructSetData( $aData1, 13, $fColumnBaseHeight,                                 2 )
	DllStructSetData( $aData1, 13, 1.0,                                                3 )
	DllStructSetData( $aData1, 14, 0.8,                                                1 )
	DllStructSetData( $aData1, 14, $fParthenonColumnHeight - $fColumnBaseHeight * 2.0, 2 )
	DllStructSetData( $aData1, 14, 0.8,                                                3 )
	DllStructSetData( $aData1, 15, 0.0,                                                1 )
	DllStructSetData( $aData1, 15, $fParthenonColumnHeight - $fColumnBaseHeight,       2 )
	DllStructSetData( $aData1, 15, 0.0,                                                3 )
	DllStructSetData( $aData1, 16, 0.0,                                                1 )
	DllStructSetData( $aData1, 16, $fColumnBaseHeight,                                 2 )
	DllStructSetData( $aData1, 16, 0.0,                                                3 )
	DllStructSetData( $aData1, 17, 0.0,                                                1 )
	DllStructSetData( $aData1, 17, 0.5,                                                2 )
	DllStructSetData( $aData1, 17, 0.0,                                                3 )

	; 18 - 20: offsets 416, 440, 448, Parameters to OpenGL functions
	; Element 18, index 1, offset 416 : uint  $aUniformColorTint[0]
	; Element 18, index 2, offset 420 : uint  $aMeshCubeTint[0]
	; Element 18, index 3, offset 424 : uint  $aUniformColorTint[4]
	; Element 18, index 4, offset 428 : uint  $aUniformColorTint[1]
	; Element 18, index 5, offset 432 : uint  $aMeshCylinderTint[0]
	; Element 18, index 6, offset 436 : uint 
	; Element 19, index 1, offset 440 : float 1.0
	; Element 19, index 2, offset 444 : float 0.9
	; Element 20, index 1, offset 448 : uint  $GL_FALSE
	; Element 20, index 2, offset 452 : uint  $GL_UNSIGNED_SHORT
	DllStructSetData( $aData1, 18, $aUniformColorTint[0], 1 )
	DllStructSetData( $aData1, 18, $aMeshCubeTint[0],     2 )
	DllStructSetData( $aData1, 18, $aUniformColorTint[$iUnifIdx], 3 )
	DllStructSetData( $aData1, 18, $aUniformColorTint[1], 4 )
	DllStructSetData( $aData1, 18, $aMeshCylinderTint[0], 5 )
	DllStructSetData( $aData1, 19, 1.0,                   1 )
	DllStructSetData( $aData1, 19, 0.9,                   2 )
	DllStructSetData( $aData1, 20, $GL_FALSE,             1 )
	DllStructSetData( $aData1, 20, $GL_UNSIGNED_SHORT,    2 )

	; 21 - 23: offsets 456, 460, 464, $aCubeTintIndInfo[1][3]
	DllStructSetData( $aData1, 21, $aCubeTintIndInfo[0][0], 1 ) ; uint offset 456
	DllStructSetData( $aData1, 22, $aCubeTintIndInfo[0][1], 1 ) ; uint offset 460
	DllStructSetData( $aData1, 23, $aCubeTintIndInfo[0][2], 1 ) ; uint offset 464

	; 24 - 32: offsets 468, 472, 476, $aCylinderTintIndInfo[3][3]
	DllStructSetData( $aData1, 24, $aCylinderTintIndInfo[0][0], 1 ) ; uint offset 468
	DllStructSetData( $aData1, 25, $aCylinderTintIndInfo[0][1], 1 ) ; uint offset 472
	DllStructSetData( $aData1, 26, $aCylinderTintIndInfo[0][2], 1 ) ; uint offset 476
	DllStructSetData( $aData1, 27, $aCylinderTintIndInfo[1][0], 1 ) ; uint offset 480
	DllStructSetData( $aData1, 28, $aCylinderTintIndInfo[1][1], 1 ) ; uint offset 484
	DllStructSetData( $aData1, 29, $aCylinderTintIndInfo[1][2], 1 ) ; uint offset 488
	DllStructSetData( $aData1, 30, $aCylinderTintIndInfo[2][0], 1 ) ; uint offset 492
	DllStructSetData( $aData1, 31, $aCylinderTintIndInfo[2][1], 1 ) ; uint offset 496
	DllStructSetData( $aData1, 32, $aCylinderTintIndInfo[2][2], 1 ) ; uint offset 500

	; 33: offsets 504, OpenGL function pointers
	DllStructSetData( $aData1, 33, wglGetProcAddress( "glUseProgram" ),                1 ) ; ptr offset 504 (504)
	DllStructSetData( $aData1, 33, wglGetProcAddress( "glBindVertexArray" ),           2 ) ; ptr offset 508 (512)
	DllStructSetData( $aData1, 33, wglGetProcAddress( "glUniform4f" ),                 3 ) ; ptr offset 512 (520)
	DllStructSetData( $aData1, 33, wglGetProcAddress( "glUniformMatrix4fv" ),          4 ) ; ptr offset 516 (528)
	DllStructSetData( $aData1, 33, GetProcAddress( "opengl32.dll", "glDrawElements" ), 5 ) ; ptr offset 520 (536)
	; (The numbers in brackets are x64 offsets)

	$pData1 = DllStructGetPtr( $aData1 )

	; Fasm code

	If @AutoItX64 Then
		If Not ReadX64code( "utilities\fasm\Columns-x64.bin", "utilities\fasm\Columns-x64-mk-bin.au3", $sCode1 ) Then Return 0
	Else
		$oFasm1 = FasmInit()
		If Not ReadFasmCode( "utilities\fasm\Columns.asm", $oFasm1, $sCode1 ) Then Return 0
		FasmExit( $oFasm1 )
	EndIf
	$pCode1 = _MemVirtualAlloc( 0, 4096, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE )
	$tCode1 = DllStructCreate( "byte[4096]", $pCode1 )
	DllStructSetData( $tCode1, 1, $sCode1 )

	Return 1

EndFunc
