        ; FASM assembler code

        ; $aData1 = DllStructCreate( _                          ; --- DrawParthenon function ---
        ;   "ushort[4];float[4];"                           & _ ;  1 -  2:  offsets   0,   8,                 Constants
        ;   "ushort[4];float[3];float[3];"                  & _ ;  3 -  5:  offsets  24,  32,  44,            Draw columns front/back
        ;   "ushort[4];float[3];float[3];"                  & _ ;  6 -  8:  offsets  56,  64,  76,            Draw columns left/right
        ;   "float[16];float[16];"                          & _ ;  9 - 10:  offsets  88, 152,                 Matrices
        ;   ""                                              & _ ; --- DrawColumn function ---
        ;   "float[16];float[16];"                          & _ ; 11 - 12:  offsets 216, 280,                 2 matrices
        ;   "float[3];float[3];float[3];float[3];float[6];" & _ ; 13 - 17:  offsets 344, 356, 368, 380, 392,  5 vectors
        ;   "uint[6];float[2];uint[2];"                     & _ ; 18 - 20:  offsets 416, 440, 448,            Parameters to OpenGL functions
        ;   "uint;uint;uint;"                               & _ ; 21 - 23:  offsets 456, 460, 464,            $aCubeTintIndInfo[1][3]
        ;   "uint;uint;uint;"                               & _ ; 24 - 32:  offsets 468, 472, 476,            $aCylinderTintIndInfo[3][3]
        ;   "uint;uint;uint;"                               & _ ;           offsets 480, 484, 488
        ;   "uint;uint;uint;"                               & _ ;           offsets 492, 496, 500
        ;   "ptr[6]" )                                          ; 33     :  offsets 504,                      OpenGL function pointers

        ; --- DrawParthenon function ---

        ; 1 - 2: offsets 0, 8, Constants
        ; Element 1, index 1, offset  0 : ushort $iParthenonWidth
        ; Element 1, index 2, offset  2 : ushort $iParthenonLength
        ; Element 2, index 1, offset  8 : float  $fParthenonColumnHeight
        ; Element 2, index 2, offset 12 : float  $fParthenonBaseHeight
        ; Element 2, index 3, offset 16 : float  $fParthenonTopHeight
        ; Element 2, index 4, offset 20 : float  $fColumnBaseHeight

        ; Draw columns front/back
        ; Local $vTrans1[3], $vTrans2[3], $x
        ; $vTrans1[1] = $fParthenonBaseHeight
        ; $vTrans1[2] = $iParthenonLength / 2 - 1
        ; $vTrans2[1] = $fParthenonBaseHeight
        ; $vTrans2[2] = - ( $iParthenonLength / 2 - 1 )
        ; For $iColumnNum = 0 To $iParthenonWidth / 2 - 1
        ;   $x = 2 * $iColumnNum - ( $iParthenonWidth / 2 - 1 )
        ; 
        ;   $vTrans1[0] = $x
        ;   $mMatrix = glmTranslate( $mPartMatrix, $vTrans1 )
        ;   DrawColumn( $mMatrix )
        ; 
        ;   $vTrans2[0] = $x
        ;   $mMatrix = glmTranslate( $mPartMatrix, $vTrans2 )
        ;   DrawColumn( $mMatrix )
        ; Next

        ; 3 - 5: offsets 24, 32, 44, Draw columns front/back
        ; Element 3, index 1, offset 24 : ushort, variable $iColumnNum
        ; Element 3, index 2, offset 26 : ushort, constant $iParthenonWidth / 2 - 1 + 1 = Max( $iColumnNum ) + 1
        ; Element 3, index 4, offset 30 : ushort, constant $iParthenonWidth / 2 - 1
        ; Element 4, index 1, offset 32 : float,  variable $vTrans1[0] = $x
        ; Element 4, index 2, offset 36 : float,  constant $vTrans1[1] = $fParthenonBaseHeight
        ; Element 4, index 3, offset 40 : float,  constant $vTrans1[2] = $iParthenonLength / 2 - 1
        ; Element 5, index 1, offset 44 : float,  variable $vTrans2[0] = $x
        ; Element 5, index 2, offset 48 : float,  constant $vTrans2[1] = $fParthenonBaseHeight
        ; Element 5, index 3, offset 52 : float,  constant $vTrans2[2] = - ( $iParthenonLength / 2 - 1 )

        ; Draw columns left/right
        ; Don't draw the first or last columns, since they've been drawn already
        ; Local $vTrans3[3], $vTrans4[3], $z
        ; $vTrans3[0] = $iParthenonWidth / 2 - 1
        ; $vTrans3[1] = $fParthenonBaseHeight
        ; $vTrans4[0] = - ( $iParthenonWidth / 2 - 1 )
        ; $vTrans4[1] = $fParthenonBaseHeight
        ; For $iColumnNum = 1 To $iParthenonLength / 2 - 2
        ;   $z = 2 * $iColumnNum - ( $iParthenonLength / 2 - 1 )
        ; 
        ;   $vTrans3[2] = $z
        ;   $mMatrix = glmTranslate( $mPartMatrix, $vTrans3 )
        ;   DrawColumn( $mMatrix )
        ; 
        ;   $vTrans4[2] = $z
        ;   $mMatrix = glmTranslate( $mPartMatrix, $vTrans4 )
        ;   DrawColumn( $mMatrix )
        ; Next

        ; 6 - 8: offsets 56, 64, 76, Draw columns left/right
        ; Element 6, index 1, offset 56 : ushort, variable $iColumnNum
        ; Element 6, index 2, offset 58 : ushort, constant $iParthenonLength / 2 - 2 + 1 = Max( $iColumnNum ) + 1
        ; Element 6, index 4, offset 62 : ushort, constant $iParthenonLength / 2 - 1
        ; Element 7, index 1, offset 64 : float,  constant $vTrans3[0] = $iParthenonWidth / 2 - 1
        ; Element 7, index 2, offset 68 : float,  constant $vTrans3[1] = $fParthenonBaseHeight
        ; Element 7, index 3, offset 72 : float,  variable $vTrans3[2] = $z
        ; Element 8, index 1, offset 76 : float,  constant $vTrans4[0] = - ( $iParthenonWidth / 2 - 1 )
        ; Element 8, index 2, offset 80 : float,  constant $vTrans4[1] = $fParthenonBaseHeight
        ; Element 8, index 3, offset 84 : float,  variable $vTrans4[2] = $z

        ; 9 - 10: offsets 88, 152, Matrices
        ; $mPartMatrix is constant
        ; Element 9, index 1, offset 88 : float $mPartMatrix

        ; $mMatrix[0-11] is constant, $mMatrix = glmTranslate( $mPartMatrix, $vTrans3 )
        ; Can use glmTranslate2 in glmMaths.asm to calculate $mMatrix
        ; Element 10, index 1, offset 152 : float $mMatrix

        ; Parameters:
        ; [ebp + 08] : $pData1


        use32
        push       ebp
        mov        ebp,                esp


        ; --- Initializations ---

        ; ebx is pointer in $aData1 table
        mov        ebx,                [ebp + 08]          ; $aData1 start

        ; Initialize loop variables
        mov        word  [ebx + 24],   0                   ; Draw columns front/back: $iColumnNum
        mov        word  [ebx + 56],   1                   ; Draw columns left/right: $iColumnNum


        ; --- Calculations ---

        ; Draw columns front/back

fbLoop: ; For $iColumnNum = 0 To $iParthenonWidth / 2 - 1

        finit                                              ; Init FPU

        ; $x = 2 * $iColumnNum - ( $iParthenonWidth / 2 - 1 )
        fild       word  [ebx + 24]                        ; $iColumnNum -> st0
        fadd       st0,                st0                 ; * 2
        fisub      word  [ebx + 30]                        ; - ( $iParthenonWidth / 2 - 1 )

        ; $vTrans1[0] = $x, $vTrans2[0] = $x
        fst        dword [ebx + 32]                        ; st0 -> $vTrans1[0]
        fst        dword [ebx + 44]                        ; st0 -> $vTrans2[0]

        ; $mMatrix = glmTranslate( $mPartMatrix, $vTrans1 )
        mov        eax,                ebx                 ; $mPartMatrix =  ebx +  88
        add        eax,                88                  ; $mPartMatrix -> eax
        mov        ecx,                ebx                 ; $mMatrix[12] =  ebx + 200
        add        ecx,                200                 ; $mMatrix[12] -> ecx
        add        ebx,                32                  ; $vTrans1     -> ebx
        call       glmTranslate2

        ; DrawColumn( $mMatrix )
        call       DrawColumn

        ; $mMatrix = glmTranslate( $mPartMatrix, $vTrans2 )
        mov        eax,                ebx                 ; $mPartMatrix =  ebx +  88
        add        eax,                88                  ; $mPartMatrix -> eax
        mov        ecx,                ebx                 ; $mMatrix[12] =  ebx + 200
        add        ecx,                200                 ; $mMatrix[12] -> ecx
        add        ebx,                44                  ; $vTrans2     -> ebx
        call       glmTranslate2

        ; DrawColumn( $mMatrix )
        call       DrawColumn

fbNext: ; For $iColumnNum = 0 To $iParthenonWidth / 2 - 1

        inc        word  [ebx + 24]                        ; $iColumnNum += 1
        mov        ax,                 word  [ebx + 24]
        cmp        ax,                 word  [ebx + 26]    ; Compare with $iParthenonWidth / 2 - 1 + 1
        jne        fbLoop                                  ; Jump to next loop

        ; Draw columns left/right

lrLoop: ; For $iColumnNum = 1 To $iParthenonLength / 2 - 2

        finit                                              ; Init FPU

        ; $z = 2 * $iColumnNum - ( $iParthenonLength / 2 - 1 )
        fild       word  [ebx + 56]                        ; $iColumnNum -> st0
        fadd       st0,                st0                 ; * 2
        fisub      word  [ebx + 62]                        ; - ( $iParthenonLength / 2 - 1 )

        ; $vTrans3[2] = $z, $vTrans4[2] = $z
        fst        dword [ebx + 72]                        ; st0 -> $vTrans3[2]
        fst        dword [ebx + 84]                        ; st0 -> $vTrans4[2]

        ; $mMatrix = glmTranslate( $mPartMatrix, $vTrans3 )
        mov        eax,                ebx                 ; $mPartMatrix =  ebx +  88
        add        eax,                88                  ; $mPartMatrix -> eax
        mov        ecx,                ebx                 ; $mMatrix[12] =  ebx + 200
        add        ecx,                200                 ; $mMatrix[12] -> ecx
        add        ebx,                64                  ; $vTrans3     -> ebx
        call       glmTranslate2

        ; DrawColumn( $mMatrix )
        call       DrawColumn

        ; $mMatrix = glmTranslate( $mPartMatrix, $vTrans4 )
        mov        eax,                ebx                 ; $mPartMatrix =  ebx +  88
        add        eax,                88                  ; $mPartMatrix -> eax
        mov        ecx,                ebx                 ; $mMatrix[12] =  ebx + 200
        add        ecx,                200                 ; $mMatrix[12] -> ecx
        add        ebx,                76                  ; $vTrans4     -> ebx
        call       glmTranslate2

        ; DrawColumn( $mMatrix )
        call       DrawColumn

lrNext: ; For $iColumnNum = 1 To $iParthenonLength / 2 - 2

        inc        word  [ebx + 56]                        ; $iColumnNum += 1
        mov        ax,                 word  [ebx + 56]
        cmp        ax,                 word  [ebx + 58]    ; Compare with $iParthenonLength / 2 - 2 + 1
        jne        lrLoop                                  ; Jump to next loop


        pop        ebp
        ret        4


        ; Include files
        include    "utilities\fasm\DrawColumns.asm"        ; Include DrawColumn function
        include    "utilities\fasm\glmMaths.asm"           ; Include GLM functions
