        ; FASM assembler code

        ; $aData1 = DllStructCreate( _                          ; --- DrawParthenon function ---
        ;   "ushort[4];float[4];"                           & _ ;  1 -  2:  offsets   0,   8,                 Constants
        ;   "ushort[4];float[3];float[3];"                  & _ ;  3 -  5:  offsets  24,  32,  44,            Draw columns front/back
        ;   "ushort[4];float[3];float[3];"                  & _ ;  6 -  8:  offsets  56,  64,  76,            Draw columns left/right
        ;   "float[16];float[16];"                          & _ ;  9 - 10:  offsets  88, 152,                 Matrices
        ;   ""                                              & _ ; --- DrawColumn function ---
        ;   "float[16];float[16];"                          & _ ; 11 - 12:  offsets 216, 280,                 2 matrices
        ;   "float[3];float[3];float[3];float[3];float[6];" & _ ; 13 - 17:  offsets 344, 356, 368, 380, 392,  5 vectors
        ;   "uint[6];float[2];uint[2];"                     & _ ; 18 - 20:  offsets 416, 440, 448,            Parameters to OpenGL functions
        ;   "uint;uint;uint;"                               & _ ; 21 - 23:  offsets 456, 460, 464,            $aCubeTintIndInfo[1][3]
        ;   "uint;uint;uint;"                               & _ ; 24 - 32:  offsets 468, 472, 476,            $aCylinderTintIndInfo[3][3]
        ;   "uint;uint;uint;"                               & _ ;           offsets 480, 484, 488
        ;   "uint;uint;uint;"                               & _ ;           offsets 492, 496, 500
        ;   "ptr[6]" )                                          ; 33     :  offsets 504,                      OpenGL function pointers

        ; --- DrawColumn function ---

        ; 10: offset 152, Matrix
        ; Element 10, index 1, offset 152 : float $mMatrix

        ; 11 - 12: offsets 216, 280, 2 matrices
        ; Element 11, index 1, offset 216 : float matrix1
        ; Element 12, index 1, offset 280 : float matrix2

        ; 13 - 17: offsets 344, 356, 368, 380, 392, 5 vectors
        ; Element 13, index 1 - 3, offset 344 : float, constant $vScale1 = [ 1.0, $fColumnBaseHeight, 1.0 ]
        ; Element 14, index 1 - 3, offset 356 : float, constant $vScale2 = [ 0.8, $fParthenonColumnHeight - $fColumnBaseHeight * 2.0, 0.8 ]
        ; Element 15, index 1 - 3, offset 368 : float, constant $vTrans1 = [ 0.0, $fParthenonColumnHeight - $fColumnBaseHeight, 0.0 ]
        ; Element 16, index 1 - 3, offset 380 : float, constant $vTrans2 = [ 0.0, $fColumnBaseHeight, 0.0 ]
        ; Element 17, index 1 - 3, offset 392 : float, constant $vTrans3 = [ 0.0, 0.5, 0.0 ]

        ; 18 - 20: offsets 416, 440, 448, Parameters to OpenGL functions
        ; Element 18, index 1, offset 416 : uint  $aUniformColorTint[0]
        ; Element 18, index 2, offset 420 : uint  $aMeshCubeTint[0]
        ; Element 18, index 3, offset 424 : uint  $aUniformColorTint[4]
        ; Element 18, index 4, offset 428 : uint  $aUniformColorTint[1]
        ; Element 18, index 5, offset 432 : uint  $aMeshCylinderTint[0]
        ; Element 18, index 6, offset 436 : uint 
        ; Element 19, index 1, offset 440 : float  1.0
        ; Element 19, index 2, offset 444 : float  0.9
        ; Element 20, index 1, offset 448 : uint   $GL_FALSE
        ; Element 20, index 2, offset 452 : uint   $GL_UNSIGNED_SHORT

        ; 21 - 23: offsets 456, 460, 464, $aCubeTintIndInfo[1][3]
        ; $aCubeTintIndInfo[0][0] ; uint offset 456
        ; $aCubeTintIndInfo[0][1] ; uint offset 460
        ; $aCubeTintIndInfo[0][2] ; uint offset 464

        ; 24 - 32: offsets 468, 472, 476, $aCylinderTintIndInfo[3][3]
        ; $aCylinderTintIndInfo[0][0] ; uint offset 468
        ; $aCylinderTintIndInfo[0][1] ; uint offset 472
        ; $aCylinderTintIndInfo[0][2] ; uint offset 476
        ; $aCylinderTintIndInfo[1][0] ; uint offset 480
        ; $aCylinderTintIndInfo[1][1] ; uint offset 484
        ; $aCylinderTintIndInfo[1][2] ; uint offset 488
        ; $aCylinderTintIndInfo[1][0] ; uint offset 492
        ; $aCylinderTintIndInfo[1][1] ; uint offset 496
        ; $aCylinderTintIndInfo[1][2] ; uint offset 500

        ; 33: offsets 504, OpenGL function pointers
        ; glUseProgram       ; ptr offset 504 (504)
        ; glBindVertexArray  ; ptr offset 508 (512)
        ; glUniform4f        ; ptr offset 512 (520)
        ; glUniformMatrix4fv ; ptr offset 516 (528)
        ; glDrawElements     ; ptr offset 520 (536)
        ; (The numbers in brackets are x64 offsets)


        ; Symbolic constants
        matrix1    equ                 216                 ; Element 11, index 1, offset 216 : float matrix1
        matrix2    equ                 280                 ; Element 12, index 1, offset 280 : float matrix2

        use64

DrawColumn:

        ; Draw bottom of the column
        ; Local $m = glmScale( $mMatrix, $vScale1 )                     ; matrix1 = ...
        ; $m = glmTranslate( $m, $vTrans3 )                             ; matrix2 = ... matrix1 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshCubeTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 1.0, 1.0, 1.0, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix2
        ; glDrawElements( $aCubeTintIndInfo[0][0], $aCubeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCubeTintIndInfo[0][2] )
        ; glUseProgram(0)

        ; $m = glmScale( $mMatrix, $vScale1 )
        mov        rax,                r12                 ; $mMatrix =  r12 + 152
        add        rax,                152                 ; $mMatrix -> rax
        mov        rcx,                r12                 ; $vScale1 =  r12 + 344
        add        rcx,                344                 ; $vScale1 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1  -> rdx
        call       glmScale

        ; $m = glmTranslate( $m, $vTrans3 )
        mov        rax,                r12
        add        rax,                matrix1             ; matrix1  -> rax
        mov        rcx,                r12                 ; $vTrans3 =  r12 + 392
        add        rcx,                392                 ; $vTrans3 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix2             ; matrix2  -> rdx
        call       glmTranslate1y

        ; glUseProgram( $aUniformColorTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 416]   ; $aUniformColorTint[0]
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; glBindVertexArray( $aMeshCubeTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 420]   ; $aMeshCubeTint[0]
        call       qword [r12 + 512]                       ; glBindVertexArray
        add        rsp,                40                  ; Restore stack pointer

        ; glUniform4f( $aUniformColorTint[4], 1.0, 1.0, 1.0, 1.0 )
        sub        rsp,                48                  ; Stack space and alignment
				movss      xmm4,               dword [r12 + 440]   ; 1.0
				movss      [rsp + 32],         xmm4
        movss      xmm3,               dword [r12 + 440]   ; 1.0
        movss      xmm2,               dword [r12 + 440]   ; 1.0
        movss      xmm1,               dword [r12 + 440]   ; 1.0
        mov        ecx,                dword [r12 + 424]   ; $aUniformColorTint[4]
        call       qword [r12 + 520]                       ; glUniform4f
        add        rsp,                48                  ; Restore stack pointer

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix2
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9,                 r12
        add        r9,                 matrix2             ; matrix2 -> r9
				mov        r8d,                dword [r12 + 448]   ; $GL_FALSE
        mov        rdx,                1                   ; 1
        mov        ecx,                dword [r12 + 428]   ; $aUniformColorTint[1]
        call       qword [r12 + 528]                       ; glUniformMatrix4fv
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCubeTintIndInfo[0][0], $aCubeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCubeTintIndInfo[0][2] )
        sub        rsp,                48                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 464]   ; $aCubeTintIndInfo[0][2]
        mov        r8d,                dword [r12 + 452]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 460]   ; $aCubeTintIndInfo[0][1]
        mov        ecx,                dword [r12 + 456]   ; $aCubeTintIndInfo[0][0]
        call       qword [r12 + 536]                       ; glDrawElements
        add        rsp,                48                  ; Restore stack pointer

        ; glUseProgram(0)
        sub        rsp,                40                  ; Stack space and alignment
        mov        rcx,                0                   ; 0
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; Draw top of the column
        ; $m = glmTranslate( $mMatrix, $vTrans1 )                       ; matrix1 = ...
        ; $m = glmScale( $m, $vScale1 )                                 ; matrix2 = ... matrix1 ...
        ; $m = glmTranslate( $m, $vTrans3 )                             ; matrix1 = ... matrix2 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshCubeTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 1.0, 1.0, 1.0, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix1
        ; glDrawElements( $aCubeTintIndInfo[0][0], $aCubeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCubeTintIndInfo[0][2] )
        ; glUseProgram(0)

        ; $m = glmTranslate( $mMatrix, $vTrans1 )
        mov        rax,                r12                 ; $mMatrix =  r12 + 152
        add        rax,                152                 ; $mMatrix -> rax
        mov        rcx,                r12                 ; $vTrans1 =  r12 + 368
        add        rcx,                368                 ; $vTrans1 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1  -> rdx
        call       glmTranslate

        ; $m = glmScale( $m, $vScale1 )
        mov        rax,                r12
        add        rax,                matrix1             ; matrix1  -> rax
        mov        rcx,                r12                 ; $vScale1 =  r12 + 344
        add        rcx,                344                 ; $vScale1 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix2             ; matrix2  -> rdx
        call       glmScale

        ; $m = glmTranslate( $m, $vTrans3 )
        mov        rax,                r12
        add        rax,                matrix2             ; matrix2  -> rax
        mov        rcx,                r12                 ; $vTrans3 =  r12 + 392
        add        rcx,                392                 ; $vTrans3 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1  -> rdx
        call       glmTranslate1y

        ; glUseProgram( $aUniformColorTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 416]   ; $aUniformColorTint[0]
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; glBindVertexArray( $aMeshCubeTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 420]   ; $aMeshCubeTint[0]
        call       qword [r12 + 512]                       ; glBindVertexArray
        add        rsp,                40                  ; Restore stack pointer

        ; glUniform4f( $aUniformColorTint[4], 1.0, 1.0, 1.0, 1.0 )
        sub        rsp,                48                  ; Stack space and alignment
				movss      xmm4,               dword [r12 + 440]   ; 1.0
				movss      [rsp + 32],         xmm4
        movss      xmm3,               dword [r12 + 440]   ; 1.0
        movss      xmm2,               dword [r12 + 440]   ; 1.0
        movss      xmm1,               dword [r12 + 440]   ; 1.0
        mov        ecx,                dword [r12 + 424]   ; $aUniformColorTint[4]
        call       qword [r12 + 520]                       ; glUniform4f
        add        rsp,                48                  ; Restore stack pointer

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix1
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9,                 r12
        add        r9,                 matrix1             ; matrix1 -> r9
				mov        r8d,                dword [r12 + 448]   ; $GL_FALSE
        mov        rdx,                1                   ; 1
        mov        ecx,                dword [r12 + 428]   ; $aUniformColorTint[1]
        call       qword [r12 + 528]                       ; glUniformMatrix4fv
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCubeTintIndInfo[0][0], $aCubeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCubeTintIndInfo[0][2] )
        sub        rsp,                48                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 464]   ; $aCubeTintIndInfo[0][2]
        mov        r8d,                dword [r12 + 452]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 460]   ; $aCubeTintIndInfo[0][1]
        mov        ecx,                dword [r12 + 456]   ; $aCubeTintIndInfo[0][0]
        call       qword [r12 + 536]                       ; glDrawElements
        add        rsp,                48                  ; Restore stack pointer

        ; glUseProgram(0)
        sub        rsp,                40                  ; Stack space and alignment
        mov        rcx,                0                   ; 0
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; Draw the main column
        ; $m = glmTranslate( $mMatrix, $vTrans2 )                       ; matrix1 = ...
        ; $m = glmScale( $m, $vScale2 )                                 ; matrix2 = ... matrix1 ...
        ; $m = glmTranslate( $m, $vTrans3 )                             ; matrix1 = ... matrix2 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshCylinderTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 0.9, 0.9, 0.9, 0.9 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix1
        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        ; glUseProgram(0)

        ; $m = glmTranslate( $mMatrix, $vTrans2 )
        mov        rax,                r12                 ; $mMatrix =  r12 + 152
        add        rax,                152                 ; $mMatrix -> rax
        mov        rcx,                r12                 ; $vTrans2 =  r12 + 380
        add        rcx,                380                 ; $vTrans2 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1  -> rdx
        call       glmTranslate

        ; $m = glmScale( $m, $vScale2 )
        mov        rax,                r12
        add        rax,                matrix1             ; matrix1  -> rax
        mov        rcx,                r12                 ; $vScale2 =  r12 + 356
        add        rcx,                356                 ; $vScale2 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix2             ; matrix2  -> rdx
        call       glmScale

        ; $m = glmTranslate( $m, $vTrans3 )
        mov        rax,                r12
        add        rax,                matrix2             ; matrix2  -> rax
        mov        rcx,                r12                 ; $vTrans3 =  r12 + 392
        add        rcx,                392                 ; $vTrans3 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1  -> rdx
        call       glmTranslate1y

        ; glUseProgram( $aUniformColorTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 416]   ; $aUniformColorTint[0]
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; glBindVertexArray( $aMeshCylinderTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 432]   ; $aMeshCylinderTint[0]
        call       qword [r12 + 512]                       ; glBindVertexArray
        add        rsp,                40                  ; Restore stack pointer

        ; glUniform4f( $aUniformColorTint[4], 0.9, 0.9, 0.9, 0.9 )
        sub        rsp,                48                  ; Stack space and alignment
				movss      xmm4,               dword [r12 + 444]   ; 0.9
				movss      [rsp + 32],         xmm4
        movss      xmm3,               dword [r12 + 444]   ; 0.9
        movss      xmm2,               dword [r12 + 444]   ; 0.9
        movss      xmm1,               dword [r12 + 444]   ; 0.9
        mov        ecx,                dword [r12 + 424]   ; $aUniformColorTint[4]
        call       qword [r12 + 520]                       ; glUniform4f
        add        rsp,                48                  ; Restore stack pointer

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $m ) ; matrix1
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9,                 r12
        add        r9,                 matrix1             ; matrix1 -> r9
				mov        r8d,                dword [r12 + 448]   ; $GL_FALSE
        mov        rdx,                1                   ; 1
        mov        ecx,                dword [r12 + 428]   ; $aUniformColorTint[1]
        call       qword [r12 + 528]                       ; glUniformMatrix4fv
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        sub        rsp,                48                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 476]   ; $aCylinderTintIndInfo[0][2]
        mov        r8d,                dword [r12 + 452]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 472]   ; $aCylinderTintIndInfo[0][1]
        mov        ecx,                dword [r12 + 468]   ; $aCylinderTintIndInfo[0][0]
        call       qword [r12 + 536]                       ; glDrawElements
        add        rsp,                48                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        sub        rsp,                48                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 488]   ; $aCylinderTintIndInfo[1][2]
        mov        r8d,                dword [r12 + 452]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 484]   ; $aCylinderTintIndInfo[1][1]
        mov        ecx,                dword [r12 + 480]   ; $aCylinderTintIndInfo[1][0]
        call       qword [r12 + 536]                       ; glDrawElements
        add        rsp,                48                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        sub        rsp,                48                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 500]   ; $aCylinderTintIndInfo[2][2]
        mov        r8d,                dword [r12 + 452]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 496]   ; $aCylinderTintIndInfo[2][1]
        mov        ecx,                dword [r12 + 492]   ; $aCylinderTintIndInfo[2][0]
        call       qword [r12 + 536]                       ; glDrawElements
        add        rsp,                48                  ; Restore stack pointer

        ; glUseProgram(0)
        sub        rsp,                40                  ; Stack space and alignment
        mov        rcx,                0                   ; 0
        call       qword [r12 + 504]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ret


        ; Include files
        ;include    "glmMaths-x64.asm"                      ; Include GLM functions
