        ; FASM assembler code

        ; $aData0 = DllStructCreate( _
        ;   "ushort[4];"                                    & _ ;  1     :  offset    0,                      Loop
        ;   "float[3];float[3];float[3];float[3];float[6];" & _ ;  2 -  6:  offsets   8,  20,  32,  44,  56,  5 vectors
        ;   "float[16];float[16];float[16];float[16];"      & _ ;  7 - 10:  offsets  80, 144, 208, 272,       4 matrices
        ;   "uint[6];float[6];uint[2];"                     & _ ; 11 - 13:  offsets 336, 360, 384,            Parameters to OpenGL functions
        ;   "uint[3];uint[3];uint[4];"                      & _ ; 14 - 16:  offsets 392, 404, 416,            $aCylinderTintIndInfo[3][3]
        ;   "uint[3];uint[3];"                              & _ ; 17 - 18:  offsets 432, 444,                 $aConeTintIndInfo[2][3]
        ;   "ptr[6];"                                       & _ ; 19     :  offset  456,                      OpenGL function pointers
        ;   "float[" & 4 * $iTrees * 4 & "]" )                  ; 20     :  offset  480 (504)                 $aTrees
        ; (The number in brackets is x64 offset)

        ; 1: offset 0, Loop
        ; Element 1, index 1, offset 0 : ushort, variable $i
        ; Element 1, index 2, offset 2 : ushort, constant $iTrees
        ; DllStructSetData( $aData0, 1, $iTrees, 2 )

        ; 2 - 6: offsets 8, 20, 32, 44, 56, 5 vectors
        ; Element 2, index 1 - 3, offset  8 : float, variable $vTrans1[3] = [ ?.?, 0.0, ?.? ]
        ; Element 3, index 1 - 3, offset 20 : float, variable $vScale2[3] = [ 1.0, ?.?, 1.0 ]
        ; Element 4, index 1 - 3, offset 32 : float, constant $vTrans2[3] = [ 0.0, 0.5, 0.0 ]
        ; Element 5, index 1 - 3, offset 44 : float, variable $vTrans3[3] = [ 0.0, ?.?, 0.0 ]
        ; Element 6, index 1 - 3, offset 56 : float, variable $vScale3[3] = [ 3.0, ?.?, 3.0 ]

        ; 7 - 10: offsets 80, 144, 208, 272, 4 matrices
        ; Element  7, index 1 - 16, offset  80 : float, constant $mIdenity
        ; For $i = 0 To 15
        ;   DllStructSetData( $aData0, 7, $mIdenity[$i], $i + 1 )
        ; Next
        ; Element  8, index 1 - 16, offset 144 : float, variable $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        ; $mTreeMatrix[0-11] is constant, can use glmTranslate2 in glmMaths.asm to calculate $mTreeMatrix
        ; For $i = 0 To 11
        ;   DllStructSetData( $aData0, 8, $mIdenity[$i], $i + 1 )
        ; Next
        ; Element  9, index 1 - 16, offset 208 : float matrix1
        ; Element 10, index 1 - 16, offset 272 : float matrix2

        ; 11 - 13: offsets 336, 360, 384, Parameters to OpenGL functions
        ; Element 11, index 1,     offset 336 : uint  $aUniformColorTint[0]
        ; Element 11, index 2,     offset 340 : uint  $aMeshCylinderTint[0]
        ; Element 11, index 3,     offset 344 : uint  $aUniformColorTint[4]
        ; Element 11, index 4,     offset 348 : uint  $aUniformColorTint[1]
        ; Element 11, index 5,     offset 352 : uint  $aMeshConeTint[0]
        ; Element 11, index 6,     offset 356 : uint  
        ; Element 12, index 1 - 5, offset 360 : float 0.694, 0.4, 0.106, 1.0, 0.0
        ; Element 13, index 1,     offset 384 : uint  $GL_FALSE
        ; Element 13, index 2,     offset 388 : uint  $GL_UNSIGNED_SHORT

        ; 14 - 16: offsets 392, 404, 416, $aCylinderTintIndInfo[3][3]
        ; $aCylinderTintIndInfo[0][0] ; uint offset 392
        ; $aCylinderTintIndInfo[0][1] ; uint offset 396
        ; $aCylinderTintIndInfo[0][2] ; uint offset 400
        ; $aCylinderTintIndInfo[1][0] ; uint offset 404
        ; $aCylinderTintIndInfo[1][1] ; uint offset 408
        ; $aCylinderTintIndInfo[1][2] ; uint offset 412
        ; $aCylinderTintIndInfo[2][0] ; uint offset 416
        ; $aCylinderTintIndInfo[2][1] ; uint offset 420
        ; $aCylinderTintIndInfo[2][2] ; uint offset 424

        ; 17 - 18: offsets 432, 444, $aConeTintIndInfo[2][3]
        ; $aConeTintIndInfo[0][0] ; uint offset 432
        ; $aConeTintIndInfo[0][1] ; uint offset 436
        ; $aConeTintIndInfo[0][2] ; uint offset 440
        ; $aConeTintIndInfo[1][0] ; uint offset 444
        ; $aConeTintIndInfo[1][1] ; uint offset 448
        ; $aConeTintIndInfo[1][2] ; uint offset 452

        ; 19: offset 456, OpenGL function pointers
        ; glUseProgram       ; ptr offset 456 (456)
        ; glBindVertexArray  ; ptr offset 460 (464)
        ; glUniform4f        ; ptr offset 464 (472)
        ; glUniformMatrix4fv ; ptr offset 468 (480)
        ; glDrawElements     ; ptr offset 472 (488)
        ; (The numbers in brackets are x64 offsets)

        ; 20: offset 480 (504), $aTrees
        ; (The number in brackets is x64 offset)
        ; For $i = 0 To $iTrees - 1
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][0], 4 * $i + 1 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][1], 4 * $i + 2 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][2], 4 * $i + 3 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][3], 4 * $i + 4 )
        ; Next

        ; Parameters:
        ; rcx : $pData0


        ; Symbolic constants
        TreeMatrix equ                 144                 ; Element  8, index 1 - 16, offset 144 : float TreeMatrix
        matrix1    equ                 208                 ; Element  9, index 1 - 16, offset 208 : float matrix1
        matrix2    equ                 272                 ; Element 10, index 1 - 16, offset 272 : float matrix2


        use64


        ; --- Initializations ---

        ; r12 is pointer in $aData0 table
        mov        r12,                rcx                 ; $aData0 start

        ; Initialize loop variable
        mov        ax,                 word  [r12 + 02]    ; $iTrees
        mov        word  [r12 + 00],   ax                  ; Loop counter $i = $iTrees

        ; r13 is pointer in $aTrees table
        mov        r13,                r12                 ; $aData0 start
        add        r13,                504                 ; $aTrees start


        ; --- Calculations ---

        ; For $i = 0 To $iTrees - 1
        ;   $vTrans1[0] = $aTrees[$i][0]
        ;   $vTrans1[2] = $aTrees[$i][1]
        ;   $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        ;
        ;   Draw trunk
        ;
        ;   Draw treetop
        ; Next

iLoop:  ; For $i = 0 To $iTrees - 1 (uses "For $i = $iTrees To 1 Step -1")

        ; Vectors
        mov        ecx,                dword [r13 + 00]
        mov        dword [r12 + 08],   ecx                 ; $vTrans1[0] = $aTrees[$i][0]
        mov        ecx,                dword [r13 + 04]
        mov        dword [r12 + 16],   ecx                 ; $vTrans1[2] = $aTrees[$i][1]

        ; Draw trunk
        mov        ecx,                dword [r13 + 08]
        mov        dword [r12 + 24],   ecx                 ; $vScale2[1] = $aTrees[$i][2]

        ; Draw treetop
        mov        dword [r12 + 48],   ecx                 ; $vTrans3[1] = $aTrees[$i][2]
        mov        ecx,                dword [r13 + 12]
        mov        dword [r12 + 60],   ecx                 ; $vScale3[1] = $aTrees[$i][3]

        ; $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        mov        rax,                r12                 ; $mIdenity        =  r12 +  80
        add        rax,                80                  ; $mIdenity        -> rax
        mov        rcx,                r12                 ; $vTrans1         =  r12 +  08
        add        rcx,                08                  ; $vTrans1         -> rcx
        mov        rdx,                r12                 ; $mTreeMatrix[12] =  r12 + 192
        add        rdx,                192                 ; $mTreeMatrix[12] -> rdx
        call       glmTranslate2


        ; --- Draw trunk ---

        ; $vScale2[1] = $aTrees[$i][2] ; <-- Calculated above
        ; $mTrunkMatrix = glmScale( $mTreeMatrix, $vScale2 )                       ; matrix1 = ...
        ; $mTrunkMatrix = glmTranslate( $mTrunkMatrix, $vTrans2 )                  ; matrix2 = ... matrix1 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshCylinderTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 0.694, 0.4, 0.106, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTrunkMatrix ) ; matrix2
        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        ; glUseProgram(0)

        ; $mTrunkMatrix = glmScale( $mTreeMatrix, $vScale2 )
        mov        rax,                r12
        add        rax,                TreeMatrix          ; TreeMatrix -> rax
        mov        rcx,                r12                 ; $vScale2   =  r12 +  20
        add        rcx,                20                  ; $vScale2   -> rcx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1    -> rdx
        call       glmScale

        ; $mTrunkMatrix = glmTranslate( $mTrunkMatrix, $vTrans2 )
        mov        rax,                r12
        add        rax,                matrix1             ; matrix1  -> rax
        mov        rcx,                r12                 ; $vTrans2 =  r12 +  32
        add        rcx,                32                  ; $vTrans2 -> rcx
        mov        rdx,                r12
        add        rdx,                matrix2             ; matrix2  -> rdx
        call       glmTranslate1y

        ; glUseProgram( $aUniformColorTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 336]   ; $aUniformColorTint[0]
        call       qword [r12 + 456]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; glBindVertexArray( $aMeshCylinderTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 340]   ; $aMeshCylinderTint[0]
        call       qword [r12 + 464]                       ; glBindVertexArray
        add        rsp,                40                  ; Restore stack pointer

        ; glUniform4f( $aUniformColorTint[4], 0.694, 0.4, 0.106, 1.0 )
        sub        rsp,                56                  ; Stack space and alignment
				movss      xmm4,               dword [r12 + 372]   ; 1.0
				movss      [rsp + 32],         xmm4
        movss      xmm3,               dword [r12 + 368]   ; 0.106
        movss      xmm2,               dword [r12 + 364]   ; 0.4
        movss      xmm1,               dword [r12 + 360]   ; 0.694
        mov        ecx,                dword [r12 + 344]   ; $aUniformColorTint[4]
        call       qword [r12 + 472]                       ; glUniform4f
        add        rsp,                56                  ; Restore stack pointer

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTrunkMatrix ) ; matrix2
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9,                 r12
        add        r9,                 matrix2             ; matrix2 -> r9
				mov        r8d,                dword [r12 + 384]   ; $GL_FALSE
        mov        rdx,                1                   ; 1
        mov        ecx,                dword [r12 + 348]   ; $aUniformColorTint[1]
        call       qword [r12 + 480]                       ; glUniformMatrix4fv
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 400]   ; $aCylinderTintIndInfo[0][2]
        mov        r8d,                dword [r12 + 388]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 396]   ; $aCylinderTintIndInfo[0][1]
        mov        ecx,                dword [r12 + 392]   ; $aCylinderTintIndInfo[0][0]
        call       qword [r12 + 488]                       ; glDrawElements
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 412]   ; $aCylinderTintIndInfo[1][2]
        mov        r8d,                dword [r12 + 388]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 408]   ; $aCylinderTintIndInfo[1][1]
        mov        ecx,                dword [r12 + 404]   ; $aCylinderTintIndInfo[1][0]
        call       qword [r12 + 488]                       ; glDrawElements
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 424]   ; $aCylinderTintIndInfo[2][2]
        mov        r8d,                dword [r12 + 388]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 420]   ; $aCylinderTintIndInfo[2][1]
        mov        ecx,                dword [r12 + 416]   ; $aCylinderTintIndInfo[2][0]
        call       qword [r12 + 488]                       ; glDrawElements
        add        rsp,                40                  ; Restore stack pointer

        ; glUseProgram(0)
        sub        rsp,                40                  ; Stack space and alignment
        mov        rcx,                0                   ; 0
        call       qword [r12 + 456]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer


        ; --- Draw treetop ---

        ; $vTrans3[1] = $aTrees[$i][2] ; <-- Calculated above
        ; $vScale3[1] = $aTrees[$i][3] ; <-- Calculated above
        ; $mTopMatrix = glmTranslate( $mTreeMatrix, $vTrans3 )                   ; matrix1 = ...
        ; $mTopMatrix = glmScale( $mTopMatrix, $vScale3 )                        ; matrix2 = ... matrix1 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshConeTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 0.0, 1.0, 0.0, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTopMatrix ) ; matrix2
        ; glDrawElements( $aConeTintIndInfo[0][0], $aConeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[0][2] )
        ; glDrawElements( $aConeTintIndInfo[1][0], $aConeTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[1][2] )
        ; glUseProgram(0)

        ; $mTopMatrix = glmTranslate( $mTreeMatrix, $vTrans3 )
        mov        rax,                r12
        add        rax,                TreeMatrix          ; TreeMatrix -> eax
        mov        rcx,                r12                 ; $vTrans3   =  r12 +  44
        add        rcx,                44                  ; $vTrans3   -> ebx
        mov        rdx,                r12
        add        rdx,                matrix1             ; matrix1    -> ecx
        call       glmTranslate1y

        ; $mTopMatrix = glmScale( $mTopMatrix, $vScale3 )
        mov        rax,                r12
        add        rax,                matrix1             ; matrix1  -> eax
        mov        rcx,                r12                 ; $vScale3 =  r12 +  56
        add        rcx,                56                  ; $vScale3 -> ebx
        mov        rdx,                r12
        add        rdx,                matrix2             ; matrix2  -> ecx
        call       glmScale

        ; glUseProgram( $aUniformColorTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 336]   ; $aUniformColorTint[0]
        call       qword [r12 + 456]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer

        ; glBindVertexArray( $aMeshConeTint[0] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        ecx,                dword [r12 + 352]   ; $aMeshConeTint[0]
        call       qword [r12 + 464]                       ; glBindVertexArray
        add        rsp,                40                  ; Restore stack pointer

        ; glUniform4f( $aUniformColorTint[4], 0.0, 1.0, 0.0, 1.0 )
        sub        rsp,                40                  ; Stack space and alignment
				movss      xmm4,               dword [r12 + 372]   ; 1.0
				movss      [rsp + 32],         xmm4
        movss      xmm3,               dword [r12 + 376]   ; 0.0
        movss      xmm2,               dword [r12 + 372]   ; 1.0
        movss      xmm1,               dword [r12 + 376]   ; 0.0
        mov        ecx,                dword [r12 + 344]   ; $aUniformColorTint[4]
        call       qword [r12 + 472]                       ; glUniform4f
        add        rsp,                40                  ; Restore stack pointer

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTopMatrix ) ; matrix2
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9,                 r12
        add        r9,                 matrix2             ; matrix2 -> r9
				mov        r8d,                dword [r12 + 384]   ; $GL_FALSE
        mov        rdx,                1                   ; 1
        mov        ecx,                dword [r12 + 348]   ; $aUniformColorTint[1]
        call       qword [r12 + 480]                       ; glUniformMatrix4fv
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aConeTintIndInfo[0][0], $aConeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[0][2] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 440]   ; $aConeTintIndInfo[0][2]
        mov        r8d,                dword [r12 + 388]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 436]   ; $aConeTintIndInfo[0][1]
        mov        ecx,                dword [r12 + 432]   ; $aConeTintIndInfo[0][0]
        call       qword [r12 + 488]                       ; glDrawElements
        add        rsp,                40                  ; Restore stack pointer

        ; glDrawElements( $aConeTintIndInfo[1][0], $aConeTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[1][2] )
        sub        rsp,                40                  ; Stack space and alignment
        mov        r9d,                dword [r12 + 452]   ; $aConeTintIndInfo[1][2]
        mov        r8d,                dword [r12 + 388]   ; $GL_UNSIGNED_SHORT
        mov        edx,                dword [r12 + 448]   ; $aConeTintIndInfo[1][1]
        mov        ecx,                dword [r12 + 444]   ; $aConeTintIndInfo[1][0]
        call       qword [r12 + 488]                       ; glDrawElements
        add        rsp,                40                  ; Restore stack pointer

        ; glUseProgram(0)
        sub        rsp,                40                  ; Stack space and alignment
        mov        rcx,                0                   ; 0
        call       qword [r12 + 456]                       ; glUseProgram
        add        rsp,                40                  ; Restore stack pointer


iNext:  ; For $i = 0 To $iTrees - 1 (uses "For $i = $iTrees To 1 Step -1")

        add        r13,                16                  ; Next row in $aTrees

        dec        word  [r12 + 00]                        ; $i -= 1
        jnz        iLoop                                   ; Jump to next loop


        ret


        ; Include files
        include    "glmMaths-x64.asm"                      ; Include GLM functions
