        ; FASM assembler code

        ; $aData0 = DllStructCreate( _
        ;   "ushort[4];"                                    & _ ;  1     :  offset    0,                      Loop
        ;   "float[3];float[3];float[3];float[3];float[6];" & _ ;  2 -  6:  offsets   8,  20,  32,  44,  56,  5 vectors
        ;   "float[16];float[16];float[16];float[16];"      & _ ;  7 - 10:  offsets  80, 144, 208, 272,       4 matrices
        ;   "uint[6];float[6];uint[2];"                     & _ ; 11 - 13:  offsets 336, 360, 384,            Parameters to OpenGL functions
        ;   "uint[3];uint[3];uint[4];"                      & _ ; 14 - 16:  offsets 392, 404, 416,            $aCylinderTintIndInfo[3][3]
        ;   "uint[3];uint[3];"                              & _ ; 17 - 18:  offsets 432, 444,                 $aConeTintIndInfo[2][3]
        ;   "ptr[6];"                                       & _ ; 19     :  offset  456,                      OpenGL function pointers
        ;   "float[" & 4 * $iTrees * 4 & "]" )                  ; 20     :  offset  480 (504)                 $aTrees
        ; (The number in brackets is x64 offset)

        ; 1: offset 0, Loop
        ; Element 1, index 1, offset 0 : ushort, variable $i
        ; Element 1, index 2, offset 2 : ushort, constant $iTrees
        ; DllStructSetData( $aData0, 1, $iTrees, 2 )

        ; 2 - 6: offsets 8, 20, 32, 44, 56, 5 vectors
        ; Element 2, index 1 - 3, offset  8 : float, variable $vTrans1[3] = [ ?.?, 0.0, ?.? ]
        ; Element 3, index 1 - 3, offset 20 : float, variable $vScale2[3] = [ 1.0, ?.?, 1.0 ]
        ; Element 4, index 1 - 3, offset 32 : float, constant $vTrans2[3] = [ 0.0, 0.5, 0.0 ]
        ; Element 5, index 1 - 3, offset 44 : float, variable $vTrans3[3] = [ 0.0, ?.?, 0.0 ]
        ; Element 6, index 1 - 3, offset 56 : float, variable $vScale3[3] = [ 3.0, ?.?, 3.0 ]

        ; 7 - 10: offsets 80, 144, 208, 272, 4 matrices
        ; Element  7, index 1 - 16, offset  80 : float, constant $mIdenity
        ; For $i = 0 To 15
        ;   DllStructSetData( $aData0, 7, $mIdenity[$i], $i + 1 )
        ; Next
        ; Element  8, index 1 - 16, offset 144 : float, variable $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        ; $mTreeMatrix[0-11] is constant, can use glmTranslate2 in glmMaths.asm to calculate $mTreeMatrix
        ; For $i = 0 To 11
        ;   DllStructSetData( $aData0, 8, $mIdenity[$i], $i + 1 )
        ; Next
        ; Element  9, index 1 - 16, offset 208 : float matrix1
        ; Element 10, index 1 - 16, offset 272 : float matrix2

        ; 11 - 13: offsets 336, 360, 384, Parameters to OpenGL functions
        ; Element 11, index 1,     offset 336 : uint  $aUniformColorTint[0]
        ; Element 11, index 2,     offset 340 : uint  $aMeshCylinderTint[0]
        ; Element 11, index 3,     offset 344 : uint  $aUniformColorTint[4]
        ; Element 11, index 4,     offset 348 : uint  $aUniformColorTint[1]
        ; Element 11, index 5,     offset 352 : uint  $aMeshConeTint[0]
        ; Element 11, index 6,     offset 356 : uint  
        ; Element 12, index 1 - 5, offset 360 : float 0.694, 0.4, 0.106, 1.0, 0.0
        ; Element 13, index 1,     offset 384 : uint  $GL_FALSE
        ; Element 13, index 2,     offset 388 : uint  $GL_UNSIGNED_SHORT

        ; 14 - 16: offsets 392, 404, 416, $aCylinderTintIndInfo[3][3]
        ; $aCylinderTintIndInfo[0][0] ; uint offset 392
        ; $aCylinderTintIndInfo[0][1] ; uint offset 396
        ; $aCylinderTintIndInfo[0][2] ; uint offset 400
        ; $aCylinderTintIndInfo[1][0] ; uint offset 404
        ; $aCylinderTintIndInfo[1][1] ; uint offset 408
        ; $aCylinderTintIndInfo[1][2] ; uint offset 412
        ; $aCylinderTintIndInfo[2][0] ; uint offset 416
        ; $aCylinderTintIndInfo[2][1] ; uint offset 420
        ; $aCylinderTintIndInfo[2][2] ; uint offset 424

        ; 17 - 18: offsets 432, 444, $aConeTintIndInfo[2][3]
        ; $aConeTintIndInfo[0][0] ; uint offset 432
        ; $aConeTintIndInfo[0][1] ; uint offset 436
        ; $aConeTintIndInfo[0][2] ; uint offset 440
        ; $aConeTintIndInfo[1][0] ; uint offset 444
        ; $aConeTintIndInfo[1][1] ; uint offset 448
        ; $aConeTintIndInfo[1][2] ; uint offset 452

        ; 19: offset 456, OpenGL function pointers
        ; glUseProgram       ; ptr offset 456 (456)
        ; glBindVertexArray  ; ptr offset 460 (464)
        ; glUniform4f        ; ptr offset 464 (472)
        ; glUniformMatrix4fv ; ptr offset 468 (480)
        ; glDrawElements     ; ptr offset 472 (488)
        ; (The numbers in brackets are x64 offsets)

        ; 20: offset 480 (504), $aTrees
        ; (The number in brackets is x64 offset)
        ; For $i = 0 To $iTrees - 1
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][0], 4 * $i + 1 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][1], 4 * $i + 2 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][2], 4 * $i + 3 )
        ;   DllStructSetData( $aData0, 20, $aTrees[$i][3], 4 * $i + 4 )
        ; Next

        ; Parameters:
        ; [ebp + 08] : $pData0


        ; Symbolic constants
        TreeMatrix equ                 144                 ; Element  8, index 1 - 16, offset 144 : float TreeMatrix
        matrix1    equ                 208                 ; Element  9, index 1 - 16, offset 208 : float matrix1
        matrix2    equ                 272                 ; Element 10, index 1 - 16, offset 272 : float matrix2


        use32
        push       ebp
        mov        ebp,                esp


        ; --- Initializations ---

        ; ebx is pointer in $aData0 table
        mov        ebx,                [ebp + 08]          ; $aData0 start

        ; Initialize loop variable
        mov        ax,                 word  [ebx + 02]    ; $iTrees
        mov        word  [ebx + 00],   ax                  ; Loop counter $i = $iTrees

        ; eax is pointer in $aTrees table
        mov        eax,                ebx                 ; $aData0 start
        add        eax,                480                 ; $aTrees start


        ; --- Calculations ---

        ; For $i = 0 To $iTrees - 1
        ;   $vTrans1[0] = $aTrees[$i][0]
        ;   $vTrans1[2] = $aTrees[$i][1]
        ;   $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        ;
        ;   Draw trunk
        ;
        ;   Draw treetop
        ; Next

iLoop:  ; For $i = 0 To $iTrees - 1 (uses "For $i = $iTrees To 1 Step -1" )

        ; Vectors
        mov        ecx,                dword [eax + 00]
        mov        dword [ebx + 08],   ecx                 ; $vTrans1[0] = $aTrees[$i][0]
        mov        ecx,                dword [eax + 04]
        mov        dword [ebx + 16],   ecx                 ; $vTrans1[2] = $aTrees[$i][1]

        ; Draw trunk
        mov        ecx,                dword [eax + 08]
        mov        dword [ebx + 24],   ecx                 ; $vScale2[1] = $aTrees[$i][2]

        ; Draw treetop
        mov        dword [ebx + 48],   ecx                 ; $vTrans3[1] = $aTrees[$i][2]
        mov        ecx,                dword [eax + 12]
        mov        dword [ebx + 60],   ecx                 ; $vScale3[1] = $aTrees[$i][3]

        push       eax                                     ; Store eax on stack

        ; $mTreeMatrix = glmTranslate( $mIdenity, $vTrans1 )
        mov        eax,                ebx                 ; $mIdenity        =  ebx +  80
        add        eax,                80                  ; $mIdenity        -> eax
        mov        ecx,                ebx                 ; $mTreeMatrix[12] =  ebx + 192
        add        ecx,                192                 ; $mTreeMatrix[12] -> ecx
        add        ebx,                08                  ; $vTrans1         -> ebx
        call       glmTranslate2


        ; --- Draw trunk ---

        ; $vScale2[1] = $aTrees[$i][2] ; <-- Calculated above
        ; $mTrunkMatrix = glmScale( $mTreeMatrix, $vScale2 )                       ; matrix1 = ...
        ; $mTrunkMatrix = glmTranslate( $mTrunkMatrix, $vTrans2 )                  ; matrix2 = ... matrix1 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshCylinderTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 0.694, 0.4, 0.106, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTrunkMatrix ) ; matrix2
        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        ; glUseProgram(0)

        ; $mTrunkMatrix = glmScale( $mTreeMatrix, $vScale2 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                TreeMatrix          ; TreeMatrix -> eax
        mov        ecx,                ebx
        add        ecx,                matrix1             ; matrix1    -> ecx
        add        ebx,                20                  ; $vScale2   -> ebx
        call       glmScale

        ; $mTrunkMatrix = glmTranslate( $mTrunkMatrix, $vTrans2 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                matrix1             ; matrix1  -> eax
        mov        ecx,                ebx
        add        ecx,                matrix2             ; matrix2  -> ecx
        add        ebx,                32                  ; $vTrans2 -> ebx
        call       glmTranslate1y

        ; glUseProgram( $aUniformColorTint[0] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 336]                       ; $aUniformColorTint[0]
        call       dword [ebx + 456]                       ; glUseProgram

        ; glBindVertexArray( $aMeshCylinderTint[0] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 340]                       ; $aMeshCylinderTint[0]
        call       dword [ebx + 460]                       ; glBindVertexArray

        ; glUniform4f( $aUniformColorTint[4], 0.694, 0.4, 0.106, 1.0 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 372]                       ; 1.0
        push       dword [ebx + 368]                       ; 0.106
        push       dword [ebx + 364]                       ; 0.4
        push       dword [ebx + 360]                       ; 0.694
        push       dword [ebx + 344]                       ; $aUniformColorTint[4]
        call       dword [ebx + 464]                       ; glUniform4f

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTrunkMatrix ) ; matrix2
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                matrix2             ; matrix2 -> eax
        push       eax                                     ; matrix2
        push       dword [ebx + 384]                       ; $GL_FALSE
        push       1                                       ; 1
        push       dword [ebx + 348]                       ; $aUniformColorTint[1]
        call       dword [ebx + 468]                       ; glUniformMatrix4fv

        ; glDrawElements( $aCylinderTintIndInfo[0][0], $aCylinderTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[0][2] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 400]                       ; $aCylinderTintIndInfo[0][2]
        push       dword [ebx + 388]                       ; $GL_UNSIGNED_SHORT
        push       dword [ebx + 396]                       ; $aCylinderTintIndInfo[0][1]
        push       dword [ebx + 392]                       ; $aCylinderTintIndInfo[0][0]
        call       dword [ebx + 472]                       ; glDrawElements

        ; glDrawElements( $aCylinderTintIndInfo[1][0], $aCylinderTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[1][2] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 412]                       ; $aCylinderTintIndInfo[1][2]
        push       dword [ebx + 388]                       ; $GL_UNSIGNED_SHORT
        push       dword [ebx + 408]                       ; $aCylinderTintIndInfo[1][1]
        push       dword [ebx + 404]                       ; $aCylinderTintIndInfo[1][0]
        call       dword [ebx + 472]                       ; glDrawElements

        ; glDrawElements( $aCylinderTintIndInfo[2][0], $aCylinderTintIndInfo[2][1], $GL_UNSIGNED_SHORT, $aCylinderTintIndInfo[2][2] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 424]                       ; $aCylinderTintIndInfo[2][2]
        push       dword [ebx + 388]                       ; $GL_UNSIGNED_SHORT
        push       dword [ebx + 420]                       ; $aCylinderTintIndInfo[2][1]
        push       dword [ebx + 416]                       ; $aCylinderTintIndInfo[2][0]
        call       dword [ebx + 472]                       ; glDrawElements

        ; glUseProgram(0)
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       0                                       ; 0
        call       dword [ebx + 456]                       ; glUseProgram


        ; --- Draw treetop ---

        ; $vTrans3[1] = $aTrees[$i][2] ; <-- Calculated above
        ; $vScale3[1] = $aTrees[$i][3] ; <-- Calculated above
        ; $mTopMatrix = glmTranslate( $mTreeMatrix, $vTrans3 )                   ; matrix1 = ...
        ; $mTopMatrix = glmScale( $mTopMatrix, $vScale3 )                        ; matrix2 = ... matrix1 ...
        ; glUseProgram( $aUniformColorTint[0] )
        ; glBindVertexArray( $aMeshConeTint[0] )
        ; glUniform4f( $aUniformColorTint[4], 0.0, 1.0, 0.0, 1.0 )
        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTopMatrix ) ; matrix2
        ; glDrawElements( $aConeTintIndInfo[0][0], $aConeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[0][2] )
        ; glDrawElements( $aConeTintIndInfo[1][0], $aConeTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[1][2] )
        ; glUseProgram(0)

        ; $mTopMatrix = glmTranslate( $mTreeMatrix, $vTrans3 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                TreeMatrix          ; TreeMatrix -> eax
        mov        ecx,                ebx
        add        ecx,                matrix1             ; matrix1    -> ecx
        add        ebx,                44                  ; $vTrans3   -> ebx
        call       glmTranslate1y

        ; $mTopMatrix = glmScale( $mTopMatrix, $vScale3 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                matrix1             ; matrix1  -> eax
        mov        ecx,                ebx
        add        ecx,                matrix2             ; matrix2  -> ecx
        add        ebx,                56                  ; $vScale3 -> ebx
        call       glmScale

        ; glUseProgram( $aUniformColorTint[0] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 336]                       ; $aUniformColorTint[0]
        call       dword [ebx + 456]                       ; glUseProgram

        ; glBindVertexArray( $aMeshConeTint[0] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 352]                       ; $aMeshConeTint[0]
        call       dword [ebx + 460]                       ; glBindVertexArray

        ; glUniform4f( $aUniformColorTint[4], 0.0, 1.0, 0.0, 1.0 )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 372]                       ; 1.0
        push       dword [ebx + 376]                       ; 0.0
        push       dword [ebx + 372]                       ; 1.0
        push       dword [ebx + 376]                       ; 0.0
        push       dword [ebx + 344]                       ; $aUniformColorTint[4]
        call       dword [ebx + 464]                       ; glUniform4f

        ; glUniformMatrix4fv( $aUniformColorTint[1], 1, $GL_FALSE, $mTopMatrix ) ; matrix2
        mov        ebx,                [ebp + 08]          ; $aData0 start
        mov        eax,                ebx
        add        eax,                matrix2             ; matrix2 -> eax
        push       eax                                     ; matrix2
        push       dword [ebx + 384]                       ; $GL_FALSE
        push       1                                       ; 1
        push       dword [ebx + 348]                       ; $aUniformColorTint[1]
        call       dword [ebx + 468]                       ; glUniformMatrix4fv

        ; glDrawElements( $aConeTintIndInfo[0][0], $aConeTintIndInfo[0][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[0][2] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 440]                       ; $aConeTintIndInfo[0][2]
        push       dword [ebx + 388]                       ; $GL_UNSIGNED_SHORT
        push       dword [ebx + 436]                       ; $aConeTintIndInfo[0][1]
        push       dword [ebx + 432]                       ; $aConeTintIndInfo[0][0]
        call       dword [ebx + 472]                       ; glDrawElements

        ; glDrawElements( $aConeTintIndInfo[1][0], $aConeTintIndInfo[1][1], $GL_UNSIGNED_SHORT, $aConeTintIndInfo[1][2] )
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       dword [ebx + 452]                       ; $aConeTintIndInfo[1][2]
        push       dword [ebx + 388]                       ; $GL_UNSIGNED_SHORT
        push       dword [ebx + 448]                       ; $aConeTintIndInfo[1][1]
        push       dword [ebx + 444]                       ; $aConeTintIndInfo[1][0]
        call       dword [ebx + 472]                       ; glDrawElements

        ; glUseProgram(0)
        mov        ebx,                [ebp + 08]          ; $aData0 start
        push       0                                       ; 0
        call       dword [ebx + 456]                       ; glUseProgram


iNext:  ; For $i = 0 To $iTrees - 1 (uses "For $i = $iTrees To 1 Step -1" )

        pop        eax                                     ; Restore eax from stack
        add        eax,                16                  ; Next row in $aTrees

        dec        word  [ebx + 00]                        ; $i -= 1
        jnz        iLoop                                   ; Jump to next loop


        pop        ebp
        ret        4


        ; Include files
        include    "utilities\fasm\glmMaths.asm"           ; Include GLM functions
