#include-once

If not IsDeclared( "vCamTarget" ) Then Global $vCamTarget[3]
If not IsDeclared( "vSphereCamRelPos" ) Then Global $vSphereCamRelPos[3]

Global $axisX[3] = [ 1, 0, 0 ], $axisY[3] = [ 0, 1, 0 ], $axisZ[3] = [ 0, 0, 1 ]

Func CalcFrustumScale( $fFovDeg )
	Return Cotangent( Radians( $fFovDeg / 2 ) )
EndFunc

Func CalcLerpFactor( $fElapsedTime, $fLoopDuration )
	Local $Value = Mod( $fElapsedTime, $fLoopDuration ) / $fLoopDuration
	If $Value > 0.5 Then $Value = 1.0 - $Value
	Return $Value * 2
EndFunc

Func ComputeAngleRad( $fElapsedTime, $fLoopDuration )
	Local $fScale = $PI * 2 / $fLoopDuration
	Local $fCurrTimeThroughLoop = Mod( $fElapsedTime, $fLoopDuration )
	Return $fCurrTimeThroughLoop * $fScale
EndFunc

Func ResolveCamPosition()

	Local $phi = Radians( $vSphereCamRelPos[0] )
	Local $theta = Radians( $vSphereCamRelPos[1] + 90.0 ) 

	Local $fSinTheta = Sin( $theta )
	Local $fCosTheta = Cos( $theta )
	Local $fCosPhi = Cos( $phi )
	Local $fSinPhi = Sin( $phi )

	Local $vDirToCamera[3] = [ _
		$fSinTheta * $fCosPhi * $vSphereCamRelPos[2] + $vCamTarget[0], _
		$fCosTheta * $vSphereCamRelPos[2] + $vCamTarget[1], _
		$fSinTheta * $fSinPhi * $vSphereCamRelPos[2] + $vCamTarget[2] ]

	Return $vDirToCamera

EndFunc
